2001-12-31  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (mark_reg_gr_used_mask): Mind HARD_REGNO_NREGS.

2001-12-31  Richard Henderson  <rth@redhat.com>

	* regrename.c (build_def_use): Don't rename asm operands that
	were originally hard registers.
	(copyprop_hardreg_forward_1): Likewise.
	(find_oldest_value_reg): Copy ORIGINAL_REGNO from source.
	* varasm.c (make_decl_rtl): Use gen_rtx_raw_REG.  Set ORIGINAL_REGNO.

2001-12-31  Douglas B Rupp  <rupp@gnat.com>

	* config/alpha/vms.h (HAS_INIT_SECTION, NEED_ATEXIT): Remove.
	(NAME__MAIN, SYMBOL__MAIN): Define.

2001-12-31  Richard Henderson  <rth@redhat.com>

	* cfgrtl.c (delete_insn): Check for not NOTE_INSN_DELETED_LABEL
	before decrementing LABEL_NUSES from a jump table.

	* final.c (alter_subreg): Assign REGNO after changing the rtx code.

	* config/alpha/alpha.c (reg_no_subreg_operand): Reject all
	non-registers.

2001-12-31  Graham Stott  <grahams@redhat.com>

	* halfpic.h: Remove foward defs of tree_node and rtx_def.

        * toplev.h: Remove forward def of tree_node, rtx_def.

	* except.h: Remove forward def of tree_node, rtx_def and
	define of tree, rtx. Also remove undefs.

	* basic-block.h: Remove forward def of tree_node and
	define of tree.

2001-12-30  Richard Henderson  <rth@redhat.com>

	* cfglayout.c (scope_def, scope_forest_info, forest,
	relate_bbs_with_scopes, make_new_scope, build_scope_forest,
	remove_scope_notes, insert_intra_before_1, insert_intra_1,
	insert_intra_bb_scope_notes, insert_inter_bb_scope_notes,
	rebuild_scope_notes, free_scope_forest_1, dump_scope_forest,
	dump_scope_forest_1, get_next_bb_note, get_prev_bb_note): Remove.
	(fixup_reorder_chain): Don't set scope for bb.
	(insn_scopes, scope_to_insns_initialize, set_block_levels,
	change_scope, scope_to_insns_finalize): New.
	(cfg_layout_initialize, cfg_layout_finalize): Update to match.
	* cfglayout.h (scope_def, scope): Remove.
	(reorder_block_def): Remove scope member.
	(scope_to_insns_initialize, scope_to_insns_finalize): Declare.
	* haifa-sched.c: Revert reemit_other_notes change.
	* sched-ebb.c (schedule_ebbs): Don't call remove_unnecessary_notes.
	Use scope_to_insns_initialize and scope_to_insns_finalize.
	* sched-rgn.c (schedule_insns): Likewise.

2001-12-31  Graham Stott  <grahams@redhat.com>

	* c-lex.c: Include tree.h before expr.h

	* c-typeck.c: Include rtl.h earlier.

	* tree.h (STRIP_NOPS): Remove extraneous semicolon.
	(STRIP_SIGN_NOPS): Likewise.
	(STRIP_TYPE_NOPS): Likewise.
	(COMPLETE_OR_UNBOUND_ARRAY_TYPE_P): Add Parenthesis around
	macro paramater.

	* final.c (struct bb_list): Delete.
	(struct bb_str): Likewise.

	* cfgloop.c (flow_loop_entry_edges_find): Fix typo.
        (flow_loop_exit_edges_find): Likewise.

	* gcse.c (gcse_main): Fix typos.
	(alloc_gcse_mem): Likewise.

	* function.h: Remove undefs for rtx and tree.

2001-12-30  Richard Henderson  <rth@redhat.com>

	* loop.c (check_dbra_loop): Fix last change: examine both
	has_multiple_exit_targets and exit_count.

2001-12-30  Richard Henderson  <rth@redhat.com>

	* integrate.c (copy_rtx_and_substitute): Fix error last change:
	we need to unconditionally create a new mem.

2001-12-30  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/mmix/mmix.md ("*call_real"): Fix typo in comment.
	* config/mmix/mmix.h (EXTRA_CONSTRAINT): Pass MMIX_REG_OK_STRICT
	to mmix_extra_constraint.
	* config/mmix/mmix.c (mmix_secondary_reload_class): Only handle
	non-global register classes.  Mark now unused parameters as such.
	(mmix_extra_constraint, 'U'): Use new parameter strict and call
	calling memory_operand_p or strict_memory_address_p, not
	address_operand.
	* config/mmix/mmix-protos.h (mmix_extra_constraint): Add parameter.

2001-12-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* unroll.c: Move include files above first use of `const'.

2001-12-30  Jakub Jelinek  <jakub@redhat.com>

	* cfgrtl.c (try_redirect_by_replacing_jump): Allow redirect_jump
	to fail if target is EXIT_BLOCK_PTR, die otherwise.
	(redirect_edge_and_branch): Likewise.
	* cfgcleanup.c (try_forward_edge): Don't force jump redirecting
	if target is EXIT_BLOCK_PTR.

2001-12-29  David Edelsohn  <edelsohn@gnu.org>

	* gcc.c (init_gcc_spec): Do not link with static libgcc.a if
	gcc invoked with -shared.

2001-12-29  Graham Stott  <grahams@redhat.com>

        * config/i386/i386.c (ix86_asm_dialect): Fix enum type.

        (override_options): Delete abs macro unused.

        (output_pic_addr_const): Use ASM_ATT/ASM_INTEL enumerations
        when testing ASSEMBLER_DIALECT.

        (print_reg): Likewise.
        (print_operand): Likewise.
        (print_operand_address): Likewise.
        (print_operand): abort if ASSEMBLER_DIALECT is unknown dialect.

        * config/i386/i386.h (ix86_asm_dialect): Fix enum type.

        (FIND_BASE_TERM): Fix typo.

Sat Dec 29 15:48:54 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (store_field): Use adjust_address, not PUT_MODE.
	(expand_expr, case VIEW_CONVERT_EXPR): Likewise.
	* reload1.c (eliminate_regs, case SUBREG): Likewise, but use
	adjust_address_nv.
	* varasm.c (make_decl_rtl): Likewise.
	* integrate.c (copy_rtx_and_substitute, case MEM): Likewise, but use
	replace_equiv_address_nv.

	* varasm.c (decode_addr_const, case INTEGER_CST): Call
	output_constant_def instead of looking at TREE_CST_RTL.

	* expr.c (convert_move): If -fforce-mem, force FROM to not be memory.

	* stor-layout.c (layout_decl): Don't misalign field of variable size
	for packed record.

	* dwarf2out.c (compute_section_prefix): Avoid cast warning.
	(gen_decl_die): Only check DECL_IGNORED_P on decls.
	(dwarf2out_decl): Check for DECL_IGNORED_P only when needed.

2001-12-29  Jakub Jelinek  <jakub@redhat.com>

	* cfglayout.c (insert_intra_before_1): New.
	(insert_inter_bb_scope_notes): Emit sibling block notes which don't
	span multiple basic blocks.

2001-12-29  Richard Henderson  <rth@redhat.com>

	* loop.c (prescan_loop): Set has_multiple_exit_targets for exception
	edges.  Rearrange jump interpretation code to use pc_set.
	(check_dbra_loop): Examine has_multiple_exit_targets not exit_count.

	* sched-deps.c (sched_analyze_insn): Set scheduling barrier for
	all insns that can throw, not just if flag_non_call_exceptions.

2001-12-29  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (STRING_OBJECT_CLASS_NAME): Remove.
	(default_constant_string_class_name): New global.
	(objc_init): Set it.
	(synth_module_prologue): Use it.

	* objc/objc-act.c: Apply various cosmetic and formatting changes.

2001-12-29  Kazu Hirata  <kazu@hxi.com>

	* config/rs6000/darwin-tramp.asm: Fix comment formatting.
	* config/rs6000/freebsd.h: Likewise.
	* config/rs6000/rs6000.c: Likewise.
	* config/sh/sh.c: Likewise.
	* config/sh/sh.h: Likewise.

2001-12-28  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (build_module_descriptor): Make sure the init
	function is not deferred.
	(build_dispatch_table_initializer): Compute the method encoding if
	not already done.

2001-12-28  Kazu Hirata  <kazu@hxi.com>

	* doc/md.texi: Add @findex define_insn_and_split.

2001-12-28  Hans Bohem  <hans_boehm@hp.com>

	* config/ia64/linux.h (MD_FALLBACK_FRAME_STATE_FOR): New.
	* config/ia64/unwind-ia64.c (uw_init_context_1): Redo sp, psp,
	bsp setup.  Set pri_unat_loc to something reasonable.
	(uw_install_context): Add missing cast.
	(unw_access_gr): Fix off-by-1 indexing error.

2001-12-28  Kazu Hirata  <kazu@hxi.com>

	* except.c: Fix comment formatting.
	* flags.h: Likewise.
	* flow.c: Likewise.
	* predict.c: Likewise.
	* simplify-rtx.c: Likewise.
	* system.h: Likewise.
	* vmsdbg.h: Likewise.
	* vmsdbgout.c: Likewise.

2001-12-28  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md: Fix formatting.

2001-12-28  Geoff Keating  <geoffk@redhat.com>

	* varasm.c (record_constant_1): Correct parameter to recursive
	call in default case.

2001-12-28  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.h (ASM_PREFERRED_EH_DATA_FORMAT,
	ASM_OUTPUT_DWARF_PCREL): Define.
	* config/sparc/sol2.h (ASM_PREFERRED_EH_DATA_FORMAT): Define.
	* configure.in (HAVE_AS_SPARC_UA_PCREL): Check whether as supports
	.uaword %r_disp32() and linker handles it correctly.
	* configure, config.in: Rebuilt.

2001-12-28  Jakub Jelinek  <jakub@redhat.com>

	* c-typeck.c (store_init_value): If initializing object with array
	type of unknown size by a compound literal, set object's size from
	compound literal size.
	* doc/extend.texi (Compound Literals): Adjust documentation.

2001-12-28  Richard Henderson  <rth@redhat.com>

	* real.c (etoe113, toe113): Ifndef INTEL_EXTENDED_IEEE_FORMAT.
	(endian): Clear word 3 for INTEL_EXTENDED_IEEE_FORMAT.
	(etartdouble): Invoke etoe64 for INTEL_EXTENDED_IEEE_FORMAT.
	* real.h (REAL_VALUE_TO_TARGET_LONG_DOUBLE): Don't special case
	INTEL_EXTENDED_IEEE_FORMAT.

2001-12-27  Geoff Keating  <geoffk@redhat.com>

	* combine.c (try_combine): Mask off sign bits when combining
	stores to the low and high parts of a two-word value.

	* expr.c (expand_expr): Don't mark memory for non-constants as
	constant.

Thu Dec 27 20:39:55 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* integrate.c (copy_rtx_and_substitute, case MEM): If inlining
	and not for LHS, clear RTX_UNCHANGING_P.

2001-12-28  Philipp Thomas  <pthomas@suse.de>

	* cppfiles.c (stack_include_file): Don't translate <stdin>.

2001-12-27  Roger Sayle <roger@eyesopen.com>

	* builtins.c (expand_builtin_memcmp): Optimize memcmp built-in
	when all arguments are known constant.  Fixes PR opt/3508.

2001-12-27  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md (two anonymous patterns): Remove.

2001-12-27  Richard Henderson  <rth@redhat.com>

	* haifa-sched.c (reemit_other_notes): New.
	(schedule_block): Use it.
	* sched-ebb.c (schedule_ebbs): Call remove_unnecessary_notes.
	* sched-rgn.c (schedule_insns): Likewise.
	* cfglayout.c (remove_scope_notes): Handle removing note at
	the end of the insn chain.
	* function.c (debug_find_var_in_block_tree): New.

2001-12-27  Alan Modra  <amodra@bigpond.net.au>
	    David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/linux64.h (ASM_DECLARE_FUNCTION_NAME): Simplify.

2001-12-27  Jakub Jelinek  <jakub@redhat.com>

	* toplev.c (independent_decode_option): Re-add -aux-info option
	handling.

Thu Dec 27 09:50:44 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* integrate.c (copy_insn_notes): Don't adjust REG_EH_REGION note
	if special value.

2001-12-26  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* collect2.c (is_ctor_dtor): Const-ify.
	* m88k-protos.h (output_file_start): Likewise.
	* m88k.c (m88k_lang_independent_options, output_options,
	output_file_start): Likewise.
	* fix-header.c (files_to_ignore, std_include_entry, include_entry,
	std_include_table, main): Likewise.
	* protoize.c (longopts): Likewise.
	* regclass.c (int_reg_class_contents): Likewise.
	* toplev.c (dump_file, f_options, W_options): Make static.
	(lang_independent_options, f_options, W_options): Const-ify.
	* tree-dump.c (dump_file_info): Likewise.
	* unroll.c (_factor): Make static.

Wed Dec 26 17:55:50 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/alpha/alpha.c (alpha_align_insns): Remove warning.

	* config/sparc/sparc.md (call struct patterns): Show starting
	at two words long.

2001-12-26  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.h (ASM_CPU_SPEC, CPP_CPU_SPEC): Add mcpu=405.
	* sysv4.h (CPP_SYSV_SPEC, CPP_OS_VXWORKS_SPEC): Add mcpu=405.

2001-12-26  DJ Delorie  <dj@redhat.com>

	* function.c (expand_main_function): Make sure stack adjustments
	happen before sjlj exception setup.

2001-12-26  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (indirect_jump): Prefer CTR over LR.
	* xcoff.h (ASM_DECLARE_FUNCTION_NAME): Handle weak function.

Tue Dec 25 12:04:47 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* dwarf2out.c: Reformatting and minor code rearrangement.

2001-12-24  Douglas B. Rupp (rupp@gnat.com)

	* configure.in (quoted_stage_prefix_set_by_configure): Generate.
	* configure: Regenerated.
	* Makefile.in (SUBDIR_FLAGS_TO_PASS): Use
	quoted_stage_prefix_set_by_configure.

Mon Dec 24 10:24:59 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* rtl.h (in_expr_list_p): New declaration.
	* rtlanal.c (in_expr_list_p): New function.
	* cfgcleanup.c: Reformatting and minor code rearrangement.
	* cfglayout.c, cfgloop.c, cfgrtl.c: Likewise.

2001-12-23  Richard Henderson  <rth@redhat.com>

	PR c/5163:
	* c-decl.c (duplicate_decls): As needed, set DECL_INLINE when
	we have a function body associated.  Minor cleanups.
	(grokdeclarator): Do not set DECL_INLINE without a function body.

2001-12-23  Richard Henderson  <rth@redhat.com>

	* stmt.c (resolve_operand_names): Handle operand modifiers.

2001-12-23  Richard Henderson  <rth@redhat.com>

	* stmt.c (parse_input_constraint): Break out from ...
	(expand_asm_operands): ... here.  Loop over the operands twice,
	the first time only calling mark_addressable.  Correct and simplify
	the conditions for spilling an output operand to memory.

2001-12-23  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (call_operand) [OSF]: Disallow virtual regs.

	* config/alpha/alpha.md (UNSPEC_SIBCALL): New.
	(sibcall, sibcall_value, sibcall_osf_1_er, sibcall_osf_1): Use it.
	(sibcall_value_osf_1_er, sibcall_value_osf_1): Likewise.

2001-12-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c (c_start_case): Don't strip conversions from the
	controlling expression.  Partially fixes PR c/2454.

2001-12-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* Makefile.in (USER_H): Remove proto.h.
	* config.gcc (c*-convex-*): Set extra_headers=proto.h.

2001-12-23  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* arc.c (arc_hard_regno_mode_ok): Const-ify.
	* arc.h (arc_hard_regno_mode_ok): Likewise.
	* i386.c (x86_64_reg_class_name): Make static.
	* m68k.c (regno_reg_class): Const-ify.
	* m68k.h (regno_reg_class): Likewise.
	* mcore.c (reg_class_from_letter): Likewise.
	* mcore.h (reg_class_from_letter): Likewise.
	* sh.c (reg_class_from_letter, ashiftrt_insns, shift_insns,
	ext_shift_insns, ext_shift_amounts): Likewise.
	* sh.h (reg_class_from_letter): Likewise.
	* sparc.c (hard_regno_mode_classes, hard_32bit_mode_classes,
	hard_64bit_mode_classes): Likewise.
	* sparc.h (hard_regno_mode_classes): Likewise.

	* gcc.c (modify_target): Make static.
	* gengenrtl.c (defs, formats): Likewise.
	* reload1.c (elim_table_1, init_elim_table): Const-ify.
	* tradcpp.c (directive, directive_table, handle_directive,
	skip_if_group, run_directive): Likewise.

2001-12-23  Richard Henderson  <rth@redhat.com>

	* calls.c (expand_call): Don't turn off ECF_LIBCALL_BLOCK for
	an invalid result register; do end the sequence properly.
	(emit_library_call_value_1): Likewise.

2001-12-22  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (rs6000_builtins): Add vsldoi variants.

	* config/rs6000/rs6000.md ("altivec_vsldoi_*"): Same.

	* config/rs6000/rs6000.c: Clean up some spacing and indentation.
	(altivec_init_builtins): Add tree types for builtins with 4 bit
	literals.
	(bdesc_3arg): Add vsldoi variants.

2001-12-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* 1750a.h (datalbl, jmplbl): Declare array size explicitly.
	* a29k.h (a29k_debug_reg_map): Likewise.
	* arc.h (arc_regno_reg_class): Likewise.
	* c4x-protos.h (c4x_regclass_map, c4x_caller_save_map): Likewise.
	* convex.h (regno_reg_class, reg_class_from_letter): Likewise.
	* d30v.h (regno_reg_class, reg_class_from_letter): Likewise.
	* i386.h (regclass_map): Likewise.
	* m32r.h (m32r_hard_regno_mode_ok, m32r_punct_chars): Likewise.
	* mcore.h (regno_reg_class): Likewise.
	* mips.h (mips_print_operand_punct, mips_char_to_class):
	Likewise.
	* ns32k.h (regclass_map): Likewise.
	* pj.h (pj_debugreg_renumber_vec): Likewise.
	* s390.h (regclass_map): Likewise.
	* sh.h (regno_reg_class): Likewise.
	* sparc.h (sparc_regno_reg_class): Likewise.

	* hard-reg-set.h (reg_class_contents): Likewise.
	* machmode.h (class_narrowest_mode): Likewise.

2001-12-22  David Edelsohn  <edelsohn@gnu.org>

	* loop.c (scan_loop, move_movables, count_one_set): Do not
	overlook hard registers when computing statistics.

Sun Dec 23 00:49:37 CET 2001  Jan Hubicka  <jh@suse.cz>

	* calls.c (ECF_LIBCALL_BLOCK): New constant.
	(emit_call_1, initialize_argument_information,
	precompute_arguments, expand_call,
	emit_library_call_value_1): Use ECF_LIBCALL_BLOCK
	instead of ECF_PURE | ECF_CONST. Honnor LCT_CONST/LCT_PURE.

2001-12-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* config.gcc (extra_headers): Move settings to math-68881.h and
	ppc-asm.h to common code for CPU types.  Use math-68881.h on all
	m68k targets.
	(header_files): Remove unused setting.

2001-12-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* elxsi.c: Include "hard-reg-set.h" and/or don't declare
	`call_used_regs' explicitly.
	* i860.c: Likewise.
	* m68k.c: Likewise.
	* ns32k.c: Likewise.
	* pa.c: Likewise.
	* vax.c: Likewise.
	* we32k.c: Likewise.

Fri Dec 21 23:30:14 CET 2001  Jan Hubicka  <jh@suse.cz>

	* i386.h (TARGET_CPU_DEFAULT_pentium_mmx): New.
	(TARGET_CPU_DEFAULT_*): Renumber.

Sat Dec 22 12:20:20 EST 2001  John Wehle  (john@feith.com)

	* rtl.h (subreg_lsb): Declare.
	* rtlanal.c (subreg_lsb): Implement.

Sat Dec 22 08:59:50 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* predict.c: Reformatting and minor cleanups.
	* cfg.c, cfganal.c, cfgbuild.c: Likewise.

	* expr.c (expand_expr, case ADDR_EXPR): Handling taking address of
	SAVE_EXPR.
	* function.c (gen_mem_addressof): Add missing tests for SAVE_EXPR.
	(put_addressof_into_stack): Clarify code in setting of used_p.

	* calls.c (flags_from_decl_or_type): Move ECF_SP_DEPRESSED here.
	(expand_call): Delete from here.
	Do pending stack adjustments if ECF_SP_DEPRESSED.

	* dwarf2out.c (save_rtx): Deleted.
	(mem_loc_descriptor): Do equivalent operation.
	(add_const_value_attribute, case CONST): Likewise.
	(add_name_and_src_coords_attributes): Likewise.

2001-12-21  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.h: Fix comment formatting.

Fri Dec 21 17:30:15 2001  Jeffrey A Law  (law@redhat.com)

	* pa.h (CPP_SPEC): If not in ANSI mode, define _INCLUDE_LONGLONG.
	(CPLUSPLUS_CPP_SPEC): Define _INCLUDE_LONGLONG.

2001-12-21  Robert Lipe  <robertlipe@usa.net>

	 * system.h (PREFETCH): Explictly undefine.

2001-12-21  Richard Henderson  <rth@redhat.com>

	* c-parse.in (SAVE_WARN_FLAGS): Save warn_traditional.
	(RESTORE_WARN_FLAGS): Restore it.
	(extension): Zero warn_traditional.

2001-12-21  Kazu Hirata  <kazu@hxi.com>

	* doc/passes.texi: Fix a typo.

2001-12-21  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.h: Fix a comment typo.

2001-12-21  Jakub Jelinek  <jakub@redhat.com>

	* combine.c (nonzero_bits): If using reg_nonzero_bits,
	we don't know anything about bits outside of X mode.
	(num_sign_bit_copies): Likewise.

2001-12-21  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.md (prefetch): Use 'a' operand code.

2001-12-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4 (gcc_AC_PROG_GNAT): Run prospective ada drivers in
	subshells.
	* configure.in: Likewise for perl Pod::Man.

	* configure: Regenerated.

2001-12-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtin-attrs.def (__builtin_printf_unlocked,
	__builtin_fprintf_unlocked, printf_unlocked, fprintf_unlocked):
	Mark with the __printf__ attribute.

	* builtins.c (expand_builtin_fputs): Add an `unlocked' parameter
	and set the replacement function depending on it.
	(expand_builtin): Skip BUILT_IN_*_UNLOCKED when not optimizing.
	Handle BUILT_IN_*_UNLOCKED when optimizing.

	* builtins.def (DEF_EXT_FALLBACK_BUILTIN,
	DEF_EXT_FRONT_END_LIB_BUILTIN): New macros.
	Declare the "unlocked" stdio functions.

	* c-common.c (c_expand_builtin_printf, c_expand_builtin_fprintf):
	Add an `unlocked' parameter and set the replacement function
	depending on it.
	(c_expand_builtin): Handle BUILT_IN_PRINTF_UNLOCKED and
	BUILT_IN_FPRINTF_UNLOCKED.

	* doc/extend.texi (printf_unlocked, fprintf_unlocked,
	fputs_unlocked): Document.

2001-12-20  Josef Zlomek  <zlomek@matfyz.cz>

	* cfgloop.c (flow_loops_find): Use the information of the depth
	first search order of the CFG correctly when finding natural loops.

2001-12-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (prologue_mcount): Update for explicit relocs.

2001-12-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (call_operand) [OSF]: Accept pseudos.
	* config/alpha/alpha.md (call_osf, call_value_osf): Don't force
	operand into $27.

2001-12-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* configure.in (all_headers, all_lib2funcs): Remove.
	* configure: Regenerate.
	* Makefile.in (LANG_EXTRA_HEADERS): Remove.
	(USER_H): Don't include $(LANG_EXTRA_HEADERS).
	* config/alpha/t-interix (USER_H): Don't include
	$(LANG_EXTRA_HEADERS).
	* config/i386/t-interix: Likewise.
	* config/t-openbsd: Likewise.

2001-12-20  Andreas Jaeger  <aj@suse.de>

	* libgcc2.c (__bb_exit_func): Remove unused variable.
	(num_digits): Remove unused function.

2001-12-20 Alan Shieh <ashieh@hkn.eecs.berkeley.edu>

	* config/arm/arm.c (arm_output_epilogue): Changed IP restore
	to use ldmfd instead of ldmea.
	* config/arm/arm.c (arm_compute_initial_elimination_offset):
	Modified to reflect behavior of arm_expand_prologue when generating
	interrupt handlers

2001-12-20  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (arm_compute_save_reg0_reg12_mask):  New
	function. Compute which of registers r0 through r12 should be
	saved onto the stack during a function's prologue.
	(arm_compute_save_reg_mask): Use
	arm_compute_save_reg0_reg12_mask.
	(arm_compute_initial_elimination_offset): Use
	arm_compute_save_reg0_reg12_mask.

	(arm_expand_prologue): Do not mark as save of the IP register
	for an interrupt handler as being part of the frame creation
	code.

2001-12-20  Richard Henderson  <rth@redhat.com>

	* varasm.c (assemble_real): Use REAL_VALUE_TO_x and assemble_integer
	to emit floating point values.
	(assemble_real_1): Remove.

	* 1750a/1750a.c (real_value_to_target_single): New.
	(real_value_to_target_double): New.
	* 1750a/1750a.h (TARGET_FLOAT_FORMAT): New.
	(REAL_VALUE_TO_TARGET_SINGLE): New.
	(REAL_VALUE_TO_TARGET_DOUBLE): New.
	* 1750a/1750a-protos.h: Update.

	* 1750a/1750a.h, a29k/a29k.h, alpha/alpha.h, alpha/unicosmk.h,
	alpha/vms.h, arc/arc.h, arm/aof.h, arm/aout.h, avr/avr.c,
	avr/avr.h, c4x/c4x.h, clipper/clix.h, convex/convex.h, cris/cris.h,
	d30v/d30v.h, dsp16xx/dsp16xx.c, dsp16xx/dsp16xx.h, elxsi/elxsi.h,
	fr30/fr30.h, h8300/h8300.h, i370/i370.h, i386/i386.h, i386/i386elf.h,
	i386/next.h, i386/ptx4-i.h, i386/sysv4.h, i860/fx2800.h, i860/i860.h,
	i860/paragon.h, i860/sysv4.h, i960/i960-protos.h, i960/i960.c,
	i960/i960.h, ia64/ia64.h, m32r/m32r.h, m68hc11/m68hc11.c,
	m68hc11/m68hc11.h, m68k/3b1.h, m68k/altos3068.h, m68k/crds.h,
	m68k/dpx2.h, m68k/hp320.h, m68k/m68k.h, m68k/mot3300.h, m68k/news.h,
	m68k/next.h, m68k/next21.h, m68k/sgs.h, m68k/sun2o4.h, m68k/sun3.h,
	m68k/tower-as.h, m88k/m88k.h, mcore/mcore.h, mips/mips-protos.h,
	mips/mips.c, mips/mips.h, mmix/mmix-protos.h, mmix/mmix.c,
	mmix/mmix.h, mn10200/mn10200.h, mn10300/mn10300.h, ns32k/encore.h,
	ns32k/ns32k.h, pa/long_double.h, pa/pa.h, pdp11/pdp11.h, pj/pj.h,
	romp/romp.c, romp/romp.h, rs6000/rs6000.h, s390/linux.h, sh/sh.h,
	sparc/sparc.h, stormy16/stormy16.h, v850/v850.h, vax/vax.h,
	vax/vaxv.h, we32k/we32k.h, doc/tm.texi: Remove ASM_OUTPUT_FLOAT,
	ASM_OUTPUT_DOUBLE, ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_BYTE_FLOAT,
	ASM_OUTPUT_SHORT_FLOAT, ASM_OUTPUT_THREE_QUARTER_FLOAT, and all
	associated support routines.

Thu Dec 20 16:58:46 CET 2001  Jan Hubicka  <jh@suse.cz>

	* cfgcleanup.c (flow_find_cross_jump): Avoid incrementing of ninsns
	if one of block does not contain jump.
	(outgoing_edge_math): Revert last path; require edges to be noncomplex
	nonfake to match single exit edge; require conditional jumps to not
	have side effect.

2001-12-20  Turly O'Connor  <turly@apple.com>

	* tm.texi (ASM_OUTPUT_OPERAND): Change documentation references to
	"recog_operand" to "recog_data.operand".
	* rtl.def: Likewise.

2001-12-20  Jakub Jelinek  <jakub@redhat.com>

	* simplify-rtx.c (simplifi_binary_operation) [DIV]: If DIV has
	narrower mode than op0, only return the bits in DIV's mode.

2001-12-20  Jakub Jelinek  <jakub@redhat.com>

	* combine.c (distribute_notes): Avoid adding REG_LABEL notes
	to JUMP_INSNs with JUMP_LABEL.

2001-12-19  Aldy Hernandez  <aldyh@redhat.com>

	* doc/install.texi: Add documentation for --enable-altivec.

	* config.gcc: Add support for --enable-altivec.

	* config/rs6000/altivec.h: New.

	* config/rs6000/linuxaltivec.h (SUBSUBTARGET_OVERRIDE_OPTIONS):
	Define.  Fix typo.

	* config/rs6000/rs6000.c (vrsave_operation): Change unspec to
	unspec_volatile.
	(generate_set_vrsave): Generate the unspec here instead of calling
	an .md pattern.
	(generate_set_vrsave): Use gen_rtvec.
	(rs6000_emit_prologue): Replace call to gen_get_vrsave with
	gen_rtx_SET.

	* config/rs6000/rs6000.md ("*movsi_internal1"): Add constraints
	for setting special registers.
	("*set_vrsave_internal"): Use unspec_volatile.
	("set_vrsave"): Remove.
	("get_vrsave"): Remove.

	* config/rs6000/rs6000.h (REG_CLASS_CONTENTS): Add vrsave to
	SPECIAL_REGS.

2001-12-19  Bruce Korb  <bkorb@gnu.org>

	* gcc/fixinc/inclhack.def:  Remove all the fix suppression "fixes".
	(strict_ansi_not_ctd):  accommodate __STDC__ == 0 tests in UW 2.1.2
	* gcc/fixinc/mkfixinc.sh(i?86-*-sysv4.2uw2*): now uses fixincl program
	* gcc/fixinc/base/...: adjust for changes in fixes

2001-12-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* po/gcc.pot: Regenerate.

	* configure.in (all_diff_excludes, diff_excludes): Remove.
	* configure: Regenerate.
	* Makefile.in (LANG_DIFF_EXCLUDES): Remove.
	* objc/config-lang.in (diff_excludes): Remove.

2001-12-19  Dan Nicolaescu  <dann@ics.uci.edu>

	* config/sparc/sparc.md (ldd peephole2s): For load peepholes pass
	the destination register as a parameter to mems_ok_for_ldd_peep.
	For store peepholes pass NULL_RTX.  Move all volatile checks ...
	* config/sparc/sparc.c (mems_ok_for_ldd_peep): ... here.  Add a
	register parameter, check it's not the same as base for an address.
	* config/sparc/sparc-protos.h (mems_ok_for_ldd_peep): Update.

2001-12-19  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/ia64.c (ia64_single_set): Return first set for
	prologue_allocate_stack and epilogue_deallocate_stack instructions.

2001-12-19  Dale Johannesen  <dalej@apple.com>

	 * config/rs6000/rs6000.h: LEGITIMIZE_RELOAD_ADDRESS:
	 redefine in terms of rs6000_legitimize_reload_address().
	 * config/rs6000/rs6000-protos.h: Add this function.
	 * config/rs6000/rs6000.c: Add this function.  Includes
	 handling for Darwin FP constants.

Wed Dec 19 11:01:21 2001  Jeffrey A Law  (law@redhat.com)

	* config/pa/t-hpux-shlib: New file.
	* config.gcc (hpux10, hpux11): Include t-hpux-shlib in tmake_file
	for 32bit hpux10 & hpux11 configurations.

2001-12-19  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/xscale-elf.h (SUBTARGET_EXTRA_ASM_SPEC): Pass
	-mno-fpu onto gas unless -mhard-float is specified.
	(MULTILIB_DEFAULTS): Include msoft-float.

	* config/arm/t-xscale-coff (EXTRA_MULTILIB_PARTS): Remove definition.

	* config/arm/coff.h (SUPPORTS_INIT_PRIORITY): Define (to false).
	* config/arm/elf.h (SUPPORTS_INIT_PRIORITY): Define (to true).

Wed Dec 19 06:12:34 2001  Douglas B. Rupp  <rupp@gnat.com>

	* dwarf2out.c (add_name_and_src_coords_attributes): Fix VMS procedure
	descriptor output.

2001-12-18  Stan Shebs  <shebs@apple.com>

	* rs6000.h (LOCAL_ALIGNMENT): Fix parens.

Tue Dec 18 17:02:06 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* emit-rtl.c (widen_memory_access): Only call compare_tree_int
	on an INTEGER_CST.

2001-12-18  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (rs6000_override_options): Only use DI ops when
	TARGET_64BIT.  Fix typo.

Tue Dec 18 16:39:46 CET 2001  Jan Hubicka  <jh@suse.cz>

	* att.h (ASM_FILE_START): Use asm_dialect.
	* linux.h (ASM_FILE_START): Likewise.
	* gas.h (ASM_FILE_START): Likewise.
	* i386.c (ix86_debug_arg_string, ix86_debug_addr_string,
	ix86_asm_string, ix86_asm_dialect): New.
	(override_options): Set asm_dialect.
	* i386.h (MASK_MIX_SSE_I387, MASK_INTEL_SYNTAX, MASK_DEBUG_ARG,
	MASK_DEBUG_ADDR): Kill.
	(MASK_64BIT, MASK_NO_RED_ZONE): renumber.
	(TARGET_DEBUG_ADDR, TARGET_DEBUG_ARG): Use string.
	(ASSEMBLER_DIALECT): Use asm_dialect.
	(TARGET_SWITCHES): Undocument deprecated items; deprecate intel-syntax;
	remove debug-addr and debug-arg.
	(TARGET_OPTIONS): Add debug-arg, debug-addr, asm.
	(asm_dialect): New enum.
	(ix86_debug_arg_string, ix86_debug_addr_string,
	ix86_asm_string, ix86_asm_dialect): Declare.
	* invoke.texi (-mintel-syntax): Remove.
	(-masm): Document.

Tue Dec 18 16:37:42 CET 2001  Jan Hubicka  <jh@suse.cz>

	* libgcc2.c (__bb_exit_func): Kill -ax dumping code.

2001-12-18  Jason Merrill  <jason@redhat.com>

	C++ ABI change: destroy value arguments in caller.
	* calls.c (initialize_argument_information): Pass the address of
	the TARGET_EXPR temporary rather than storing it into another.

Tue Dec 18 07:09:06 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/xm-vms.h (INCLUDE_DEFAULTS): Add /gnu/include.
	* config/alpha/vms.h (STACK_CHECK_BUILTIN): #define 0 for VMS.

2001-12-18  Jakub Jelinek  <jakub@redhat.com>

	* config/linux.h (PREFERRED_DEBUGGING_TYPE): Remove.
	* config/sparc/linux.h (PREFERRED_DEBUGGING_TYPE): Remove.
	* config/sparc/linux64.h (PREFERRED_DEBUGGING_TYPE): Remove.
	(CC1_SPEC): Don't default to -gstabs+ if -m32.

2001-12-05  David O'Brien  <obrien@FreeBSD.org>

	* elfos.h (PREFERRED_DEBUGGING_TYPE): Change to DWARF2_DEBUG.

2001-12-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* po/gcc.pot: Regenerate.

2001-12-18  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c: Fix comment typos.
	* config/h8300/h8300.h: Fix comment formatting.

2001-12-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* machmode.h (mode_name, mode_class, mode_size, mode_unit_size,
	mode_bitsize, mode_mask_array, mode_wider_mode): Set array size in
	declaration to NUM_MACHINE_MODES.
	(mode_size, mode_unit_size): Set array type to unsigned char.
	(mode_bitsize): Set array type to unsigned short.

	* rtl.c (rtx_length): Set array type to unsigned char.
	(rtx_length, rtx_name, rtx_format, rtx_class): Set array size to
	NUM_RTX_CODE.
	(mode_bitsize): Set array type to unsigned short.
	(mode_size, mode_unit_size): Set array type to unsigned char.
	(mode_name, mode_class, mode_bitsize, mode_size, mode_unit_size,
	mode_wider_mode, mode_mask_array): Set array size to
	NUM_MACHINE_MODES.

	* rtl.h (rtx_length, rtx_name, rtx_format, rtx_class): Set array
	size in declaration to NUM_RTX_CODE.

2001-12-17  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (unop): Encode RB as $sp.

2001-12-17  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Makefile.in: Update dependencies.
	* c-lang.c: Remove unnecessary includes.
	(deferred_fns, start_cdtor, finish_cdtor, defer_fn): Move to
	c-objc-common.c.
	(finish_file): Move body to c_common_finish_file.
	* c-objc-common.c: Include varray.h and ggc.h.
	(deferred_fns, start_cdtor, finish_cdtor, defer_fn,
	expand_deferred_fns, c_objc_common_finish_file): Moved from c-lang.c.
	(c_objc_common_init): Initialize deferred function array.
	* c-tree.h (c_objc_common_finish_file,
	static_ctors, static_dtors): New.
objc:
	* Make-lang.in: Update dependencies.
	* objc/objc-act.c: Don't include varray.h.
	(defer_fn, deferred_fns): Move to c-objc-common.c.
	(objc_init): Similarly for initialization of it.
	(finish_file): Move some to c-objc-common.c, use
	c_objc_common_finish_file.

2001-12-17  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c: Remove is_gpr_return_reg prototype.

2001-12-17  Neil Booth  <neil@daikokuya.demon.co.uk>

	* doc/cppinternals.texi: Update.

Mon Dec 17 14:21:21 2001  Jeffrey A Law  (law@redhat.com)

	* expmed.c (emit_store_flag): Extract updated comparison code
	from the return value of compare_from_rtx.
	* expr.c (do_store_flag): Similarly.

2001-12-17  Nick Clifton  <nickc@cambridge.redhat.com>

	* caller-save.c (init_caller_save): Use MODE_BASE_REG_CLASS in
	preference to BASE_REG_CLASS.
	* recog.c (preprocess_constraints): Ditto.
	* regclass.c (record_operand_costs, scan_one_insn, regclass,
	record_reg_classes, record_address_regs): Ditto.
	* regrename.c (scan_rtx_address, scan_rtx,
	replace_oldest_value_addr, replace_oldest_value_mem): Ditto.
	* reload.c (find_reloads, find_reloads_address,
	find_reloads_address_1): Ditto.
	* reload1.c (maybe_fix_stack_asms): Ditto.
	* defaults.h (MODE_BASE_REG_CLASS): Provide default
	definition.
	* doc/tm.texi: Document MODE_BASE_REG_CLASS.

	* config/arm/arm.h (MODE_BASE_REG_CLASS): Define.

2001-12-17  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi2html: Use -I $SOURCEDIR.

	Separate user and internals manuals.
	* Makefile.in (info, $(docdir)/gcc.info, dvi, gcc.dvi): Update
	dependencies.
	($(docdir)/gccint.info, gccint.dvi): New targets.
	(maintainer-clean, install-info, uninstall): Update.
	* doc/.cvsignore: Add gccint.info*.
	* doc/include/gcc-common.texi: New file.
	* doc/gcc.texi: Use it.  Adjust to be a user-only manual.  Put
	copyright notice in a macro.  Don't include ISBN unless FSFPRINT
	is defined.
	* doc/gccint.texi: New file.
	* doc/configfiles.texi, doc/extend.texi, doc/invoke.texi,
	doc/md.texi, doc/passes.texi, doc/tm.texi, doc/trouble.texi:
	Update for separate user and internals manuals.

2001-12-17  Dale Johannesen  <dalej@apple.com>

	 * config/rs6000/rs6000.h:  CPP_CPU_SPEC: add mcpu=7400.
	 ASM_CPU_SPEC: Ditto.
	 RTX_COSTS: Fix timing info for 7450 multiply.
	 * config/rs6000/rs6000.md:  Fix timing info for 7450 imul.
	 Allow floats to be kept in int regs in movsf_low,
	 movsf_low_st (Darwin only)

2001-12-17  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (vrsave_operation): Recognize SETs in
	parallel.
	(is_gpr_return_reg): New.
	(rs6000_emit_prologue): Call generate_set_vrsave with additional
	argument.  Save only registers in the mask.  Attach
	REG_FRAME_RELATED_EXPR note to altivec offsets.  Do not call
	rs6000_frame_related when saving VRSAVE.
	(rs6000_emit_epilogue): Call generate_set_vrsave with additional
	argument.  Restore only registers in the mask.  Restore altivec
	registers after we restore CR.
	(generate_set_vrsave): New parameter epiloguep.  Generate unspec
	sets instead of clobbers for call saved registers.
	(altivec_frame_fixup): New.

2001-12-17  Richard Henderson  <rth@redhat.com>

	* config/sparc/sparc.md (movdi_zero): Remove.
	(movdi_insn_sp32_v9): New.

2001-12-17  Richard Henderson  <rth@redhat.com>

	* cfgcleanup.c (outgoing_edges_match): Check for insn match with
	a single outgoing edge too.

Mon Dec 17 18:27:52 CET 2001  Jan Hubicka  <jh@suse.cz>

	* cfgrtl.c (redirect_edge_and_branch):  Do simplify abnormal
	edges resulting from computed jump

Mon Dec 17 17:57:05 CET 2001  Jan Hubicka  <jh@suse.cz>

	* Makefile.in (cfgcleanup.o): Add cselib.h dependency.
	* basic-block.h (CLEANUP_THREADING): New constant.
	* cfgcleanup.c: Include cselib.h
	(thread_jump, mark_effect): New functions.
	(try_forward_edges): Do jump threading when asked for.
	* jump.c (mark_modified_reg, save_regs, num_same_regs, modified_regs,
	modified_mem, thread_jumps, rtx_equal_for-thread_p): Kill.
	* rtl.h (thread_jumps, rtx_equal_for_thread_p): Kill.
	* toplev.c (rest_of_compilation): Do now call thread_jumps; use
	CLEANUP_THREAD instead.

2001-12-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* sparc/linux.h (STARTFILE_SPEC): Fix typo in last change.

2001-12-17  Tom Rix  <trix@redhat.com>

	* config/rs6000/rs6000.c (expand_block_move): Fix limits on max size
	of bytes.

2001-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* target.h (asm_out.byte_op, asm_out.aligned_op, asm_out.unaligned_op,
	asm_out.integer): New fields.
	* target-def.h (TARGET_ASM_BYTE_OP, TARGET_ASM_ALIGNED_[HSDT]I_OP,
	TARGET_ASM_UNALIGNED_[HSDT]I_OP, TARGET_ASM_INTEGER): New initializers.
	(TARGET_ASM_ALIGNED_INT_OP, TARGET_ASM_UNALIGNED_INT_OP): Collect
	the individual initializers together.
	(TARGET_ASM_OUT): Add the new initializers.
	* output.h (assemble_integer): Return bool.
	(integer_asm_op): Declare.
	(default_assemble_integer): Declare.
	(assemble_aligned_integer): New interface to assemble_integer.
	* varasm.c (integer_asm_op): New function to select pseudo-op.
	(default_assemble_integer): Default implementation of asm_out.integer.
	(assemble_integer): Use the new target hook.  Split objects into
	words or bytes if the target hook fails.  Return bool.
	* doc/tm.texi (ASM_OUTPUT_CHAR, ASM_OUTPUT_BYTE, ASM_OUTPUT_SHORT,
	ASM_OUTPUT_INT, ASM_OUTPUT_DOUBLE_INT, ASM_OUTPUT_QUADRUPLE_INT,
	UNALIGNED_SHORT_ASM_OP,	UNALIGNED_INT_ASM_OP,
	UNALIGNED_DOUBLE_INT_ASM_OP): Undocument.
	Document new target hooks.

	* defaults.h (ASM_OUTPUT_ADDR_VEC_ELT): Use integer_asm_op.
	* dwarf2asm.c (unaligned_integer_asm_op): Remove.
	(dw2_assemble_integer): New.
	(dw2_asm_output_data, dw2_asm_output_delta, dw2_asm_output_offset,
	dw2_asm_output_pcrel, dw2_asm_output_addr, dw2_asm_output_addr_rtx,
	dw2_asm_output_encoded_addr_rtx): Use it.
	(dw2_asm_output_nstring): Use assemble_integer for the null terminator.
	(dw2_asm_output_data_uleb128, dw2_asm_output_data_sleb128): Use
	integer_asm_op to get the byte pseudo-op.  Use assemble_integer
	if it returns NULL.
	* dwarf2asm.h (dw2_assemble_integer): Declare.
	* dwarfout.c: Include dwarf2asm.h.  Use dwarf2 functions for the
	default	implementation of most macros.
	(output_unsigned_leb128): Use dw2_asm_output_data.
	(output_signed_leb128, dwarfout_source_line): Likewise.
	(output_reg_number): Use dw2_assemble_integer.
	(generate_macinfo_entry): Separate the type and offset arguments.
	Use assemble_integer to write the value.
	(dwarfout_start_source_file): Update generate_macinfo_entry usage.
	(dwarfout_end_source_file, dwarfout_define, dwarfout_undef): Likewise.
	* final.c (output_addr_const): Don't put brackets round a subtracted
	symbol value or ".".
	* halfpic.c (half_pic_finish): Use assemble_aligned_integer.

	* config/1750a/1750a.c (assemble_integer_1750a): New,
	* config/alpha/alpha.h (literal_section): Avoid ASM_OUTPUT_INT.
	* config/arc/arc.c (arc_assemble_integer): New.
	* config/arc/arc.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_INT.
	* config/arm/arm.c (arm_poke_function_name): Likewise.
	(arm_assemble_integer): New, extracted from...
	* config/arm/arm.h (OUTPUT_INT_ADDR_CONST): ...here, now removed.
	(ARM_TRAMPOLINE_TEMPLATE, ARM_FUNCTION_PROFILER): Avoid ASM_OUTPUT_INT.
	(ARM_FUNCTION_PROFILER): Likewise.
	* config/avr/avr-protos.h (asm_output_byte): Remove.
	(asm_output_char, asm_output_short): Remove.
	* config/avr/avr.c (avr_assemble_integer): New.
	(asm_output_byte, asm_output_char, asm_output_short): Remove.
	* config/clipper/clipper.h (ASM_LONG): Remove.
	* config/dsp16xx/dsp16xx-protos.h (asm_output_long): Remove.
	* config/dsp16xx/dsp16xx.c (asm_output_long): Remove.
	* config/elxsi/elxsi.c (elxsi_assemble_integer): New.
	* config/i370/i370.c (i370_hlasm_assemble_integer): New.
	* config/i370/i370.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_SHORT.
	(ASM_BYTE, ASM_SHORT, ASM_LONG): Delete.
	* config/i386/att.h, (ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP.
	* config/i386/linux.h (ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): Use
	ASM_LONG instead of UNALIGNED_INT_ASM_OP.
	* config/i386/sco5.h (ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): Likewise.
	(ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP.
	* config/i386/sysv4.h (ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): Use
	ASM_LONG instead of UNALIGNED_INT_ASM_OP.
	* config/i860/fx2800.h (ASM_FILE_END): Avoid ASM_LONG.
	* config/i860/i860.c (i860_output_function_epilogue): Likewise.
	* config/i860/i860.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_INT.
	(ASM_SHORT, ASM_LONG): Undefine.
	* config/i860/paragon.h (ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP.
	* config/i860/sysv3.h (ASM_OUTPUT_ASCII): Likewise.
	* config/i960/i960.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_INT.
	* config/ia64/ia64.c (ia64_assemble_integer): New.
	* config/ia64/ia64.h (ASM_OUTPUT_DWARF_OFFSET): Use integer_asm_op.
	(ASM_OUTPUT_DWARF_PCREL): Likewise.
	* config/m68hc11/m68hc11.h (ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT,
	ASM_OUTPUT_ADDR_DIFF_ELT, ASM_OUTPUT_ADDR_VEC_ELT): Avoid ASM_LONG.
	(ASM_SHORT, ASM_LONG): Remove.
	* config/m68k/m68k.h (INT_OP_GROUP): New macro.
	(INT_OP_STANDARD, INT_OP_DOT_WORD, INT_OP_NO_DOT, INT_OP_DC): New
	macros, the allowed values for INT_OP_GROUP.
	* config/m68k/amix.h (ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP
	* config/m68k/atari.h (ASM_OUTPUT_ASCII): Likewise
	* config/m68k/m68kelf.h (ASM_OUTPUT_ASCII): Likewise
	* config/m68k/auxas.h (BYTE_ASM_OP, WORD_ASM_OP, LONG_ASM_OP): Remove.
	(INT_OP_GROUP): Define to INT_OP_NO_DOT.
	* config/m68k/dpx2.h (ASM_LONG): Undefine.
	(INT_OP_GROUP): Define to INT_OP_DC.
	* config/m68k/dpx2g.h (ASM_LONG): Undefine.
	* config/m68k/hp320.h (INT_OP_GROUP): Define to INT_OP_NO_DOT.
	* config/m68k/lynx.h (ASM_LONG): Undefine.
	* config/m68k/dpx2g.h (ASM_LONG): Undefine.
	* config/m68k/m68kelf.h (ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP.
	* config/m68k/m68kv4.h (ASM_OUTPUT_ASCII): Likewise.
	(TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_*.
	* config/m68k/mot3300.h (INT_OP_GROUP): Define to INT_OP_STANDARD
	for GAS and INT_OP_NO_DOT otherwise.
	(ASM_CHAR, ASM_BYTE, ASM_SHORT, ASM_LONG): Remove.
	(ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT,
	ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT): Avoid ASM_LONG.
	(ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP.
	* config/m68k/sgs.h (BYTE_ASM_OP, WORD_ASM_OP, LONG_ASM_OP): Remove.
	(INT_OP_GROUP): Define to INT_OP_STANDARD.
	(ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT,
	ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT): Avoid LONG_ASM_OP.
	(ASM_OUTPUT_ASCII): Avoid BYTE_ASM_OP.
	* config/m68k/tower-as.h (ASM_LONG): Remove.
	(INT_OP_GROUP): Define to INT_OP_NO_DOT.
	* config/m88k/m88k.c (output_tdesc): Avoid ASM_LONG.
	* config/m88k/m88k.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_INT.
	(ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT): Avoid ASM_LONG.
	* config/mips/iris5.h (TARGET_IRIX5): Define.
	* config/mips/mips.c (mips_assemble_integer): New.
	* config/mips/sni-svr4.h (ASM_LONG): Undefine.
	* config/mmix/mmix-protos.h (mmix_asm_output_double_int): Remove.
	* config/mmix/mmix.c (mmix_assemble_integer): New.
	(mmix_asm_output_double_int): Remove.
	(mmix_print_operand): Call mmix_output_octa directly.
	* config/mmix/mmix.h (ASM_LONG): Remove.
	* config/ns32k/ns32k.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_INT.
	* config/pa/pa.c (pa_assemble_integer): New.
	(pa_override_options): Only use aligned DI ops on 64-bit targets.
	Only use the unaligned ops if TARGET_GAS.
	* config/pdp11/pdp11.c (pdp11_assemble_integer): New.
	* config/pdp11/pdp11.h (TRAMPOLINE_TEMPLATE): Avoid ASM_OUTPUT_SHORT.
	* config/pj/pj.h (ASM_LONG): Undefine.
	* config/rs6000/linux64.h (RELOCATABLE_NEEDS_FIXUP): Undefine.
	* config/rs6000/rs6000.c (rs6000_assemble_integer): New, mostly
	extracted from ASM_OUTPUT_INT in sysv4.h.  Use in_text_section()
	and in_toc_section() rather than the in_section variable.
	(rs6000_override_options): Only use DI ops when TARGET_POWERPC64.
	* config/rs6000/sysv4.h (TOC_SECTION_FUNCTION): Add in_toc_section().
	(RELOCATABLE_NEEDS_FIXUP): Define.
	* config/rs6000/xcoff.h (DOUBLE_INT_ASM_OP): Change space to tab.
	* config/s390/linux.h (ASM_SHORT, ASM_LONG, ASM_QUAD): Remove.
	(ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT): Use integer_asm_op
	to get the word directive.
	(ASM_OUTPUT_ASCII): Avoid ASM_BYTE_OP.
	* config/s390/s390.c (s390_assemble_integer): New.
	* config/s390/s390.h (ASM_OUTPUT_SPECIAL_POOL_ENTRY): Use
	integer_asm_op to get the word directive.
	* config/sparc/sol2.h (ASM_SHORT, ASM_LONG): Remove.
	* config/sparc/sparc-protos.h (output_double_int): Remove.
	* config/sparc/sparc.c (output_double_int): Move to...
	(sparc_assemble_integer): ...this new function.
	(sparc_override_options): Only use .uaxword if TARGET_ARCH64.
	* config/sparc/sparc.h (ASM_SHORT, ASM_LONG, ASM_LONGLONG): Remove.
	* config/sparc/sysv4.h (ASM_LONG): Remove.
	(ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT): Avoid
	ASM_LONG.
	* config/vax/vax.h (TRAMPOLINE_TEMPLATE): Use assemble_aligned_integer.
	* config/we32k/we32k.h (TRAMPOLINE_TEMPLATE): Likewise.

	* config/1750a/1750a.c, config/a29k/a29k.c, config/alpha/alpha.c,
	config/arc/arc.c, config/arm/arm.c, config/avr/avr.c, config/c4x/c4x.c,
	config/clipper/clipper.c, config/convex/convex.c, config/cris/cris.c,
	config/d30v/d30v.c, config/dsp16xx/dsp16xx.c, config/elxsi/elxsi.c,
	config/fr30/fr30.c, config/h8300/h8300.c, config/i370/i370.c,
	config/i386/i386.c, config/i860/i860.c, config/i960/i960.c,
	config/ia64/ia64.c, config/m32r/m32r.c, config/m68hc11/m68hc11.c,
	config/m68k/m68k.c, config/m88k/m88k.c, config/mips/mips.c,
	config/mmix/mmix.c, config/mn10200/mn10200.c, config/mn10300/mn10300.c,
	config/ns32k/ns32k.c, config/pa/pa.c, config/pdp11/pdp11.c,
	config/sh/sh.c, config/sparc/sparc.c, config/stormy16/stormy16.c,
	config/v850/v850.c, config/vax/vax.c, config/we32k/we32k.c
	(TARGET_ASM_BYTE_OP, TARGET_ASM_ALIGNED_HI_OP,
	TARGET_ASM_ALIGNED_SI_OP, TARGET_ASM_ALIGNED_DI_OP,
	TARGET_ASM_UNALIGNED_HI_OP, TARGET_ASM_UNALIGNED_SI_OP,
	TARGET_ASM_UNALIGNED_DI_OP, TARGET_ASM_INTEGER): Redefine as
	appropriate.

	* config/defaults.h, config/darwin.h, config/elfos.h, config/svr3.h,
	config/1750a/1750a.h, config/a29k/a29k.h, config/alpha/alpha.h,
	config/arc/arc.h, config/arm/arm.h, config/avr/avr.h, config/c4x/c4x.h,
	config/clipper/clipper.h, config/convex/convex.h, config/cris/cris.h,
	config/d30v/d30v.h, config/dsp16xx/dsp16xx.h, config/elxsi/elxsi.h,
	config/fr30/fr30.h, config/h8300/h8300.h, config/i370/i370.h,
	config/i386/bsd.h, config/i386/djgpp.h, config/i386/i386.h,
	config/i386/sco5.h, config/i386/sol2.h, config/i386/sun386.h,
	config/i860/i860.h, config/i960/i960.h, config/ia64/ia64.h,
	config/m32r/m32r.h, config/m68hc11/m68hc11.h, config/m68k/auxas.h,
	config/m68k/dpx2.h, config/m68k/hp320.h, config/m68k/m68k.h,
	config/m68k/mot3300.h, config/m68k/sgs.h, config/m68k/tower-as.h,
	config/m88k/m88k.h, config/mcore/mcore-elf.h, config/mcore/mcore.h,
	config/mips/iris5.h, config/mips/iris6.h, config/mips/mips.h,
	config/mmix/mmix.h, config/mn10200/mn10200.h, config/mn10300/mn10300.h
	config/ns32k/encore.h, config/ns32k/ns32k.h, config/pa/pa-64.h,
	config/pa/pa.h, config/pdp11/pdp11.h, config/pj/pj.h,
	config/romp/romp.h, config/rs6000/linux64.h, config/rs6000/rs6000.h,
	config/rs6000/sysv4.h, config/rs6000/xcoff.h, config/s390/linux.h,
	config/sh/sh.h, config/sparc/linux64.h, config/sparc/sol2.h,
	config/sparc/sp64-elf.h, config/sparc/sparc.h, config/sparc/sysv4.h,
	config/stormy16/stormy16.h, config/v850/v850.h, config/vax/vax.h,
	config/we32k/we32k.h (ASM_OUTPUT_CHAR, ASM_OUTPUT_BYTE, ASM_BYTE_OP,
	ASM_BYTE, ASM_OUTPUT_SHORT, ASM_OUTPUT_INT, ASM_OUTPUT_DOUBLE_INT,
	UNALIGNED_SHORT_ASM_OP, UNALIGNED_INT_ASM_OP,
	UNALIGNED_DOUBLE_INT_ASM_OP): Undefine, where defined.

2001-12-17  Stan Shebs  <shebs@apple.com>

	* config/rs6000/darwin.h (SUBTARGET_OVERRIDE_OPTIONS): Define.
	(STACK_BOUNDARY): Remove definition.
	(CPP_PREDEFINES): Define __POWERPC__.

2001-12-17  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/c-tree.texi (Trees): Only refer to GCC.

2001-12-17  Andreas Jaeger  <aj@suse.de>

	* c-common.def: Fix typo in comment.

2001-12-16  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (sparc64-*-freebsd*): Add target.
	* config/sparc/freebsd.h: New file.
	* config/sparc/sparc.h (LIB_SPEC, LINK_SPEC): Don't define.
	* config/sparc/sunos4.h (LIB_SPEC, LINK_SPEC): Define.
	* config/sparc/sysv4.h (CPP_PREDEFINES): Undefine before defining.

2001-12-16  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (rs6000_legitimize_address): Force both
	PLUS operands into registers for altivec mode.

2001-12-16  Aldy Hernandez  <aldyh@redhat.com>

	* builtins.c (apply_args_size): Change regno to unsigned.

2001-12-16  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (FUNCTION_ARG_REGNO_P): Change
	ALTIVEC_ARG_MAX_REG to ALTIVEC_ARG_NUM_REG.

2001-12-16  Zack Weinberg  <zack@codesourcery.com>

	* c-typeck.c (error_init, pedwarn_init, warning_init): Call
	gettext on argument before printing.

	* fold-const.c (negate_expr): Always call fold on new
	NEGATE_EXPR.

2001-12-17  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.def (COMPOUND_LITERAL_EXPR): Contain a DECL_STMT, not
	a DECL directly.
	* c-common.h (COMPOUND_LITERAL_EXPR_DECL_STMT): New.
	(COMPOUND_LITERAL_EXPR_DECL): Adjust definition.
	* c-decl.c (build_compound_literal): Put the decl inside a
	DECL_STMT.
	* doc/c-tree.texi (COMPOUND_LITERAL_EXPR): Update documentation.
	Fixes PR c/5105.

2001-12-16  Aldy Hernandez  <aldyh@redhat.com>

	* config.gcc: Add powerpc-*-eabisimaltivec*.

2001-12-16  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-common.c, c-common.h (back_end_hook): Remove.
	* c-lang.c (finish_file): Remove back_end_hook.

Sun Dec 16 13:13:01 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (highest_pow2_factor, case INTEGER_CST): Fix error in
	last change.

2001-12-16  Richard Henderson  <rth@redhat.com>

	* toplev.c (parse_options_and_default_flags): Don't enable
	flag_cprop_registers at -O1.

2001-12-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* avr.c (avr_simplify_comparision_p, adjust_insn_length,
	mask_one_bit_p, output_reload_insisf): Don't use the 'U' suffix.
	* avr.h (reg_class): Likewise.
	* avr.md: Likewise.
	* mcore.c (try_constant_tricks, mcore_byte_offset,
	mcore_halfword_offset): Likewise.
	* sh.c (shl_sext_kind, gen_block_redirect, split_branches): Likewise.
	* v850.c (not_power_of_two_operand): Likewise.

	* clipper/clix.h (ASM_OUTPUT_ASCII): Avoid signed/unsigned
	warnings.
	* convex.h (ASM_OUTPUT_ASCII): Likewise.
	* i370.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/att.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/i386-interix.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/i386elf.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/ptx4-i.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/sco5.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/sun386.h (ASM_OUTPUT_ASCII): Likewise.
	* i386/sysv4.h (ASM_OUTPUT_ASCII): Likewise.
	* i860/bsd.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/3b1.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/amix.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/atari.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/crds.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/hp320.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/m68kv4.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/mot3300.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/sgs.h (ASM_OUTPUT_ASCII): Likewise.
	* m68k/tower-as.h (ASM_OUTPUT_ASCII): Likewise.
	* mips/bsd-5.h (ASM_OUTPUT_ASCII): Likewise.
	* mips/mips-5.h (ASM_OUTPUT_ASCII): Likewise.
	* mips/svr3-5.h (ASM_OUTPUT_ASCII): Likewise.
	* mips/svr4-5.h (ASM_OUTPUT_ASCII): Likewise.
	* ns32k/encore.h (ASM_OUTPUT_ASCII): Likewise.
	* vax/vaxv.h (ASM_OUTPUT_ASCII): Likewise.
	* we32k/we32k.h (ASM_OUTPUT_ASCII): Likewise.

	* i386/uwin.h (MD_STARTFILE_PREFIX): Avoid redefinition warnings.
	* interix.h (TARGET_MEM_FUNCTIONS): Likewise.
	* psos.h (CPP_PREDEFINES): Likewise.
	* rs6000/linux64.h (ROUND_TYPE_ALIGN): Likewise.
	* rs6000/xcoff.h (RS6000_MCOUNT, RS6000_ITRUNC, RS6000_UITRUNC,
	ASM_OUTPUT_EXTERNAL): Likewise.
	* sparc/liteelf.h (DWARF_DEBUGGING_INFO, DWARF2_DEBUGGING_INFO):
	Likewise.
	* sparc/sp64-elf.h (UNALIGNED_DOUBLE_INT_ASM_OP): Likewise.
	* sparc/sp86x-elf.h (DWARF_DEBUGGING_INFO, DWARF2_DEBUGGING_INFO):
	Likewise.
	* sparc/sunos4.h (SUNOS4_SHARED_LIBRARIES): Likewise.

	* c-lex.c (lex_number): Use ISXDIGIT/hex_value.
	* vax/xm-vms.h (FILE_NAME_NONDIRECTORY): Use ISUPPER/TOLOWER.
	* fold-const.c (real_hex_to_f): Use hex_value.
	* real.c (asctoeg): Use hex_value & ISXDIGIT.
	* toplev.c (toplev_main): Call hex_init.
	* tradcpp.c (main): Call hex_init.

	* nextstep-protos.h: New file.
	* nextstep.c: Include "rtl.h", "output.h" & "tm_p.h".
	* nextstep.h (INCLUDE_DEFAULTS): Delete LOCAL_INCLUDE_DIR and
	STANDARD_INCLUDE_DIR from the CROSS_COMPILE clause.
	(nextstep_asm_out_constructor, nextstep_asm_out_destructor,
	handle_pragma): Move prototypes to nextstep-protos.h.
	* config.gcc (i[34567]86-next-*, m68k-next-nextstep2*,
	m68k-next-nextstep[34]*): Append nextstep-protos.h to tm_p_file.

2001-12-16  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	PR other/3725
	* configure.in: Add AC_SUBST(target_alias).
	* configure: Regenerated.

2001-12-15  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (sibcall_osf_1_er): New.
	(sibcall_value_osf_1_er): New.

2001-12-15  Dan Nicolaescu  <dann@ics.uci.edu>

	* config/sparc/sparc.c (mems_ok_for_ldd_peep): Rename from
	addrs_ok_for_ldd_peep_withmem; take MEMs as parameters, not
	addrs; eliminate restriction of only using fp and sp as base
	registers.
	* config/sparc/sparc-protos.h: Update.
	* config/sparc/sparc.md (movdi): Use TARGET_V9 not TARGET_ARCH64.
	(*cmp_cc_set, *cmp_ccx_set64, *movdi_zero): New insns derived
	from old define_peepholes.
	Convert all the ldd/std peepholes to peephole2.

2001-12-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* s390.md (prologue, epilogue, *return_si, *return_di): New.
	s390.c (find_unused_clobbered_reg, s390_frame_info,
	save_fpr, restore_fpr, s390_emit_prologue, s390_emit_epilogue): New.
	s390-protos.h (s390_emit_prologue, s390_emit_epilogue): Declare.
	s390.c (s390_arg_frame_offset): Use s390_frame_info.
	(leaf_function_flag, cur_is_leaf_function,
	save_fprs, restore_fprs, force_const_mem_late): Remove.
	(s390_function_prologue, s390_function_epilogue): Mostly remove.
	s390.md (lit): New.  Uses ...
	s390.c (s390_output_constant_pool): ... this, so adapt and make global.
	s390-protos.h (s390_output_constant_pool): Declare.
	s390.md (load_multiple, store_multiple): Allow use after reload.
	s390.c (load_multiple_operation, store_multiple_operation): Likewise.
	s390.h (INCOMING_FRAME_SP_OFFSET): Define.
	s390.h (CALL_REALLY_USED_REGISTERS): Define.
	config/s390/linux64.h (CALL_USED_REGISTERS): Remove, now handled ...
	s390.h (CONDITIONAL_REGISTER_USAGE): ... here.
	s390.c (s390_sr_alias_set): New global variable, initialized ...
	(override_options): ... here.  New.
	s390-protos.h (override_options): Declare.
	s390.h (OVERRIDE_OPTIONS): Call it.
	s390.c (s390_function_profiler): New.
	s390-protos.h (s390_function_profiler): Declare.
	s390.h (FUNCTION_PROFILER): Call it.
	s390.c (s390_profile): Remove.

	* s390.c (reg_used_in_mem_p): PC reload counts as memory access.
	(addr_generation_dependency_p): Consider literal pool register loads.
	(s390_adjust_priority): Do not schedule load_multiple.
	s390.md (attribute "type"): Define some additional types.
	(function_unit "integer"): Adapt.
	(many insns): Adapt "type" attribute setting.

	* s390.c (general_s_operand, s_imm_operand): New.
	(s_operand): Remove old definition, call general_s_operand instead.
	s390-protos.h (s_imm_operand): Declare.
	s390.c (base_n_index_p, r_or_s_operand, r_or_s_or_im8_operand,
	r_or_x_or_im16_operand, r_or_im8_operand): Remove.
	s390-protos.h (r_or_s_operand, r_or_s_or_im8_operand,
	r_or_x_or_im16_operand, r_or_im8_operand): Likewise.
	s390.h (PREDICATE_CODES): Add s_imm_operand, remove r_or_s*_operand.
	s390.md (many insns): Rework insn predicates.

	* s390.c (legitimate_pic_operand_p, legitimate_constant_p): Accept all
	non-symbolic constants.  Reload will force them because of ...
	(s390_preferred_reload_class): ... this.  New.
	s390-protos.h (s390_preferred_reload_class): Declare.
	s390.h (PREFERRED_RELOAD_CLASS): Call it.
	s390.md (movdi, movsi, movdf, movsf, *reload_la_64 splitters,
	*reload_la_31 splitters): Handle constants after reload.
	(many insns): no longer force all constants immediately.
	s390.c (legitimate_reload_constant_p): New helper routine.
	s390-protos.h (legitimate_reload_constant_p): Declare.
	s390.c (print_operand): Clean up CONST_INT case, add CONST_DOUBLE case.

	* s390.h (FIRST_PSEUDO_REGISTER, FRAME_POINTER_REGNUM,
	HARD_FRAME_POINTER_REGNUM, REGISTER_NAMES): Add virtual frame pointer.
	(CALL_USED_REGISTERS, CALL_REALLY_USED_REGISTERS): Update.
	(ELIMINABLE_REGS, INITIAL_ELIMINATION_OFFSET): Likewise.
	(REGNO_OK_FOR_INDEX_P, REG_OK_FOR_INDEX_NONSTRICT_P): Likewise.
	(DWARF_FRAME_REGISTERS): Define.
	s390.c (regclass_map): Add virtual frame pointer.
	(legitimate_la_operand_p): Allow use of virtual frame pointer.
	s390.md (*la_ccclobber, *addaddr_ccclobber): New.
	(addaddr, addsi_64): Delete.

	* s390.h (HARD_REGNO_MODE_OK): Allow SImode and DImode values in
	floating point registers.
	(CLASS_CANNOT_CHANGE_MODE, CLASS_CANNOT_CHANGE_MODE_P): Define.
	(ADDR_FP_REGS, GENERAL_FP_REGS): New register classes.
	(REG_CLASS_NAMES, REG_CLASS_CONTENTS): Update.

	* s390.md (movti): Replace multi-insn output with splitters.
	(movdi_31, movdf_31): Likewise.
	(movti_ss, movdi_ss, movsi_ss, movdf_ss, movsf_ss): New.
	(movdi_lhi, movdi_lli, movdi_larl, movsi_lhi, movsi_lli): New.
	(movdi_64, movdi_31, movsi, movdf_64, movdf_31): Adapt.
	(movdf_soft_64, movdf_soft_31, movsf_soft): Remove.
	(movsf_64, movsf_31): Remove, replace by ...
	(movsf): ... this.
	(movqi_64): Use lhi instead of llill.
	(*movstrictqi, *movstricthi): Don't use (strict_low_part (mem)).

	* s390.md (extendsidi2, *extendsidi2, extendhidi2, *extendhidi2,
	extendqidi2, extendhisi2, *extendhisi2, extendqisi2,
	extendqihi2 and associated splitters): Reworked.
	(zero_extendsidi2, zero_extendsidi2, *zero_extendsidi2,
	zero_extendhidi2, *zero_extendhidi2, zero_extendqidi2,
	zero_extendqidi2, *zero_extendqidi2, zero_extendhisi2,
	*zero_extendhisi2_64, zero_extendhisi2_31, zero_extendqisi2,
	*zero_extendqisi2_64, *zero_extendqisi2_mem_31,
	zero_extendqisi2_reg_31, zero_extendqihi2, *zero_extendqisi2_64,
	zero_extendqihi2, zero_extendqihi2_64, zero_extendqihi2_31,
	and associated splitters): Likewise.
	(*sethighqisi, *sethighhisi, *sethighqidi_64, *sethighqidi_31
	and associated splitters): New.
	(truncdisi2, truncdihi2, truncdiqi2, truncsihi2, do_truncsihi2,
	*truncsihi2_64, truncsiqi2, trunchiqi2): Remove.
	(ashlhi3, ashrhi3, lshrhi3, abshi3): Remove.
	s390.h (PROMOTE_PROTOTYPES): Remove.
	config/s390/linux64.h (PROMOTE_PROTOTYPES): Likewise.

	* s390.md (muldi3): Delete, use instead ...
	(mulsidi3): ... this.
	(*muldi3_64): Rename to muldi3.
	(mulsi_6432): Fix template.
	(divdi3, moddi3): Delete, replace by ...
	(divmoddi4): ... this.
	(divmodtidi3): Fix template.
	(divmodtisi3): New.
	(udivdi3, umoddi3): Delete, replace by ...
	(udivmoddi4): ... this.
	(udivmodtidi3): Fix template.
	(divsi3, modsi3): Delete, replace by ...
	(divmodsi4): ... this.
	(divmoddisi3): Fix template.
	(udivsi3, umodsi3): Adapt.

	* s390.md (anddi3): Remove SS alternative, use instead ...
	(anddi3_ss, anddi3_ss_inv): ... these.
	(anddi3_ni): New.
	(andsi3*, andhi3*, andqi3*): Likewise.
	(iordi3): Remove SS alternative, use instead ...
	(iordi3_ss, iordi3_ss_inv): ... these.
	(iordi3_oi): New.
	(iorsi3*, iorhi3*, iorqi3*): Likewise.
	(iordi3_cc, iordi3_cconly, iorsi3_cc, iorsi3_cconly): New.
	(xordi3): Remove SS alternative, use instead ...
	(xordi3_ss, xordi3_ss_inv): ... these.
	(xordi3_oi): New.
	(xorsi3*, xorhi3*, xorqi3*): Likewise.
	(xordi3_cc, xordi3_cconly, xorsi3_cc, xorsi3_cconly): New.
	(one_cmpldi2, one_cmplsi2, one_cmplhi2, one_cmplqi2):
	Expand to XOR with -1.
	(*one_cmpldi2, *one_cmplsi2, *one_cmplhi2): Remove.
	(cmpdi_tm): Delete, replace by ...
	(cmpdi_tm_reg, cmpdi_tm_mem): ... these.
	(cmpsi_cct): Delete, replace by ...
	(cmpsi_tm_reg, cmpsi_tm_mem): ... these.
	(cmpdi_tm2, cmpsi_tm2): Improve.
	(cmphi_tm_sub, cmpqi_tm_sub, cmpqi_tm2, cmpqi_tm): New.
	s390.c (s390_single_hi, s390_extract_hi,
	s390_single_qi, s390_extract_qi): New helper routines.
	s390-protos.h (s390_single_hi, s390_extract_hi,
	s390_single_qi, s390_extract_qi): Declare.
	s390.c (tmxx_operand, const1_operand): Remove.
	s390-protos.h (tmxx_operand, const1_operand): Likewise.
	s390.h (PREDICATE_CODES): Likewise.

	* s390.md (sqrtdf2, sqrtsf2): New.

	* s390.h (CRT_CALL_STATIC_FUNCTION): Define.
	(check_and_change_labels): Remove section-change special case.

	* s390.h (RETURN_ADDR_RTX): Fix use of __builtin_return_address
	in leaf functions.  Needs ...
	(DYNAMIC_CHAIN_RTX):  ... this.  New.

	* s390.c (emit_pic_move): Don't generate pseudos if no_new_pseudos.

	* s390.md (movstrdix_64, movstrsix_31, movstrdi_64, movstrsi_31,
	clrstrsi_64, clrstrsi_31, cmpstr_64, cmpstr_31): Do not clobber
	input operands using a match_dup clause.
	(movstrdi, movstrsi, clrstrdi, clrstrsi, cmpstrdi, cmpstrsi): Adapt.

	* s390.md (floatdidf2, floatdisf2, floatsidf2, floatsidf2_ieee,
	floatsisf2, floatsisf2_ieee): Add missing CC clobber.

	* s390.md (floatsidf2_ibm): Use correct operand.

	* s390.md (fixuns_truncdfdi2, fixuns_truncdfsi2, fix_truncdfsi2,
	fixuns_truncsfdi2, fixuns_truncsfsi2, floatsidf2): Remove use of
	non-portable constants.
	s390.c (s390_gen_rtx_const_DI): New helper routine.
	s390-protos.h (s390_gen_rtx_const_DI): Declare.

	* s390.h (ASM_OUTPUT_SPECIAL_POOL_ENTRY): Fix alignment.

	* config/s390/linux.h (ASM_OUTPUT_SHORT, ASM_OUTPUT_CHAR,
	ASM_OUTPUT_BYTE): Clean up assembly output.
	(ASM_OUTPUT_SKIP, ASM_OUTPUT_ALIGN): Remove duplicate definitions.
	(ASM_OUTPUT_ASCII): Remove.

	* config/s390/t-linux (CRTSTUFF_T_CFLAGS_S): Define.

2001-12-15  Zack Weinberg  <zack@codesourcery.com>

	* unwind-dw2-fde-glibc.c: #define _Unwind_Find_FDE to itself
	before including unwind-dw2-fde.c, if we are not using the
	special code in this file.

2001-12-15  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.h (TARGET_SWITCHES): Turn on
	MASK_EXPLICIT_RELOCS if the assembler supports it.
	* configure.in (HAVE_AS_EXPLICIT_RELOCS): New.
	* configure, config.in: Rebuild.

Sat Dec 15 17:53:03 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* calls.c (emit_call_1): If ECF_SP_DEPRESSED, pretend have adjusted
	for rounded_stack_size.

2001-12-15  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c, config/i386/i386.h, config/mcore/mcore.h,
	config/ns32k/ns32k.h, config/rs6000/sysv4.h, fold-const.c,
	toplev.c, cppinit.c, cppmacro.c, gcc.c: Use "built-in" and
	"bit-field" spellings in messages.
	* po/gcc.pot: Regenerate.

2001-12-15  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.c, config/fr30/fr30.c, config/v850/v850-c.c, toplev.c: Use
	American spelling in messages.
	* po/gcc.pot: Regenerate.

2001-12-15  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md: Adjust whitespacing.  Remove
	constraints from expanders.  Replace \@ with @.

2001-12-15  Richard Earnshaw  <rearnsha@arm.com>

	* arm/unknown-elf.h (CPP_PREDEFINES): Add a suitable default.

2001-12-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* regrename.c (copyprop_hardreg_forward): Do not keep register
	value data live across abnormal call or eh egdes.

Sat Dec 15 08:29:45 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (highest_pow2_factor, case INTEGER_CST): Return
	BIGGEST_ALIGNMENT for 0.

Sat Dec 15 14:13:03 CET 2001  Jan Hubicka  <jh@suse.cz>

	* predict.def (PRED_NORETURN): Make probabilities match reality.
	(PRED_OPCODE_POSITIVE, PRED_OPCODE_NONEQUAL, PRED_ERROR_RETURN):
	Likewise.

2001-12-15  Jakub Jelinek  <jakub@redhat.com>

	* configure.in: Check for ld.
	(HAVE_LD_EH_FRAME_HDR): Define if ld supports --eh-frame-hdr option.
	* configure, config.in: Rebuilt.
	* config.gcc: Add crtbeginT.o to extra_parts where needed.
	* config/t-linux (LIB2ADDEH, LIB2ADDEHDEP): Use unwind-dw2-fde-glibc
	frame unwinding on Linux.
	* config/t-linux-gnulibc1 (LIB2ADDEH, LIB2ADDEHDEP): Use unwind-dw2-fde
	frame unwinding.
	* config/linux.h (STARTFILE_SPEC): Use crtbeginT.o for -static.
	(LINK_EH_SPEC): Define.
	* config/i386/gnu.h (STARTFILE_SPEC): Use crtbeginT.o for -static.
	* config/ia64/linux.h (STARTFILE_SPEC, LINK_EH_SPEC): Define.
	* config/ia64/fde-glibc.c (_Unwind_IteratePhdrCallback): Don't
	iterate further if pc falls into current library, but fde was not
	found.
	* config/sparc/linux.h (STARTFILE_SPEC): Use crtbeginT.o for -static
	if using glibc.
	(LINK_EH_SPEC): Define.
	* config/sparc/linux64.h (STARTFILE_SPEC32, STARTFILE_SPEC64):
	Use crtbeginT.o for -static.
	(LINK_EH_SPEC): Define.
	* config/sparc/t-linux64 (EXTRA_MULTILIB_PARTS): Add crtbeginT.o.
	* Makefile.in (crtbeginT.o): Add rule.
	* gcc.c (init_gcc_specs): For -static-libgcc, use -lgcc -lgcc_eh.
	If neither -static-libgcc nor -shared-libgcc is passed and -shared,
	use -lgcc if LINK_EH_SPEC is defined and -lgcc_s -lgcc if not.
	If none of the above switches are passed, use -lgcc -lgcc_eh.
	(init_spec): If LINK_EH_SPEC is defined, prepend it to link_spec.
	* mklibgcc.in: Don't include LIB2ADDEH objects into libgcc.a if
	creating libgcc_s.so, put them into separate libgcc_eh.a instead.
	* unwind-dw2-fde.c: Don't include any headers if this file
	is included from other .c file.
	* unwind-dw2-fde-glibc.c: New file.
	* crtstuff.c (USE_PT_GNU_EH_FRAME, USE_EH_FRAME_REGISTRY): Define.
	Use it instead of EH_FRAME_SECTION_NAME where appropriate.

2001-12-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_memcmp): Mark parameter with
	ATTRIBUTE_UNUSED.
	* cfgcleanup.c (insns_match_p): Likewise.
	* regrename.c (mode_change_ok): Likewise.
	* gcc.c (execute): Const-ify.

2001-12-14  Aldy Hernandez  <aldyh@redhat.com>

	* c-parse.in (typename): Do not split attributes.
	Remove unsupported attributes warning.

	* c-decl.c (groktypename): Apply attributes.

2001-12-14  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (spill_restore_mem): Mark iterator
	initialization as possibly dead.

2001-12-14  Richard Henderson  <rth@redhat.com>

	* regrename.c (mode_change_ok): New.
	(find_oldest_value_reg): Use it.

2001-12-14  Richard Henderson  <rth@redhat.com>

	* regrename.c (struct value_data): Add max_value_regs.
	(init_value_data): Initialize it.
	(kill_value): Kill values that overlap the dying register.
	(set_value_regno): New.
	(kill_set_value, kill_autoinc_value, copy_value): Use it.
	(copyprop_hardreg_forward_1): Kill earlyclobber operands
	before looking at inputs.

2001-12-14  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.h (ASM_OUTPUT_DEF_FROM_DECLS): Handle
	DECL_WEAK for function descriptors.
	* config/rs6000/xcoff.h (HANDLE_PRAGMA_WEAK): Define if assembler
	weak support present.
	(ASM_WEAKEN_LABEL): Same.

2001-12-14  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md (anonymous pattern): Add a missing
	mode.

2001-12-14  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (h8300_adjust_insn_length): Fix a
	comment typo.

2001-12-14  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (h8300_handle_eightbit_data_attribute):
	Remove the initialization requierment.
	(h8300_handle_tiny_data_attribute): Likewise.

2001-12-14  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md (udivqi3): Remove.
	(divqi3): Likewise.
	(udivhi3): Likewise.
	(divhi3): Likewise.
	(umodqi3): Likewise.
	(modqi3): Likewise.
	(umodhi3): Likewise.
	(modhi3): Likewise.
	(udivmodqi3): New.
	(divmodqi3): Likewise.
	(udivmodhi3): Likewise.
	(divmodhi3): Likewise.

Sat Dec 15 01:39:12 CET 2001  Jan Hubicka  <jh@suse.cz>

	* cfgcleanup.c (flow_find_cross_jump): Replace tests for note
	by active_insn_p; count conditional jump as instruction.

2001-12-14  DJ Delorie  <dj@redhat.com>
	    Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygwin.h (I386_PE_STRIP_ENCODING): Handle '*'
	at SYM_NAME[0] or SYM_NAME[3].
	(STRIP_NAME_ENCODING): Don't check for leading '*'.

2001-12-14  Ira Ruben	<ira@apple.com>

	Add -### option (displays driver-generated commands without
	executing and quotes all arguments).
	* doc/invoke.texi: Add -###.
	* gcc.c (verbose_only_flag) - New flag.
	* (execute): If -### write quoted arguments and return.
	* (display_help): Print meaning of -###.
	* (process_command): Handle -###.

2001-12-14  Ira Ruben	<ira@apple.com>

	Fix to no allow -save-temps to clobber user's source file.
	* gcc.c: Add static globals input_stat and input_stat_set.
	(do_spec_1): For 'g', 'u', 'U' case with save_temps_flag
	set, check that user's input file is not overwritten.
	(set_input): Reset input_stat_set for each new file.

Fri Dec 14 22:14:44 CET 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (estimate_probability): Fix LOOP_EXIT heuristic.

2001-12-14  Zack Weinberg  <zack@codesourcery.com>

	* combine.c (record_dead_and_set_regs): Use
	regs_invalidated_by_call.  Don't note stores for CALL_INSNs.

2001-12-14  Roger Sayle <roger@eyesopen.com>

	* builtins.def: Rename BUILT_IN_FSQRT to BUILT_IN_SQRT and
	__builtin_fsqrt to __builtin_sqrt.

	* builtins.c (expand_builtin_mathfn,expand_builtin): Same.
	* doc/extend.texi: Simplify documentation to match patch.

Fri Dec 14 21:23:54 CET 2001  Jan Hubicka  <jh@suse.cz>

	* config.gcc: Revamp target_cpu_default2 to strings;
	support new x86 variants.
	* i386.c (override_options): Default x86_cpu_string and x86_arch_string
	properly; set prefetch_sse.
	* i386.h (x86_prefetch_sse): Declare.
	(TARGET_PREFETCH_SSE): New.
	(CPP_CPU_DEFAULT_SPEC): Define according to the new macros.
	(TARGET_CPU_DEFAULT_*): New.

Thu Dec 13 21:57:13 CET 2001  Janis Johnson <janis187@us.ibm.com>
			      Jan Hubicka  <jh@suse.cz>

	* config/i386/i386.h (struct processor_costs): Add new members
	  prefetch_block and simultaneous_prefetches.
	  (PREFETCH_BLOCK, SIMULTANEOUS_PREFETCHES): New.
	* config/i386/i386.c (processor_costs structs): Add values for
	  prefetch_block and simultaneous_prefetches.
	* config/i386/i386.md (unspec values): Remove values for prefetch
	  operations, which now use the PREFETCH rtx code.
	  (prefetch_sse, prefetch_3dnow, prefetchw): Combine to use new
	  unified prefetch support.

2001-12-14  Jason Merrill  <jason@redhat.com>

	* diagnostic.c (sorry): Increment sorrycount before saving the
	buffer state.

Fri Dec 14 19:53:23 CET 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (sqrt?f): Fix conditionals.

Fri Dec 14 07:29:52 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config.gcc (alpha64-dec-*vms*): New case.
	* config/alpha/t-vms64, config/alpha/vms-crt0-64.c: New files.
	* config/alpha/vms-psxcrt0-64.c, config/alpha/vms64.h: Likewise.
	* config/alpha/xm-vms64.h: Likewise.

	* config/alpha/alpha.c (vms_attribute_table): Add new attributes.
	(alpha_write_linkage): Test for null alpha_links.
	(SECTION_VMS_GLOBAL, SECTION_VMS_INITIALIZE): New section attributes.
	(vms_section_type_flags, vms_asm_named_section): Handle them.

Fri Dec 14 12:05:14 CET 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_fpmath, ix86_fpmath_string): New.
	(override_option): Set ix86_fpmath.
	* i386.h (MASK_MIX_SSE_I387): Remove.
	(TARGET_SSE_MATH): New.
	(TARGET_MIX_SSE_I387): Use ix86_fpmath.
	(TARGET_SWITCHES): Remove "mix-sse-i387".
	(fpmath_unit): New enum.
	(ix86_fpmath, ix86_fpmath_string): Declare.
	* i386.md (swapsf): Fix condition.
	(add?f, sub?f, mul?f, div?f, sqrt?f, min?f): Use TARGET_SSE_MATH.
	(fp_?f_*_nosse): New.
	(fp_*): Use TARGET_SSE_MATH.
	* invoke.texi (-mfpmath): Document.
	(-msse2): Add.

2001-12-14  Jason Merrill  <jason@redhat.com>

	* dwarf2out.c (output_die): Print the string in the comment for
	a DW_FORM_strp.

2001-12-14  Richard Earnshaw  <rearnsha@arm.com>

	* netbsd.h (COLLECT_SHARED_INIT_FUNC)
	(COLLECT_SHARD_FINI_FUNC): Remove redundant semicolon.
	* doc/tm.texi (COLLECT_SHARED_INIT_FUNC)
	(COLLECT_SHARD_FINI_FUNC): Use @code where appropriate.

2001-12-13  Richard Henderson  <rth@redhat.com>

	* regrename.c (kill_value_regno): Simplify chain removal.
	(kill_value): Kill all of HARD_REGNO_NREGS.
	(kill_set_value): Use kill_value not kill_value_regno.
	(kill_autoinc_value): Likewise.
	(copyprop_hardreg_forward): Don't collect refresh_blocks.
	Call delete_noop_moves.

2001-12-13  Aldy Hernandez  <aldyh@redhat.com>

	* attribs.c (c_common_attribute_table): Swap decl_req and type_req
	for the mode attribute.
	(handle_mode_attribute): Handle types, not decls.

2001-12-13  Jason Merrill  <jason@redhat.com>

	* c-common.h (COMPOUND_STMT_BODY_BLOCK): New macro.

2001-12-13  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.md (eh_set_lr_di): Change scratch
	constraint to base register.
	(eh_set_lr_si): Same.

2001-12-13  Hans-Peter Nilsson  <hp@axis.com>

	* expr.c (expand_expr, case ADDR_EXPR): Don't honor
	flag_force_addr for modifier != EXPAND_CONST_ADDRESS,
	modifier != EXPAND_INITIALIZER and modifier != EXPAND_SUM.

Thu Dec 13 20:30:08 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (copy_blkmode_from_reg): Add missing braces to eliminate
	warning and reformat comments.
	(expand_assignment): Don't pass EXPAND_WRITE if LHS is component.
	(highest_pow2_factor, case INTEGER_CST): Return BIGGEST_ALIGNMENT
	if overflow.

2001-12-12  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (rs6000_override_options): Add
	SUBSUBTARGET_OVERRIDE_OPTIONS.

	* config/rs6000/eabialtivec.h: New file.

	* config/rs6000/linuxaltivec.h: New file.

	* config.gcc: Add powerpc-*-eabialtivec and
	powerpc-*-linux-gnualtivec.

2001-12-13  Neil Booth  <neil@daikokuya.demon.co.uk>

	* toplev.c (process_options, parse_options_and_default_flags):
	Set flag_no_inline before the post_options hook.

2001-12-13  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (adjust_address_1): Don't adjust address if adjust
	is false.

2001-12-13  Richard Earnshaw  <rearnsha@arm.com>

	* collect2.c (COLLECT_SHARED_INIT_FUNC)
	(COLLECT_SHARD_FINI_FUNC): Define default values.
	(write_c_file_stat): Use them to call construtor and destructor
	functions in shared libraries.
	* doc/tm.texi (COLLECT_SHARED_INIT_FUNC)
	(COLLECT_SHARD_FINI_FUNC): Document them.
	* config/netbsd.h (COLLECT_SHARED_INIT_FUNC)
	(COLLECT_SHARD_FINI_FUNC): Define.

	* config/netbsd.h (LINK_SPEC): Don't pull in estart if creating a
	shared library.  Pass -shared through to the linker.
	* config/arm/netbsd.h (LINK_SPEC): Likewise.

	* config/arm/t-netbsd (TARGET_LIBGCC2_CFLAGS): Add -fpic.
	(SHLIB_EXT, SHLIB_NAME, SHLIB_SONAME, SHLIB_OBJS, SHLIB_LINK)
	(SHLIB_INSTALL): Define.

2001-12-13  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (legitimize_pic_address): Handle LABEL_REFs in substantially
	the same way as we handle SYMBOL_REFS.

Thu Dec 13 07:47:24 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* loop.c (remove_constant_addition): Fix prototype and whitespace.
	(emit_prefetch_instructions): Remove warnings and whitespace
	changes.

Thu Dec 13 06:48:38 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/vms-cc.c (preprocess_args): Fix forward
	declaration.

Thu Dec 13 12:31:07 CET 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (estimate_probability): Reorganize opcode heuristics.
	* predict.def (PRED_OPCODE_POSITIVE, PRED_OPCODE_NONEQUAL,
	PRED_FPOPCODE): New.

	* i386.c (override_options): Recognize various CPU variants and set
	SSE/MMX/3dNOW flags accordingly.
	* i386.h (MASK_MMX_SET, MASK_SSE_SET, MASK_SSE2_SET, MASK_3DNOW_SET,
	MASK_3DNOW_A_SET): New.
	(MASK_ACCUMULATE_OUTGOING_ARGS_SET): New.
	(MASK_NO_ACCUMULATE_OUTGOING_ARGS): Delete.
	(MASK_*): Renumber.
	(TARGET_FLAGS): Use new masks.
	(CPP_CPU_SPECS): Recognize new CPU variants.
	* invoke.texi (-mcpu): Update documentation.

	* flags.h (flag_prefetch_loop_arrays): Declare.
	* loop.h (LOOP_PREFETCH): Define new constant.
	* loop.c (strength_reduce): Call emit_prefetch_instructions.
	(MAX_PREFETCHES, PREFETCH_BLOCKS_BEFORE_LOOP_MAX,
	PREFETCH_BLOCKS_BEFORE_LOOP_MIN, PREFETCH_BLOCKS_IN_LOOP_MIN): New
	constants.
	(check_store_data): New structure.
	(check_store, emit_prefetch_instructions, rtx_equal_for_prefetch_p):
	New functions.
	* toplev.c: Include insn-flags.h.
	(flag_prefetch_loop_arrays): New global variable.
	(lang_independent_option): Add -fprefetch-loop-arrays.
	(rest_of_compilation) Pass LOOP_PREFETCH when flag_prefetch_loop_arrays
	is set.
	* Makefile.in (toplev.c): Depend on insn-flags.h.
	* invoke.texi (-fprefetch-loop-arrays): Document.

	* predict.c (estimate_probability): Distribute the loop exit
	probability according to number of exit edges.

	* cfgcleanup.c (insns_match_p): Break out from ...;
	(flow_find_cross_jump): ... here;
	(outgoing_edges_match): Add parameter MODE; attempt to match everything
	except for tablejumps.
	(try_crossjump_to_edge): Accept complex edges.
	(try_crossjump_bb): Likewise.

2001-11-29  Corey Minyard <minyard@acm.org>

	* recog.c (validate_replace_rtx_1): Use simplify_gen_binary
	instead of plus_constant.
	* simplify-rtx.c (neg_const_int): New.
	(simplify_gen_binary, simplify_plus_minus): Use it.

2001-12-12  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_builtin_memset, expand_builtin_memcpy,
	expand_builtin_strcpy): Additional arguments TARGET and MODE.
	(expand_builtin_bzero, expand_builtin_strcpy,
	expand_builtin_strncpy, expand_builtin_bzero): Pass additional
	TARGET and MODE parameters to the above functions.
	(expand_builtin_memset, expand_builtin_memcpy): Optimize the
	case where the LEN parameter is constant zero.
	(expand_builtin_memcmp): No longer conditional on
	HAVE_cmpstrsi.  Take an additional mode parameter.  Optimize
	the cases where len is either constant zero or one.
	Optimize to call to memcpy, even if the memcpy isn't inlined.
	(expand_builtin_strncpy): Optimize to call memcpy, even if the
	memcpy isn't inlined.
	(expand_builtin_strcmp, expand_builtin_strncmp): Always attempt
	to optimize to a call to memcmp.
	(expand_builtin): expand_builtin_memcmp can always be called,
	and pass the required parameters to expand_builtin_memcmp,
	expand_builtin_memset, expand_builtin_memcpy and
	expand_builtin_strcpy.

2001-12-12  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (arm-*-freebsd*): Add target.
	* config/arm/freebsd.h: New file.
	* config/arm/arm.h (CPP_PREDEFINES): Do not define.
	(CPP_SPEC): #undef before defining.
	(CPP_CPU_ARCH_SPEC): Add -Acpu=arm -Amachine=arm.
	* config/arm/conix-elf.h (CPP_PREDEFINES): Remove -Acpu=arm
	-Amachine=arm.
	* config/arm/linux-elf.h: Likewise.
	* config/arm/netbsd.h: Likewise.
	* config/arm/riscix.h: Likewise.
	* config/arm/riscix1-1.h: Likewise.
	* config/arm/semiaof.h: Likewise.

2001-12-12  Richard Henderson  <rth@redhat.com>

	* regrename.c (copyprop_hardreg_forward): New optimization.
	(kill_value_regno, kill_value, init_value_data, kill_clobbered_value,
	kill_set_value, kill_autoinc_value, copy_value, find_oldest_value_reg,
	replace_oldest_value_reg, replace_oldest_value_addr,
	replace_oldest_value_mem, copyprop_hardreg_forward_1,
	debug_value_data, validate_value_data): New.
	* rtl.h (copyprop_hardreg_forward): Declare.
	* toplev.c (flag_cprop_registers): New.
	(f_options): Add -fcprop-registers
	(rest_of_compilation): Invoke it.
	(parse_options_and_default_flags): Set it at -O1.
	* doc/invoke.texi: Document it.

2001-12-12  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (dw_val_class): Add dw_val_class_range_list.
	(DEBUG_RANGES_SECTION_LABEL): Define.
	(ranges_section_label): Add.
	(add_AT_range_list): New.
	(print_die, sizeof_die, value_format): Handle dw_val_class_range_list.
	(output_loc_list): Location expression length is always 2-byte.
	(output_die): Handle dw_val_class_range_list.
	(gen_lexical_block_die): Call add_AT_range_list.
	(dwarf2out_init): Initialize ranges_section_label.
	(dwarf2out_finish): Emit ranges_section_label.

2001-12-12  Jakub Jelinek  <jakub@redhat.com>

	* c-typeck.c (digest_init): Allow initializing
	static storage duration objects with compound literals.
	* doc/extend.texi (Compound literals): Document the extension.

2001-12-12  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (adjust_address_1): Always copy address to avoid
	shared rtl.

Wed Dec 12 07:37:52 2001  Olivier Hainque <hainque@act-europe.fr>

	* stmt.c (expand_end_case): Do subtraction of lower bound as trees
	to avoid overflow.

Wed Dec 12 07:35:24 2001  Douglas B. Rupp  <rupp@gnat.com>

	* cppfiles.c (read_include_file): Set buffer size properly when
	file is shorter than expected.

Wed Dec 12 08:35:33 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* objc/objc-act.c (encode_complete_bitfield): Fixed encoding
	enumeral types - encode them using 'i'.

2001-12-12  Nathan Sidwell  <nathan@codesourcery.com>

	* doc/extend.texi (Deprecated Features): Deprecate implicit
	typename. Document that named return and initializer lists are now
	removed.

2001-12-11  Roger Sayle <roger@eyesopen.com>

	* except.c (reachable_next_level): Handle ERT_UNKNOWN to avoid
	compiler warning about enumeration values not being handled.

2001-12-11  Momchil Velikov  <velco@fadata.bg>

	* config/fp-bit.c (pack_d): Cast to ``fractype'' for long long
	shifts.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.h (TARGET_FIXUP_EV5_PREFETCH): New.
	* config/alpha/linux.h (TARGET_FIXUP_EV5_PREFETCH): New.
	* config/alpha/alpha.md (prefetch): New.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* combine.c (simplify_and_const_int): Simplify (AND (PLUS X Y) C)
	if C has only low bits set and doesn't intersect with X or Y.

Tue Dec 11 23:58:39 EST 2001  John Wehle  (john@feith.com)

	* basic-block.h (flow_preorder_transversal_compute): Declare.
	* cfganal.c (flow_preorder_transversal_compute): Implement.

Tue Dec 11 23:54:27 EST 2001  John Wehle  (john@feith.com)

	* cfganal.c (flow_depth_first_order_compute): Always
	increment dfsnum.

2001-11-30 Alan Matsuoka <alanm@redhat.com>

	* combine.c (combine_simplify_rtx) : Can't simplify
	cases that use mode class MODE_CC.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* expmed.c (expand_divmod): Ignore sdiv_pow2_cheap for modes in
	which there is no divide expander.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* except.c (sjlj_find_directly_reachable_regions): Don't
	consider RNL_BLOCKED a directly reachable region.
	(sjlj_assign_call_site_values): Trust directly_reachable.
	(sjlj_emit_dispatch_table): Likewise.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (divmodsi_internal_er): Split, so that
	we represent the address load's dependency on the gp.
	(divmoddi_internal_er): Likewise.
	(divmodsi_internal_er_1, divmoddi_internal_er_1): New.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (widen_memory_access): New.
	* expr.h (widen_memory_access): Declare it.
	* config/alpha/alpha.c (get_aligned_mem): Use it.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* combine.c (simplify_shift_const): Move SHIFT_COUNT_TRUNCATED
	simplification above out of range check.

2001-12-11  Dan Nicolaescu  <dann@ics.uci.edu>

	* config/sparc/sparc.md (prefetch): New.

2001-12-11  Aldy Hernandez  <aldyh@redhat.com>

	* output.h (regno_uninitialized): Make argument unsigned.

	* flow.c (regno_uninitialized): Make regno unsigned.

2001-12-11  David O'Brien  <obrien@FreeBSD.org>

	* elfos.h (ENDFILE_SPEC, STARTFILE_SPEC): Do not define.
	* config/cris/cris.h (ENDFILE_SPEC): Define.
	* config/i386/i386elf.h ((ENDFILE_SPEC, STARTFILE_SPEC): Define.
	* config/pa/elf.h: Likewise.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* objc/objc-act.c (build_string_class_template): New.
	(build_objc_string_object): Call it.

2001-12-11  Steve Ellcey  <sje@cup.hp.com>

	* doc/tm.texi (FUNCTION_ARG_REG_LITTLE_ENDIAN): New.
	* defaults.h (FUNCTION_ARG_REG_LITTLE_ENDIAN): New.
	* calls.c (store_unaligned_arguments_into_pseudos): Check
	FUNCTION_ARG_REG_LITTLE_ENDIAN to see how structures
	are passed/returned.
	* expr.c (move_block_from_reg): Ditto.
	(move_block_from_reg): Ditto.
	(copy_blkmode_from_reg): Ditto.
	* stmt.c (expand_return): Ditto.
	* stor-layout.c (compute_record_mode): If
	FUNCTION_ARG_REG_LITTLE_ENDIAN is set then check
	MEMBER_TYPE_FORCES_BLK even if mode == VOIDmode.
	* config/ia64/hpux.h (MEMBER_TYPE_FORCES_BLK): Set to true
	so that Structures of one field are still treated as structures.
	(FUNCTION_ARG_REG_LITTLE_ENDIAN): New, set it to true.
	(FUNCTION_ARG_PADDING): Set to ia64_hpux_function_arg_padding().
	(PAD_VARARGS_DOWN): Modify from default to not pad structures down.
	* config/ia64/ia64-protos.h (ia64_hpux_function_arg_padding): New.
	* config/ia64/ia64.c (ia64_hpux_function_arg_padding): New function
	to special case handling of structure padding.

2001-12-11  Daniel Berlin  <dan@cgsoftware.com>

	* sched-rgn.c (CONST_BASED_ADDRESS_P): CONST_INT -> CONSTANT_P.
	(may_trap_exp): Stores only are risk if they trap, too, not just
	if code == MEM.

2001-12-11  Aldy Hernandez  <aldyh@redhat.com>

	* flow.c (find_regno_partial): Indent properly.  Add a default to
	switch.

2001-12-11  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-common.c (combine_strings): Complain if concatenating
	__FUNCTION__.
	* c-parse.in (yylexname): Flag artificial strings.
	* tree.h (TREE_ARTIFICIAL_STRING_P): New.
doc:
	* extend.texi: Update.

2001-12-11  Aldy Hernandez  <aldyh@redhat.com>

	* c-common.c (type_for_mode): Handle unsigned vectors.
	(type_for_mode): Remove redundant calls to TYPE_MODE.

	* tree.c (make_vector): New.
	(build_common_tree_nodes_2): Use make_vector for vector types.
	Add unsigned vector types.

	* tree.h (tree_index): Add unsigned types for vectors.
	(unsigned_V16QI_type_node): New.
	(unsigned_V4SI_type_node): New.
	(unsigned_V8QI_type_node): New.
	(unsigned_V8HI_type_node): New.
	(unsigned_V4HI_type_node): New.
	(unsigned_V2SI_type_node): New.

2001-12-11  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (finish_message_expr): Fix misplaced parens in a
	test of class names.

2001-12-11  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (m68020-*-elf*): Expand tm_file to include all needed
	cpu configuration headers.
	* config/h8300/elf.h: Include dbxelf.h.
	* config/m68k/linux.h: Likewise.
	* config/m68k/m68020-elf.h: Likewise.
	* config/m68k/m68kv4.h: Likewise.
	* config/sh/elf.h: Likewise.
	* config/m68k/m68kemb.h: Add comment about the its purpose.

2001-12-11  Richard Henderson  <rth@redhat.com>

	* objc/objc-act.c (build_constructor): Cast initializer values
	to the proper field types.

2001-12-11  Jakub Jelinek  <jakub@redhat.com>

	* unwind-dw2.c (execute_cfa_program): Fix DW_CFA_restore handling.

2001-12-10  Roger Sayle <roger@eyesopen.com>

	* builtins.c (expand_builtin): Use a switch statement to list
	those functions not expanded without optimizations, instead of a
	series of equality tests.

Tue Dec 11 07:08:57 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/vms.h (LIB_SPEC): Define.
	* config/alpha/xm-vms.h (INCLUDE_DEFAULTS): Don't set component field.

	* libgcc2.c (_bb): Remove ctime declaration.

	* Makefile.in (stage[1234]-start): $(LN_S) utilities in a manner
	that works if LN_S = cp.

	* config/alpha/x-vms (version): Change "." to "_".

	* configure.in: Hardcode that vfork works on VMS host.
	* configure: Regenerated.

Mon Dec 10 18:37:31 2001  Douglas B. Rupp  <rupp@gnat.com>

	* gcc.c (convert_filename): Add do_obj parameter. Don't convert
	unless do_obj true.
	(process_command): Modify calls to convert_filename.

2001-12-11  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/sparc/sol2-sld-64.h: Include dbxelf.h again.

Mon Dec 10 15:54:27 2001  Jeffrey A Law  (law@cygnus.com)

	* combine.c (known_cond): Check mode of each operand to determine
	if COND is comparing floating point values.

2001-12-10  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.h (processor_type): Add PPC405.
	(RTX_COSTS): Add PPC405.  Correct rs64 and ppc630 multiply costs.
	* rs6000.md: Add PPC405 information.  Utilize imul2 and imul3 for
	rios1, rs64, and ppc630 processors.
	* rs6000.c (processor_target_table): Add PPC405.

2001-12-10  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (unaligned_extendhidi): Call gen_lowpart
	instead of hardcoding subregs into the _be and _le patterns.

2001-12-10  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c, c-parse.in, c-typeck.c: Revert concatenation changes.

Mon Dec 10 09:19:11 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/i386/i386.md (leave, leave_rex64): Adjust pattern to match
	what insn does.

2001-12-10  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/cpp.texi: Don't condition menus on @ifinfo.  Condition the
	copyright notice formerly conditioned on @ifinfo on @ifnottex
	instead.

Mon Dec 10 06:15:44 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* vmsdbgout.c (lookup_filename): Remove warning.

Mon Dec 10 06:09:57 2001  Douglas B. Rupp  <rupp@gnat.com>

	* Makefile.in: Add $(OUTPUT_OPTION) to compilation rules.

	* config.gcc (alpha*-dec-vms*): Change to alpha*-dec-*vms*
	(exeext, target_alias, prefix, local_prefix): Define.
	* config/alpha/x-vms (USE_COLLECT2): Make empty.
	* config/alpha/xm-vms.h (INCLUDE_DEFAULTS): Use Unix style
	file specifications. Remove ".".
	(GCC_INCLUDE_DIR): Remove redefinition (redundant).
	* fixinc/mkfixinc.sh (alpha*-dec-vms*):  Change to alpha*-dec-*vms*

2001-12-09  Nathan Sidwell  <nathan@codesourcery.com>

	* Makefile.in (.po.gmo): Use POSIXLY_CORRECT argument ordering.

Sun Dec  9 21:57:24 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/t-vms (EXTRA_PARTS): Append $(VMS_EXTRA_PARTS)
	Add rules for building [vp]crt0.o
	* config/alpha/vms.h (START_FILE_SPEC): Define.
	* config/alpha/x-vms (VMS_EXTRA_PARTS): Define
	* config/alpha/vms-crt0.c, config/alpha/vms-psxcrt0.c: New files.
	* doc/invoke.texi: Document special Alpha/VMS options.

Sun Dec  9 20:25:17 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* hwint.h (HOST_BITS_PER_LONGLONG): Deal with __int64 type.
	* vmsdbg.h (DST_SRC_COMMAND): Test for type of long long or __int64,
	not GNUC.

Sun Dec  9 20:19:32 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>
			  Douglas B. Rupp  <rupp@gnat.com>

	* tree.c (append_random_char): Conditionalize INO for VMS.

2001-12-09  Richard Henderson  <rth@redhat.com>

	* cfgcleanup.c (label_is_jump_target_p): New function.
	(try_optimize_cfg): Use label_is_jump_target_p to check if label is
	target of a JUMP_INSN from the preceding block.

Sun Dec  9 18:40:07 2001  Douglas B. Rupp  <rupp@gnat.com>

	* vmsdbgout.c (lookup_filename): Assign null string instead
	of null pointer to fnam.

2001-12-09  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_align_insns): Suppress realignment
	immediately after a call; insert nops before a call.

2001-12-09  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_align_insns): Use align_functions,
	not FUNCTION_BOUNDARY.
	* config/alpha/alpha.h (TRAMPOLINE_ALIGNMENT): New.
	* config/alpha/alpha32.h, config/alpha/vms.h: Likewise.
	* config/alpha/unicosmk.h (FUNCTION_BOUNDARY): Remove.

2001-12-09  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/mmix/mmix.c (mmix_function_block_profiler,
	mmix_block_profiler, mmix_function_block_profiler_exit): Delete
	unused functions.
	* config/mmix/mmix-protos.h (mmix_function_block_profiler,
	mmix_block_profiler, mmix_function_block_profiler_exit): Delete
	prototypes.

	* config/cris/cris.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER):
	Delete obsoleted macros.

2001-12-09  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/cpp.texi, doc/cppinternals.texi, doc/invoke.texi,
	doc/md.texi, doc/rtl.texi, doc/tm.texi: Use American spelling.

	* ChangeLog.2, ChangeLog.3, ChangeLog.5, ChangeLog, alias.c,
	cfgbuild.c, expmed.c, expr.c, final.c, flow.c, fold-const.c,
	function.c, config/alpha/alpha.md, config/alpha/vms-ld.c,
	config/arm/arm.c, config/arm/arm.h, config/c4x/libgcc.S,
	config/i370/i370.c, config/i386/i386.c,
	config/i386/i386-interix.h, config/i386/i386.md,
	config/i386/i386.h, config/i386/netbsd-elf.h, config/ia64/ia64.c,
	config/m32r/m32r-protos.h, config/mcore/mcore.h,
	config/rs6000/rs6000.h, config/sparc/linux64.h,
	config/sparc/sparc.c, config/v850/v850-protos.h,
	config/cris/cris.h, config/s390/s390.md, config/elfos.h: Fix
	spelling errors.

2001-12-09  Daniel Berlin  <dan@cgsoftware.com>

	* config/rs6000/rs6000.h (enum rs6000_builtins): Add remaining
	altivec builtins (VCF?X, VCT?XS, VSEL, V*EFP, VRFI*).

	* config/rs6000/rs6000.c: Ditto.

	* config/rs6000/rs6000.md: Ditto.

2001-12-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* 1750a.md: Add default case in switch.
	* alpha/vms.h (INITIAL_ELIMINATION_OFFSET): Add abort clause in
	if-else statement.
	* dsp16xx.c (print_operand_address): Likewise.
	* i386/osf1elf.h (FUNCTION_PROFILER): Const-ify.
	* ia64.md: Add missing braces.
	* rs6000-protos.h (s8bit_cint_operand): Prototype.
	* s390.h (INITIAL_ELIMINATION_OFFSET): Add abort clause in
	if-else statement.
	* stormy16.h (REG_CLASS_CONTENTS): Add missing braces.
	* v850.h (OUTPUT_ADDR_CONST_EXTRA): Don't issue a `return'.
	* dbxout.c (dbxout_source_file): Move a variable into the scope
	where it is used.
	* final.c (profile_function): Mark parameter with
	ATTRIBUTE_UNUSED.
	* genemit.c (gen_expand): Likewise for generated file.
	* insn-addr.h (INSN_ADDRESSES_NEW): Avoid undefined behavior.

	* vmsdbg.h: Delete spurious close-comment.
	(DST_HEADER): Fix typo in ENUM_BITFIELD parameter.
	* vmsdbgout.c (write_modbeg): Define return type.

	* m68k/3b1.h (ASM_OUTPUT_ALIGN): Wrap in do-while(0).
	* m68k/amix.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* m68k/atari.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* m68k/hp320.h (ASM_OUTPUT_ALIGN): Likewise.
	* m68k/m68kelf.h (ASM_OUTPUT_ALIGN): Likewise.
	* m68k/sgs.h (ASM_OUTPUT_ALIGN): Likewise.
	* m68k/tower-as.h (ASM_OUTPUT_ALIGN): Likewise.

2001-12-08  Tom Rix  <trix@redhat.com>

	* config/rs6000/aix43.h (NON_POWERPC_MASKS): Delete MASK_STRING.
	* config/rs6000/aix51.h (NON_POWERPC_MASKS): Same.
	* config/rs6000/rs6000.md (load_multiple, store_multiple): Do not use
	for powerpc64.
	* config/rs6000/rs6000.md (movstrsi_8reg, movstrsi_6reg,
	movstrsi_4reg, movstrsi_1_reg): Add powerpc64.
	* config/rs6000/rs6000.c (expand_block_move): Do not use
	gen_movstrsi_2reg and powerpc64.

2001-10-08  Aldy Hernandez  <aldyh@redhat.com>

	* c-common.h (rid): Add RID_CHOOSE_EXPR and
	RID_TYPES_COMPATIBLE_P.

	* c-parse.in (reswords): Add __builtin_choose_expr.
	Add __builtin_types_compatible_p.
	Add CHOOSE_EXPR token.
	Add TYPES_COMPATIBLE_P token.
	Add production for CHOOSE_EXPR.
	Add production for TYPES_COMPATIBLE_P.

	* doc/extend.texi (__builtin_choose_expr): Add documentation.
	(__builtin_types_compatible_p): Likewise.

2001-12-08  David Edelsohn  <edelsohn@gnu.org>

	* stor-layout.c (place_union_field): Apply ADJUST_FIELD_ALIGN
	to unions.

2001-12-08  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-parse.in: Take string literals in assembler constructs,
	not expressions.
	* c-typeck.c (build_asm_stmt, simple_asm_stmt): No need to
	check the strings are STRING_CSTs.

2001-12-08  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c (c_lex): Peek a token ahead for a string to concatenate,
	using combine_strings to do the concatenation.
	* c-parse.in: Replace uses of the string non-terminal with STRING.
	Don't attempt string concatenation.
	(OBJC_STRING): New terminal.
	(string): Remove non-terminal.
	(_yylex): Call combine_strings on function names.  Generate
	OBJC_STRING terminals; don't pass '@' on to yacc.
	* c-typeck.c (simple_asm_stmt): Don't concatenate strings here.
	(build_asm_stmt): Similarly.

2001-12-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* rtlanal.c (get_jump_table_offset): Delete unused variable.

2001-12-08  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (VUNSPEC_PREFETCH): Delete constant definition.
	(prefetch): Rewrite using PREFETCH RTL primitive.
	* arm.h (arm_builtins): Delete ARM_BUILTIN_PREFETCH).
	* arm.c (arm_init_builtins): Don't initialize a builtin for
	__builtin_prefetch here.
	(arm_expand_builtin): Don't expand __builtin_prefetch here.

2001-12-08  Richard Earnshaw  <rearnsha@arm.com>

	* final.c (cleanup_subreg_operands):  Use recog_data.operand_loc
	in test for a subreg.

2001-12-08  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* rtl.c (rtx_equal_p): Check for null pointers when comparing rtx
	strings.

2001-12-07  Richard Henderson  <rth@redhat.com>

	* doc/extend.texi: Fix typo last change.

	* c-decl.c (c_language): Remove duplicate.

2001-12-07  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/darwin.h: Set MAX_LONG_TYPE_SIZE to 32.
	* config/rs6000/rs6000.c (rs6000_emit_move): In Darwin-
	specific codegen, eliminate a register copy.
	(print_operand_address): Add support for Darwin's lo16(constant)
	syntax.
	(rs6000_machopic_legitimize_pic_address): Fix darwin-specific
	generation of addresses within very large data objects.
	(s8bit_cint_operand):  New.
	* config/rs6000/rs6000.md: Remove "iu" reference for 750/7400.
	Move "mtjmpr" to correct functional unit for 750/7400/7450.
	Add imul2 and imul3 insn types for multiplication by 16- and
	8-bit constants.
	Change tablejump patterns to strongly discourage using LR
	rather than CTR.
	Add %lo16 patterns for Darwin loads and stores.

2001-12-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.md: Use (HOST_WIDE_INT)1<<63 in lieu of 0x8000000000000000.

2001-12-07  Stephane Carrez  <Stephane.Carrez@sun.com>

	* config/sparc/sparc.c (epilogue_renumber): Do not replace %fp
	with %sp because it can cause the delayed instruction to load
	below the stack.

2001-12-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.c (alpha_expand_unaligned_store,
	alpha_expand_unaligned_store_words): Use constm1_rtx in place of
	call to immed_double_const.

2001-12-07  Aldy Hernandez  <aldyh@redhat.com>

	* doc/extend.texi (Variable Attributes): Document vector_size.

	* attribs.c (c_common_attribute_table): Add vector_size.
	(handle_vector_size_attribute): New.
	(vector_size_helper): New.
	(decl_attributes): Relayout the decl after calculating attribs.

2001-12-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Don't include install-old.texi.  Adjust menu
	description for Trouble section.
	* doc/install-old.texi: Adjust for inclusion as chapter of new
	installation manual.
	* doc/install.texi, doc/include/fdl.texi, doc/install.texi2html:
	Adjust to include old installation chapter as chapter of new
	installation manual.

Fri Dec  7 11:07:35 EST 2001  John Wehle  (john@feith.com)

	* rtl.h (get_jump_table_offset): Declare.
	* rtlanal.c (get_jump_table_offset): Implement.

Fri Dec  7 07:06:17 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* final.c (bb_head, bb_tail, bb_file_label_num, bb_func_label_num):
	Deleted; were used only by BB profiler code.
	(sbb_head, sbb_tail, sbb_label_num): Likewise.
	(end_final): Delete now-unused vars I, PTR, and SPTR.

	* expr.c (store_field): Remove warning.
	(expand_expr, case COMPONENT_REF, case VIEW_CONVERT_EXPR): Likewise.
	(highest_pow2_factor, case MIN_EXPR, case MAX_EXPR): Add cases.
	(highest_pow2_factor, case *_DIV_EXPR): Only can do something if
	divisor constant power of 2.
	(highest_pow2_factor, case COMPOUND_EXPR): Look at operand 1.

2001-12-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.c (function_arg): Cast value to HOST_WIDE_INT before
	shifting.

2001-12-06  Aldy Hernandez  <aldyh@redhat.com>

	* rs6000.h (PRE_GCC3_DWARF_FRAME_REGISTERS): New.
	(DWARF_FRAME_REGISTERS): Delete.

2001-12-06  Janis Johnson  <janis187@us.ibm.com>

	* builtin-types.def (BT_FN_VOID_PTR_VAR): New.
	* builtins.def (BUILT_IN_PREFETCH): Change arguments.
	* builtins.c (expand_builtin_prefetch): Two arguments are now optional,
	with defaults for read prefetch with high degree of locality.
	* doc/extend.texi (__builtin_prefetch): Update documentation.
	* doc/md.texi (prefetch): Add documentation.

2001-12-06  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (stdio_va_list): Handle __VA_LIST__ in Tru64
	UNIX V5.1A stdio.h.
	* fixinc/fixincl.x: Regenerate.
	Fixes PR libf2c/4826.

2001-12-06  Aldy Hernandez  <aldyh@redhat.com>
	    Richard Henderson  <rth@redhat.com>

	* doc/tm.texi (DWARF_FRAME_REGISTERS): Add documentation.
	(PRE_GCC3_DWARF_FRAME_REGISTERS): Same.

	* unwind-dw2.c (__frame_state_for): Change DWARF_FRAME_REGISTERS
	to PRE_GCC3_DWARF_FRAME_REGISTERS.
	(frame_state): Same.
	(PRE_GCC3_DWARF_FRAME_REGISTERS): Define if not already defined.

2001-12-06  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* langhooks.c (lhd_staticp): Mark parameter with
	ATTRIBUTE_UNUSED.

2001-12-06  H.J. Lu <hjl@gnu.org>

	* Makefile.in (.po.gmo): Use "-test -d po || mkdir po" to
	reduce noise.
	(.po.pox): Likewise.
	(o/$(PACKAGE).pot): Likewise.

2001-12-06  Alexandre Oliva  <aoliva@redhat.com>

	* tree.c (get_callee_fndecl): Move DECL_ABSTRACT_ORIGIN-following...
	* tree-inline.c (expand_call_inline): ... here.

2001-12-06  H.J. Lu <hjl@gnu.org>

	* Makefile.in (.po.gmo): Use "-mkdir po" for parallel build.
	(.po.pox): Likewise.
	(o/$(PACKAGE).pot): Likewise.

2001-12-06  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc: Include dbxelf.h before elfos.h.
	* elfos.h: Don't include dbxelf.h, let config.gcc handle it.

2001-12-06  Zack Weinberg  <zack@codesourcery.com>

	* cppfiles.c (open_file): If we've opened a directory by
	mistake, close it.
	(find_include_file): Avoid turning / into // or // into ///.

2001-12-06  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.h (STRUCT_VALUE): Suppress definition.
	(STRUCT_VALUE_REGNUM): Restore definition.

2001-12-06  Andrew MacLeod <amacleod@redhat.com>

	* flow.c (find_regno_partial): Return register, not the expression
	the register is in.

Thu Dec  6 09:24:12 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (handle_epilogue_set): Check for FP setting case when
	SP is set from FP in same insn.

2001-12-06  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (load_multiple_sequence): Pass pointer to
	RTX when calling alter_subreg().
	(store_multiple_sequence): Pass pointer to RTX when calling
	alter_subreg().

Thu Dec  6 06:55:13 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (assing_parms): Fix typo in last change.
	* config/clipper.c (clipper_builtin_saveregs): Remove Checker code.
	* config/m88k/m88k.c (m88k_builtin_saveregs): Likewise.
	* config/pa/pa.c (hppa_builtin_saveregs): Likewise.
	* config/sparc/sparc.c (sparc_builtin_saveregs): Likewise.

2001-12-06  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_unique_section): Simplify and
	correct code selecting section.

Thu Dec  6 12:45:33 CET 2001  Jan Hubicka  <jh@suse.cz>

	* final.c (count_basic_block, add_bb, add_bb_string):
	Kill.
	(end_final, final_start_function, final, final_scan_insn,
	leaf_function_p): Kill BB profiler related code.
	* flags.h (profile_block_flag): Kill.
	* libgcc2.c (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE,
	BB_BUCKETS, BBINBUFSIZE, bb_edge, bb_func_mode, bb_func,
	__bb, bb_src, bb_dst, bb_tracefile, bb_hashbuckets,
	bb_func_head, bb_callcount, bb_mode, bb_stack, bb_stacksize
	reported, GOPENDECOMPRESS, GOPENCOMPRESS, gopen, gclose,
	__bb_exit_trace_func, __bb_init_prg, __bb_trace_func,
	__bb_trace_func_ret, __bb_init_file, __bb_trace_ret,
	__bb_init_trace_func): Kill.
	* toplev.c (profile_block_flag): Kill.
	(indepdendent_decode_option, process_options): Kill -a related code.
	* alpha.c (direct_call_operand): Likewise.
	* arm.c (arm_expand_prologue, thumb_expand_prologue,
	thumb_expand_epilogue): Likewise.
	* c4x.c (c4x_expand_prologue, c4x_null_epilogue_p): Likewise.
	* c4x.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* d30v.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* fr30.c (fr30_expand_prologue): Kill BB profiler related code.
	* i386.c (ix86_can_use_return_insn_p, ix86_expand_prologue,
	ix86_expand_epilogue, ix86_expand_epilogue): Kill BB profiler related
	code.
	(ix86_output_function_block_profiler, ix86_output_block_profiler): Kill.
	* i386.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* fr30.c (fr30_expand_prologue): Kill BB profiler related code.
	* i960.c (i960_output_function_prologue): Kill BB profiler related
	code.
	* ia64.c (ia64_compute_frame_size): Likewise.
	* ia64.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* m32r.c (m32r_expand_prolofue): Kill BB profiler related code.
	* m68hc11.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* m68k.c (m68k_output_function_epilogue): Kill BB profiler related code.
	* m68k.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* m88k.c (output_options, m88k_layout_frame, m88k_expand_prologue):
	Kill BB profiler related code.
	* m88k.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* mips.c (mips_expand_prologue): Kill BB profiler related code.
	* mmix.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* rs6000.c (rs6000_override_options): Kill BB profiler related code.
	* s960.c (s390_function_prologue): Kill BB profiler related code.
	* s960.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* linux-aout.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Kill.
	* linux.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Kill.
	* linux64.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Kill.
	* sol2.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Kill.
	* sparc.c (sparc_override_options, eligible_for_sibcall_delay,
	sparc_nonflat_function_epilogue): Kill BB profiler related code.
	(sparc_function_block_profiler, sparc_block_profiler,
	sparc_function_block_profiler_exit): Kill.
	* sparc.h (OVERRIDE_OPTIONS): Kill BB profiler related code.
	(FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* sun4o3.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Kill.
	* sunos4.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Kill.
	* stormy16.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.
	* doc/invoke.texi: Kill documentation of -a and -ax.
	* tm.texi (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER,
	FUNCTION_BLOCK_PROFILER_EXIT, MACHINE_STATE_SAVE,
	MACHINE_STATE_RESTORE): Kill.

2001-10-26  Steve Christiansen  <smc@us.ibm.com>

	* doc/rtl.texi: Use a table to display RTL format characters.

2001-12-06  Bo Thorsen  <bo@suse.co.uk>

	* config/i386/linux64.h (LINK_SPEC): Correct name of dynamic linker.

Wed Dec  5 19:18:53 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (keep_stack_depressed): Check global_live_at_start
	of EXIT_BLOCK for temp register and verify it isn't in equiv_reg_src.

2001-12-05  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (powerpc-*-freebsd*): Use the proper tmake_file files,
	as set by the generic FreeBSD configure framework.

2001-12-04  Jason Merrill  <jason@redhat.com>

	* langhooks.h (struct lang_hooks_for_tree_inlining): Add
	start_inlining, end_inlining.
	* tree-inline.c (expand_call_inline): Call them.
	* langhooks-def.h (LANG_HOOKS_TREE_INLINING_START_INLINING): Define.
	(LANG_HOOKS_TREE_INLINING_END_INLINING): Define.
	(LANG_HOOKS_TREE_INLINING_INITIALIZER): Add them.
	* langhooks.c (lhd_tree_inlining_start_inlining): New fn.
	(lhd_tree_inlining_end_inlining): New fn.

2001-12-05  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-common.c (shadow_warning): New function, moved from cp/decl.c.
	* c-common.h (shadow_warning): New.
	* c-decl.c: Include c-common.h.
	(warn_if_shadowing): New, broken out of pushdecl.
	(pushdecl): Use warn_if_shadowing.
	(store_parm_decls): Prevent duplicate -Wshadow warnings.

Wed Dec  5 17:59:19 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/vms.h (SIZE_TYPE, PTRDIFF_TYPE): Remove, were disabled.
	(DOLLARS_IN_IDENTIFIERS, LINK_SPEC): Remove duplicate.
	(LIB_SPEC): Remove.

Wed Dec  5 16:03:04 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* doc/c-tree.texi (RECORD_TYPE, UNION_TYPE): Expand on definition.
	(QUAL_UNION_TYPE): New type.

	* varasm.c (output_constant, case ERROR_MARK): New case.

	* attribs.c (handle_no_check_memory_usage_atribute): Deleted.
	(c_com): Delete its reference.
	* builtins.c: Delete memory checking code.
	* calls.c, expr.c, function.c, stmt.c: Likewise.
	* builtins.c (expand_builtin_arg_info): Remove reference to
	EXPAND_MEMORY_USE_* modifiers.
	* explow.c (expr_size): Likewise.
	* expr.c (expand_expr, expand_increment): Likewise.
	* expr.h (ARGS_SIZE_RTX): Likewise.
	* function.c (assign_parms, expand_pending_sizeso): Likewise.
	* c-decl.c (duplicate_decls): Don't handle DECL_NO_CHECK_MEMORY_USAGE.
	* expr.c (in_check_memory_usage): Delete.
	(get_push_address, get_memory_usage_from_modifier): Delete.
	(expand_assigment): Use EXPAND_WRITE on destination.
	(expand_expr): Delete ro_modifier.
	* expr.h (expand_modifier): Delete EXPAND_MEMORY_* entries and
	add EXPAND_WRITE.
	(memory_use_mode): Delete.
	* flags.h (flag_check_memory_usage): Deleted.
	(flag_prefix_function_name): Likewise.
	* function.c (expand_function_start): Don't set
	current_function_check_memory_usage.
	* function.h (check_memory_usage): Delete.
	* libfuncs.h, optabs.c: Delete chkr_* stuff.
	* stmt.c (expand_asm_opernd): Change EXPAND_MEMORY_USE_WO to
	EXPAND_WRITE.
	* toplev.c (flag_check_memory_usage): Deleted.
	(flag_prefix_function_name): Likewise.
	(f_options, process_options): Delete references to above.
	* tree.h (DECL_NO_CHECK_MEMORY_USAGE): Deleted.
	* varasm.c (CHKR_PREFIX): Deleted.
	(make_decl_rtl): Remove flag_prefix_function_name handling.
	(assemble_name): Likewise.
	* doc/extend.texi: Remove no_check_memory_usage attribute.
	* doc/invoke.texi: Remove -fcheck-memory-usage
	and -fprefix-function-name.

2001-12-05  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (STMP_FIXPROTO, STMP_FIXINC): Use substituted values
	from autoconf.

2001-12-05  Nick Clifton  <nickc@cambridge.redhat.com>

	* config.gcc: Include arm/xscale-coff.h before arm/arm.h.

2001-12-05  William Cohen  <wcohen@redhat.com>

	* config/arm/arm.h (THUMB_FUNCTION_PROFILER): Correct typo in
	instruction.

2001-12-05  Daniel Berlin  <dan@cgsoftware.com>

	* config/rs6000/rs6000.h (enum rs6000_builtins): Add more altivec
	builtins.

	* config/rs6000/rs6000.md: Modeling of 7450 altivec changed to
	better reflect reality (change from Apple's tree).
	Add more of altivec instructions.
	Add ftruncv4sf2 pattern.
	Remove more unspecs (vector merge instructions, etc).

	* config/rs6000/rs6000.c (bdesc_3arg): New, for 3 argument altivec
	builtins.
	(bdesc_1arg): New, for 1 argument altivec builtins.
	(altivec_expand_builtin): Handle unary and ternary ops.
	(altivec_init_builtins): Ditto.

Wed Dec  5 09:33:39 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/alpha/vms.h (ADA_LONG_TYPE_SIZE): New macro.
	* doc/tm.texi (ADA_LONG_TYPE_SIZE): Document it.

2001-12-05  Jakub Jelinek  <jakub@redhat.com>

	* gcse.c (store_killed_in_insn): Consider pure calls
	as potential store killers in addition to normal calls.

2001-12-05  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (expand_expr): When checking promoted value, use
	DECL_MODE (exp) and not mode.

2001-12-05  Jakub Jelinek  <jakub@redhat.com>

	* c-typeck.c (output_init_element): Call digest_init
	just once, not in each if branch and check its return value for
	error_mark_node.

2001-12-05  Jakub Jelinek  <jakub@redhat.com>

	* c-decl.c (pushdecl): Only increase n_incomplete if pushed decl's
	type is RECORD_TYPE, UNION_TYPE or ARRAY_TYPE thereof.
	(finish_struct): Break the loop if n_incomplete went to 0.
	For ARRAY_TYPE, if it is not TYPE_DECL, layout the decl too.

Wed Dec  5 07:41:13 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/alpha.c (alpha_va_start): Update VMS case.

Wed Dec  5 07:27:42 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>
			  Douglas B. Rupp  <rupp@gnat.com>

	* vmsdbg.h, vmsdbgout.c: Add documentation and minor cleanups.
	* doc/invoke.texi: Add -gvms.
	* doc/passes.texi: Add mention of vmsdbgout.c.
	* doc/tm.texi: Document VMS debugging output.

Wed Dec  5 06:26:27 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.h (tree, rtx): Remove no-longer-needed definitions.

	* function.c (keep_stack_depressed): Refine check for register
	clobbered over call.

	* expr.c (store_expr): When copying string constant into array,
	use functions that update memrefs instead of computations on
	addresses to better track MEMs.  Also properly handle 32/64 pointers.
	(expand_expr): Use TARGET even if not reg for multi-word CONSTRUCTOR.
	(expand_expr, case CONSTRUCTOR): Fix errors in parms to assign_temp.

	* emit-rtl.c (component_ref_for_mem_expr): Try harder to find decl
	underneath COMPONENT_REFs.
	(set_mem_attributes): Also strip VIEW_CONVERT_EXPR.

2001-12-05  Neil Booth  <neil@daikokuya.demon.co.uk>

	* toplev.c (display_target_options): Don't print twice.

Wed Dec  5 00:42:16 EST 2001  John Wehle  (john@feith.com)

	* emit-rtl.c (set_unique_reg_note): Don't set
	a REG_EQUAL or REG_EQUIV note if multiple sets
	are present.

2001-12-04  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* cfgrtl.c (verify_flow_info): Allow jump table data in fallthru if
	CASE_DROPS_THROUGH.

2001-12-04  Andrew MacLeod  <amacleod@redhat.com>

	* rtl.h (initialize_uninitialized_subregs): New prototype.
	* toplev.c (rest_of_compilation): Call initialize_uninitialized_subregs
	when optimization is on.
	* flow.c (find_regno_partial): Find subregs within an expression.
	(initialize_uninitialized_subregs): Initialize live on entry registers
	which are used in subreg expressions.

2001-12-04  Phil Edwards  <pme@gcc.gnu.org>

	* Makefile.in:  Add INSTALL_SCRIPT using INSTALL definition.

2001-12-04  DJ Delorie  <dj@redhat.com>

	* fixinc/fixincl.c (initialize): Avoid problemsome macro
	parameter names (PR 3388).

2001-12-05  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_legitimize_address): Fix typo.
	* config/rs6000/rs6000.h (LEGITIMATE_LO_SUM_ADDRESS_P): Here too.

2001-12-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.def (COMPOUND_LITERAL_EXPR): New.
	* c-common.c (c_expand_expr): Handle COMPOUND_LITERAL_EXPR.
	(c_staticp): New function.
	* c-common.h (COMPOUND_LITERAL_EXPR_DECL): New.
	(c_staticp): Declare.
	* c-typeck.c (default_function_array_conversion, build_unary_op):
	Don't handle CONSTRUCTOR specially.
	(lvalue_p, mark_addressable): Handle COMPOUND_LITERAL_EXPR.
	* c-decl.c (build_compound_literal): New function.
	* c-tree.h (build_compound_literal): Declare.
	* c-parse.in (primary): Use build_compound_literal.
	* c-lang.c (LANG_HOOKS_STATICP): Define.
	* objc/objc-lang.c (LANG_HOOKS_STATICP): Likewise.
	* doc/c-tree.texi: Document COMPOUND_LITERAL_EXPR.
	* doc/extend.texi: Update documentation of compound literals.
	Fixes PR c/4787.

2001-12-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* langhooks.h (struct lang_hooks): Add staticp.
	* langhooks-def.h (lhd_staticp, LANG_HOOKS_STATICP): New.
	(LANG_HOOKS_INITIALIZER): Add LANG_HOOKS_STATICP.
	* langhooks.c (lhd_staticp): New function.
	* tree.c (staticp): Call lang_hooks.staticp for language-specific
	tree codes.

2001-12-04  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppspec.c (lang_specific_driver): Set is_cpp_driver.
	* gcc.c (process_command): Ensure the cpp driver sees
	--help and --target-help, and that the help is printed
	exactly once.

2001-12-04  David Edelsohn  <edelsohn@gnu.org>

	* config/elfos.h (ASM_OUTPUT_INTERNAL_LABEL): Display count unsigned.

2001-12-04  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/cris.h (OPTIMIZATION_OPTIONS): Don't unset
	flag_strict_aliasing.  Use separate assignment statements.

2001-12-04  Zack Weinberg  <zack@codesourcery.com>

	* build-make, cross-make: Delete file.
	* configure.in: Set and substitute CROSS, ALL,
	SYSTEM_HEADER_DIR, HOST_PREFIX, HOST_PREFIX_1, HOST_CC,
	HOST_CFLAGS, STMP_FIXINC, and STMP_FIXPROTO depending on
	whether build == host and host == target.  Do not
	AC_SUBST_FILE build_overrides or cross_overrides.  Do not
	AC_SUBST cross_defines or extra_c_flags.
	* Makefile.in (NATIVE_SYSTEM_HEADER_DIR): New.
	(SYSTEM_HEADER_DIR, HOST_PREFIX, HOST_CC, HOST_PREFIX,
	HOST_PREFIX_1, HOST_CFLAGS, ALL, INTERNAL_CFLAGS): Set
	partially or completely with autoconf-substituted @variable@
	notation.
	(INSTALL_TARGET, @cross_defines@, @cross_overrides@,
	@build_overrides@, @extra_c_flags@, all.build, install-build,
	install-cross-rest, install-float-h-cross): Deleted.
	(install-normal): Rename to install.  Delete old "install"
	indirection rule.

2001-12-04  Andrew MacLeod  <amacleod@redhat.com>

	* stmt.c (expand_return): Clear destination instead of clobbering it
	when setting a return value via bitsets.

2001-12-04  Alexandre Oliva  <aoliva@redhat.com>

	* tree.c (get_callee_fndecl): Only use DECL_ABSTRACT_ORIGIN if
	it has DECL_SAVED_TREE.

	* c-decl.c (duplicate_decls): Revert rth's patch.  If newdecl
	is in a different binding level, get its abstract origin to be
	olddecl.
	* tree-inline.c (expand_call_inline): Move DECL_INITIAL sanity
	check earlier.
	* tree.c (get_callee_fndecl): Follow DECL_ABSTRACT_ORIGIN if
	DECL_INITIAL is NULL.

2001-12-04  Jakub Jelinek  <jakub@redhat.com>

	* flow.c (ior_reg_cond): Return NULL if ! add and rtx wasn't optimized.
	Return correct value if one of the subexpressions was optimized to
	0 resp. 1.  Optimize (x | A) | x and (x & A) | x.
	(and_reg_cond): Similarly.

2001-12-04  Jakub Jelinek  <jakub@redhat.com>

	* function.c (assign_parms): Set last_named only for last named
	argument.

2001-12-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi: Use the GFDL.  Include years from old install
	manual in copyright notice.  Include copyright and GFDL notice on
	HTML index page.  Include usual footer on testing.html.
	* doc/install.texi2html: Build gfdl.html.  Use -I
	$SOURCEDIR/include.
	* doc/include/fdl.texi: Adapt for use in the install manual.

2001-12-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi: Document that installed native compiler for
	building cross compilers should be GCC 2.95 or later.

2001-12-03  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.h (CALL_REALLY_USED_REGISTERS): New macro.
	* config/mips/mips.md: Check TARGET_DEBUG_D_MODE before split
	patterns.

2001-12-03  Janis Johnson  <janis187@us.ibm.com>

	* rtl.def (PREFETCH): New rtx code.
	* doc/rtl.texi (PREFETCH): Add documentation.
	* function.c (instantiate_virtual_regs_1): Handle PREFETCH rtx.
	* rtlanal.c (reg_referenced_p): Ditto.
	* sched-vis.c (print_exp):  Ditto.
	* ssa-dce.c (find_inherently_necessary):  Ditto.

	* config/ia64/ia64.h (SIMULTANEOUS PREFETCHES): Define.
	  (PREFETCH_BLOCK): Define.
	* config/ia64/ia64.md (itanium_class): Add lfetch.
	  (prefetch, prefetch_internal): New.

	* builtin-types.def (BT_FN_VOID_PTR_INT_INT): New.
	* builtins.def (BUILT_IN_PREFETCH): New.
	* builtins.c (expand_builtin_expect): New.
	  (expand_builtin): Call it.
	* doc/extend.texi: Document __builtin_prefetch.

	* config/i386/i386.md (prefetch): Rename as prefetch_sse to avoid
	  conflicts with new generic prefetch functionality.
	* config/i386/i386.c (ix86_expand_builtin): Use new name for
	  prefetch_sse.

2001-12-02  Ziemowit Laski  <zlaski@apple.com>

	* objc/Make-lang.in: Update copyright.
	(OBJC_OBJS): Add objc-lang.o.
	(objc-lang.o): New rule.
	* objc/config-lang.in: Fix file description and update
	copyright.
	* objc/objc-act.c: Do not include langhooks.h and
	langhooks-def.h
	(lang_hooks): Move (along with LANG_HOOKS...) to objc-lang.c.
	(objc_post_options): Move to objc-lang.c.
	(objc_init_options): Move to objc-lang.c.
	(objc_init): Make non-static.
	(objc_decode_option): Make non-static.
	(HASHFUNCTION): Remove macro.
	(hash_func): New function.
	(hash_enter): Replace HASHFUNCTION with hash_func.
	(hash_lookup): Replace HASHFUNCTION with hash_func.
	(maybe_objc_tree_codes): New function.
	(init_objc): Move ObjC tree code initialization to
	maybe_objc_tree_codes().
	* objc/objc-act.h (GCC_OBJC_ACT_H): New include guard.
	(objc_init): New public prototype.
	(objc_decode_option): New public prototype.
	(maybe_add_objc_tree_codes): New public prototype.
	* objc/objc-lang.c: New file.
	(lang_hooks): Moved from objc-act.c.
	(objc_post_options): Moved from objc-act.c.
	(objc_init_options): Moved from objc-act.c.

2001-12-03  Geoff Keating  <geoffk@redhat.com>

	* emit-rtl.c (gen_lowpart_common): Avoid unwanted sign-extension
	of array elements.

2001-12-03  Neil Booth  <neil@daikokuya.demon.co.uk>

	PR c/4988
	* gcc.c (process_command): Don't add a preprocessor option for
	--help and --target-help; cc1 is enough.

2001-12-03  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-decl.c (grokdeclarator): Use ISO word.
	* cppinit.c: Remove leading capital from diagnostic messages, as
	per GNU coding standards.
	* emit-rtl.c: Similarly.
	* final.c: Similarly.
	* gcc.c: Similarly.
	* tradcpp.c: Similarly.
	* config/arm/arm.c: Similarly.
	* config/arm/arm.h: Similarly.
	* config/avr/avr.c: Similarly.
	* config/avr/avr.h: Similarly.
	* config/c4x/c4x.c: Similarly.
	* config/cris/cris.c: Similarly.
	* config/cris/cris.h: Similarly.
	* config/d30v/d30v.c: Similarly.
	* config/dsp16xx/dsp16xx.c: Similarly.
	* config/dsp16xx/dsp16xx.h: Similarly.
	* config/h8300/h8300.c: Similarly.
	* config/i386/i386.c: Similarly.
	* config/i386/xm-djgpp.h: Similarly.
	* config/i960/i960.h: Similarly.
	* config/m32r/m32r.c: Similarly.
	* config/m68hc11/m68hc11.c: Similarly.
	* config/m88k/m88k.c: Similarly.
	* config/m88k/m88k.h: Similarly.
	* config/mcore/mcore.c: Similarly.
	* config/mcore/mcore.h: Similarly.
	* config/mips/mips.c: Similarly.
	* config/mmix/mmix.c: Similarly.
	* config/pa/pa.c: Similarly.
	* config/rs6000/rs6000.c: Similarly.
	* config/rs6000/sysv4.h: Similarly.
	* config/s390/s390.c: Similarly.
	* config/sparc/sparc.c: Similarly.
	* config/v850/v850-c.c: Similarly.
	* config/v850/v850.c: Similarly.

2001-12-03  Zack Weinberg  <zack@codesourcery.com>

	* rs6000.h (RETURN_IN_MEMORY): Cast result of
	int_size_in_bytes to unsigned HOST_WIDEST_INT so that -1 > 8.

Mon Dec  3 09:18:34 2001  Jeffrey A Law  (law@cygnus.com)

	* mn10200.md (negsf2): Use -0x8000 instead of 0x8000 for
	bit twiddling constant.

Mon Dec  3 16:16:37 CET 2001  Jan Hubicka  <jh@suse.cz>

	* gcse.c (delete_null_pointer_checks_1): Do not use delete_list;
	call purge_dead_edges after removing.
	(delete_null_pointer_checks): Do not handle delete_list.

	* cfgbuild.c (inside_basic_block_p, control_flow_insn_p): Break out from ...
	(count_basic_blocks): ... here.
	(find_basic_blocks, find_bb_boundaries): Cleanup.

	* stor-layout.c (fixup_signed_type, fixup_unsigned_type): Avoid
	overflow for types greater then 2 * HOST_WIDE_INT.

	* reload.c (find_reloads): Update the duplicates after swapingg.

Mon Dec  3 13:52:19 CET 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (movabsqi*): Use 'b' prefix instead of 'q'.

2001-12-02  Zack Weinberg  <zack@codesourcery.com>

	* config/rs6000/rs6000.h (MASK_ALTIVEC_ABI,
	MASK_LONG_DOUBLE_128): Delete.
	(MASK_AIX_STRUCT_RET, MASK_AIX_STRUCT_RET_SET,
	TARGET_AIX_STRUCT_RET): New flags.
	(TARGET_SWITCHES): Remove entries for -mlong-double-128 and
	-mlong-double-64.  Add entries for -m(no-)aix-struct-return
	and -m(no-)svr4-struct-return.
	(TARGET_OPTIONS): Add entry for -mlong-double-.
	(rs6000_long_double_size_string, rs6000_long_double_type_size,
	rs6000_altivec_abi): Declare.
	(TARGET_LONG_DOUBLE_128, TARGET_ALTIVEC_ABI,
	LONG_DOUBLE_TYPE_SIZE): Change definitions to match.
	(RETURN_IN_MEMORY): If !TARGET_AIX_STRUCT_RET, return
	structures of size <= 8 bytes in registers.
	(PRINT_OPERAND_PUNCT_VALID_P): Take out '$' and '*'.

	* config/rs6000/rs6000.c (rs6000_long_double_size_string,
	rs6000_long_double_type_size, rs6000_altivec_abi): New
	globals.
	(rs6000_override_options): Set rs6000_long_double_type_size
	from rs6000_long_double_size_string, if nonzero.  Set the
	MASK_AIX_STRUCT_RET bit in target_flags from DEFAULT_ABI, if
	not already set.
	(rs6000_parse_abi_options): Set rs6000_altivec_abi, not a
	target_flags bit.
	(rs6000_init_builtins): This hook now takes no arguments.

	* config/rs6000/netbsd.h, config/rs6000/linux.h: Define
	DRAFT_V4_STRUCT_RET to 1.

2001-12-03  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c (really_start_incremental_init, push_init_level):
	Avoid constructor_max_index being other than an INTEGER_CST.

2001-12-02  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/xcoff.h (ASM_OUTPUT_INTERNAL_LABEL): Display count
	unsigned.
	(ASM_GENERATE_INTERNAL_LABEL): Same.
	(UNIQUE_SECTION): Fix typo.

2001-12-02  Richard Henderson  <rth@redhat.com>

	* c-decl.c (duplicate_decls): Conditionalize DECL_SAVED_TREE copy.

2001-12-02  Richard Henderson  <rth@redhat.com>

	* rtl.h (mem_attrs): Rename decl to expr; adjust all users.
	(MEM_EXPR): Rename from MEM_DECL; adjust all users.
	* emit-rtl.c (set_mem_expr): Rename from set_mem_decl.
	* expr.h, final.c, reload1.c: Adjust users.

	* alias.c (nonoverlapping_component_refs_p): New.
	(decl_for_component_ref, adjust_offset_for_component_ref): New.
	(nonoverlapping_memrefs_p): Use them.
	* emit-rtl.c (component_ref_for_mem_expr): New.
	(set_mem_attributes): Use it.
	(set_mem_offset): New.
	* expr.c (expand_assignment): Call set_mem_attributes for
	inner references; adjust the memory offset as needed.
	* print-rtl.c (print_mem_expr): New.
	(print_rtx): Use it.

Sun Dec  2 09:22:25 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/x-interix3 (SYSTEM_HEADER_DIR): Put back default.

	* config/alpha/vms.h (VMS_DEBUGGING_INFO): New macro.
	(PREFERRED_DEBUGGING_TYPE): Define as VMS_AND_DWARF2_DEBUG.
	(ASM_SPEC): Don't redefine.
	(OPTIMIZATION_OPTIONS, OVERRIDE_OPTIONS, LINK_SPEC): Define.
	* config/alpha/t-vms (EXTRA_PARTS): Use; add rule for vms-dwarf2.asm.
	* config/alpha/vms-dwarf2.asm: New file.

	* Makefile.in (OBJS): Add vmsdbgout.c and its rule.
	* c-lex.c (init_c_lex): Test for VMS_AND_DWARF2_DEBUG.
	* debug.h (gcc_debug_hooks): Add vmsdbg_debug_hooks.
	(vmsdbgout_after_prologue): New declaration.
	* defaults.h (VMS_DEBUGGING_INFO): Add to PREFERRED_DEBUGGING_TYPE.
	* dwarf2.h (dwarf_attribute): New DW_AT_VMS_rtnbeg_pd_address.
	* dwarf2out.c (dwarf2out_do_frame): Test for VMS_AND_DWARF2_DEBUG.
	(dwarf2out_frame_finish): Test for VMS_AND_DWARF2_DEBUG.
	(dwarf_attr_name): Use DW_AT_VMS_rtnbeg_pd_address.
	(add_name_and_src_coords_attributes): Test VMS_DEBUGGING_INFO
	* final.c (final_start_function): Test for VMS_AND_DWARF2_DEBUG.
	Test VMS_DEBUGGING_INFO.
	(final_end_function): Test for VMS_AND_DWARF2_DEBUG.
	(final_scan_insn): Test for VMS_AND_DWARF2_DEBUG and VMS_DEBUG.
	* flags.h (debug_info_type): Add VMS_DEBUG and VMS_AND_DWARF2_DEBUG.
	* toplev.c (compile_file): Test VMS_DEBUGGING_INFO, VMS_DEBUG, and
	VMS_AND_DWARF2_DEBUG.
	(rest_of_type_compilation): Test for VMS_AND_DWARF2_DEBUG.
	(decode_g_option): Add "vms" to debug_type_names.
	(process_options): Set vmsdbg_debug_hooks if -gvms.
	(lang_independent_init): Emit line number for VMS unless -g0.
	* tree.c: (build_complex_type): Test for VMS_AND_DWARF2_DEBUG.
	* vmsdbg.h, vmsdbgout.c: New files.

Sun Dec  2 09:03:06 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* cfgbuild.c (SET_STATE): Add cast to eliminate warning.a

2001-12-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cfgrtl.c (purge_all_dead_edges): Initialize variable.
	* dwarf2out.c (is_cxx): Prototype.
	* local-alloc.c (block_alloc): Avoid 'unsigned>=0 is always true'
	warning.
	* objc/objc-act.c (defer_fn): Avoid signed/unsigned warning.

Sun Dec  2 07:12:30 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* libgcc2.c (__bb_exit_func): Fix line wrap problems.

2001-12-02  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.h (SLOW_UNALIGNED_ACCESS): Simplify.
	* config/rs6000/rs6000.c (rs6000_emit_move): Use adjust_address
	rather than simplify_subreg.  Check for volatile-ness.  Check that
	we're not splitting one slow operation into two slow operations.

2001-12-02  David Edelsohn  <edelsohn@gnu.org>

	* emit-rtl.c (gen_lowpart_common): Cast array element to HOST_WIDE_INT
	before shifting.

2001-12-02  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-decl.c (duplicate_decls, push_parm_decl): Remove leading
	capital from diagnostics.
	* c-lex.c (cb_file_change): Similarly.
	* c-parse.in : Similarly.
	* cfgrtl.c (verify_flow_info): Similarly.
	* collect2.c: Similarly.
	* cppfiles.c (find_include_file): Similarly.
	* cppinit.c (cpp_handle_option): Similarly.
	* cpplex.c (cpp_spell_token): Similarly.
	* cppmain.c (do_preprocessing): Similarly.
	* gcc.c (translate_options, process_command, do_spec1,
	main, pfatal_execute): Similarly.
	* genattr.c (main): Similarly.
	* genattrtab.c (check_attr_test, operate_exp, simplify_test_exp,
	write_test_expr, main): Similarly.
	* gencodes.c (main): Similarly.
	* genconfig.c (main): Similarly.
	* genconstants.c (main): Similarly.
	* genemit.c (main): Similarly.
	* genextract.c (main): Similarly.
	* genflags.c (main): Similarly.
	* genopinit.c (main): Similarly.
	* genoutput.c (process_template, main): Similarly.
	* genpeep.c (main): Similarly.
	* genrecog.c (main): Similarly.
	* gensupport.c (is_predicable, identify_predicable_attribute,
	alter_predicate_for_insn, init_md_reader_args, main): Similarly.
	* ggc-page.c (alloc_anon): Similarly.
	* mips-tfile.c (add_string, add_procedure, add_file, read_line,
	parse_begin, parse_bend, parse_def, parse_end, parse_file,
	parse_stabs_common, parse_stabs, write_varray, write_object,
	read_seek, copy_object, main, error): Similarly.
	* profile.c (compute_branch_probabilities): Similarly.
	* reg-stack.c (check_asm_stack_operands): Similarly.
	* reload.c (find_reloads): Similarly.
	* reload1.c (spill_failure, failed_reload): Similarly.
	* rtl-error.c (_fatal_insn_not_found): Similarly.
	* toplev.c (read_integral_parameter, crash_signal,
	decode_f_option, set_target_switch, parse_options_and_default_flags)
	: Similarly.
	* tradcif.y (parse_number, yylex): Similarly.
	* tradcpp.c (main, fancy_abort): Similarly.
	* tree.c (tree_check_failed): Similarly.
	* varray.c (varray_check_failed): Similarly.
	* xcoffout.c (xcoff_output_standard_types): Similarly.
objc:
	* objc-act.c (get_object_ref, lookup_and_install_protocols,
	build_objc_string_object, objc_declare_alias, build_ivar_chain,
	finish_message_expr, build_protocol_expr, is_public,
	start_class): Similarly.

2001-12-01  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-decl.c (duplicate_decls, parmlist_tags_warning): Remove
	trailing period from diagnostics.
	* c-lex.c (cb_file_change): Similarly.
	* cppmacro.c (check_trad_stringification): Similarly.
	* gcc.c (do_spec_1): Similarly.
	* genattr.c (main): Similarly.
	* genattrtab.c (main, operate_exp, make_length_attrs): Similarly.
	* gencodes.c (main): Similarly.
	* genconfig.c (main): Similarly.
	* genconstants.c (main): Similarly.
	* genemit.c (main): Similarly.
	* genextract.c (main): Similarly.
	* genopinit.c (main): Similarly.
	* genoutput.c (main): Similarly.
	* genpeep.c (main): Similarly.
	* genrecog.c (main): Similarly.
	* mips-tfile.c (add_file, error): Similarly.
	* profile.c (init_branch_prob): Similarly.
	* reload1.c (spill_failure): Similarly.
	* stmt.c (parse_output_constraint): Similarly.
	* varasm.c (assemble_variable): Similarly.

2001-12-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* m68k.c (init_FPA_table): Provide static prototype.
	* mips/abi64.h (mips_function_value): Move prototype to ...
	* mips-protos.h (mips_function_value): ... here.
	* mips.c: Include halfpic.h.
	* output.h (rdata_section): Prototype.

	* h8300.c (h8300_asm_named_section): Wrap with !OBJECT_FORMAT_ELF.
	* m88k.c (m88k_svr3_asm_out_constructor,
	m88k_svr3_asm_out_destructor): Wrap with CTOR_LIST_BEGIN &&
	!OBJECT_FORMAT_ELF.
	* mcore.c (mcore_asm_named_section): Wrap with OBJECT_FORMAT_ELF.
	* sh.c (sh_asm_named_section): Wrap with !OBJECT_FORMAT_ELF.
	* sparc.c (sparc_elf_asm_named_section): Wrap with OBJECT_FORMAT_ELF.

2001-12-01  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.h (LEGITIMATE_LO_SUM_ADDRESS_P): Complex
	LO_SUM addresses less than word size are not legitimate,
	because they lead to invalid SUBREGs.
	* config/rs6000/rs6000.c (rs6000_legitimize_address): Likewise.

2001-12-01  Olivier Hainque <hainque@act-europe.fr>

	* unroll.c (loop_iterations): Give up on jumps with null JUMP_LABEL
	while scanning for multiple back edges.

2001-12-01  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* ginclude/ppc-asm.h (JUMP_TARGET): New macro.
	* config/rs6000/tramp.asm: Use it.

2001-12-01  Zack Weinberg  <zack@codesourcery.com>

	* gencheck.c, gengenrtl.c: Don't define xmalloc.
	* gensupport.c: Don't define xstrdup, xcalloc, xrealloc,
	xmalloc.

2001-11-30  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c (output_ascii): Cast `p' to unsigned char.

2001-11-30  Daniel Berlin  <dan@cgsoftware.com>

	* config/rs6000/rs6000.c (altivec_expand_builtin): add
	ALTIVEC_BUILTIN_LD_INTERNAL_4sf and ALTIVEC_BUILTIN_ST_INTERNAL_4sf,
	*_16qi,_8hi, rename existing V4SI ones to *_4si.
	(altivec_init_builtins): Ditto.
	(bdesc_2arg): Rename CODE_FOR_* to match changes in MD file.

	* config/rs6000/rs6000.md: Add attribute types vecsimple,
	veccomplex, vecfloat, and vecperm, for altivec instructions.
	Modify altivec patterns to use appropriate attribute type.
	Modify altivec patterns to match RTL operations where appropriate
	(IE no unspec where we can avoid it).
	Add vector unit scheduling for ppc7450.
	Rename patterns to what they are where appropriate
	(altivec_vaddfp->addv4sf3, etc)

	* config/rs6000/rs6000.h (enum rs6000_builtins): Change VRS->VSR.
	Pass -mppc, and define _ARCH_PPC, if -mcpu=7450 is used.

	* config/rs6000/sysv4.h: Add -mcpu=7450.

	* testsuite/gcc.dg/altivec-1.c: Update test to take into account renamed
	_builtin_altivec_ld_interal function.

2001-11-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* configure.in (AC_CHECK_FUNCS): Delete strtoul, bsearch, popen,
	strchr, strrchr, isascii, gettimeofday.
	* config.in, configure: Regenerate.

2001-11-30  Zoltan Hidvegi  <hzoli@hzoli.2y.net>

	* unroll.c (unroll_loop): Correct special exit cases.

2001-11-30  Stephane Carrez  <Stephane.Carrez@sun.com>

	* config/sparc/sparc.c (DF_MODES_NO_S): Fix pr/3623, define to
	accept DFmode and DImode only.

2001-11-30  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (STARTING_FRAME_OFFSET): Adjust for altivec.
	(STACK_DYNAMIC_OFFSET): Same.

2001-11-30  Richard Henderson  <rth@redhat.com>

	* c-decl.c (duplicate_decls): Copy DECL_SAVED_TREE.

2001-11-30  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (CALL_REALLY_USED_REGISTERS): New.
	(CONDITIONAL_REGISTER_USAGE): Set call_really_used_registers to
	the values in call_used_registers.

Fri Nov 30 12:48:26 2001  Jeffrey A Law  (law@cygnus.com)

	* gthr-dce.h: If _DCE_THREADS is not defined, then just include
	gthr-single.

2001-11-30  Jason Merrill  <jason@redhat.com>

	* dwarf2out.c (is_cxx): New fn.
	(add_data_member_location_attribute): Check it.
	* dbxout.c (dbxout_type): Only look at BINFO_VPTR_FIELD for C++.

Fri Nov 30 08:26:57 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* dwarf2asm.c (dw2_asm_output_encoded_addr_rtx): Handle const1_rtx.

2001-11-30  Daniel Berlin  <dan@cgsoftware.com>

	* genopinit.c (gen_insn): Handle MODE_VECTOR_INT and
	MODE_VECTOR_FLOAT as allowed.

2001-11-29  Zack Weinberg  <zack@codesourcery.com>

	Purge cruft now we have build libiberty.

	* Makefile.in (OBSTACK, VFPRINTF, DOPRINT, STRSTR,
	HOST_OBSTACK, HOST_VFPRINTF, HOST_DOPRINT, HOST_STRSTR,
	USE_HOST_OBSTACK, USE_HOST_VFPRINTF, USE_HOST_DOPRINT,
	USE_HOST_STRSTR): Delete variables.
	(vfprintf.o, doprint.o, strstr.o, splay-tree.o, obstack.o,
	hashtab.o, safe-ctype.o, $(HOST_PREFIX_1)obstack.o,
	$(HOST_PREFIX_1)vfprintf.o, $(HOST_PREFIX_1)doprint.o,
	$(HOST_PREFIX_1)strstr.o), $(HOST_PREFIX_1)): Delete rules.
	(LIBIBERTY, BUILD_LIBIBERTY): New variables.
	(LIBDEPS): Now just $(INTLDEPS) $(LIBIBERTY).
	(LIBS): Now just $(INTLLIBS) @LIBS@ $(LIBIBERTY).
	(HOST_LIBDEPS): Now just $(BUILD_LIBIBERTY).
	(HOST_LIBS): Ditto.
	(HOST_RTL): Remove hashtab.o safe-ctype.o.
	(OBJS): Remove splay-tree.o.
	(gen-protos): Depend on $(HOST_LIBS), not ../libiberty/libiberty.a.
	(distclean): No need to delete splay-tree.c obstack.c
	hashtab.c safe-ctype.c.
	(mostlyclean): Delete build copies of print-rtl.c bitmap.c
	errors.c ggc-none.c (all prefixed with $(HOST_PREFIX_1).
	* aclocal.m4 (gcc_AC_FUNC_VFPRINTF_DOPRNT, gcc_AC_FUNC_STRSTR):
	Delete.
	* configure.in: Don't use them.
	Set and substitute @FORBUILD@.
	* config.in, configure: Regenerate.
	* doprint.c: Move to libiberty/_doprnt.c.
	* doc/configterms.texi: Document that libiberty is now built
	up to three times.  Fix typo.

2001-11-30  Jason Merrill  <jason@redhat.com>

	* dwarf2out.c (add_data_member_location_attribute): Do the
	right thing for virtual bases.
	* dbxout.c (dbxout_type): For a virtual base, print the offset
	within the vtable.

2001-11-29  Zoltan Hidvegi  <hzoli@hzoli.2y.net>

	* doloop.c (doloop_valid_p): Check for LTU and GTU as well.

2001-11-29  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (function_arg): Unnamed vector arguments
	go in memory.
	Remove unused attribute for named.

2001-11-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* genattrtab.c (attr_rtx_1): New function containing the
	majority of `attr_rtx'.  Move variable declarations into the
	scope where they are used.  Eliminate unnecessary gotos.
	(attr_rtx): Now just a wrapper for `attr_rtx_1' using VA_OPEN,
	VA_FIXEDARG, and VA_CLOSE.

2001-11-30  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/cris.c (cris_notice_update_cc): Check first
	destination also against overlap with cc_status.value2 and second
	destination against overlap with cc_status.value1.  For overlaps,
	clear overlapped value, don't just CC_STATUS_INIT.

	* config/cris/cris.h (EXTRA_CONSTRAINT_T): Fix spacing and FIXME.
	Fix typo in comment.
	(LINK_SPEC): Remove whitespace at end of line.

2001-11-29  Jakub Jelinek  <jakub@redhat.com>

	* c-lex.c (init_c_lex): Canonicalize "-" filename to "".

2001-11-29  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (ASM_DEBUG_SPEC): Only check HAVE_AS_G*_DEBUG_FLAG
	macros for the supported debugging types.

2001-11-29  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	PR other/4932
	* config/i386/i386.c (print_operand):  Verify that the
	  argument to %c is a constant and not a conditional which
	  needs to be reversed.

Thu Nov 29 11:12:59 2001  Geoffrey Keating (geoffk@redhat.com)

	* emit-rtl.c (gen_lowpart_common): Fix conversion of
	REAL_VALUE_TYPEs to an array of target integers.  Fix extraction
	of low part of those arrays for 32bit and 64bit hosts.

2001-11-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (insn-output.o): Depend on insn-codes.h.

2001-11-29  Joseph S. Myers  <jsm28@cam.ac.uk>

	* configure.in (target_list): Add generated-manpages.
	* configure: Regenerate.
	* Makefile.in (generated-manpages): Depend on
	lang.generated-manpages.
	* objc/Make-lang.in (objc.generated-manpages): New dummy target.

2001-11-29  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/crti.asm (_init): Add .thumb_func if compiled
	with -mthumb.
	(_fini): Add .thumb_func if compiled with -mthumb.

2001-11-28  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.c (override_options): Fix thinko in mips_tune
	for mips32/mips64. Remove MASK_SOFT_FLOAT configuration bits.

Thu Nov 29 00:24:15 EST 2001  John Wehle  (john@feith.com)

	* alpha.md (tablejump): Use pic_offset_table_rtx
	instead of gen_rtx_REG.

Wed Nov 28 15:36:13 2001  Jeffrey A Law  (law@cygnus.com)

	* expr.c (store_expr): When copying a string constant into an
	array, reset the known alignment of the MEM for the section to
	be cleared to BITS_PER_UNIT.

2001-11-28  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/cris.c: Remove whitespace at end of line.

Wed Nov 28 14:51:23 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config.gcc (i[34567]86-*-interix3*): New case.
	* config/x-interix3, config/interix3.h, config/i386/i386-interix3.h:
	New files.

2001-11-28  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (sibcall_osf_1, sibcall_value_osf_1): Use
	symbolic_operand as the predicate.

2001-11-28  Richard Henderson  <rth@redhat.com>

	* doloop.c (doloop_modify_runtime): Properly select induction
	variable; skip late entry test if biv initializer created by loop.

Wed Nov 28 08:21:47 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.h (EXPR_WFL_LINECOL): Used by Java in node other than
	EXPR_WITH_FILE_LOCATION, so change checks and documentation.

	* tree.h (TREE_VIA_PROTECTED): Update to show can be in TREE_VEC.

	* tree.h: Add missing checks on some macros; make formatting more
	consistent.

	* stor-layout.c (put_pending_size): Look for SAVE_EXPR if not at top
	level; only add to pending_sizes if find it.

	* langhooks.c (lhd_safe_from_p): Add ATTRIBUTE_UNUSED.

	* df.c (iterate_dataflow_sbitmap, iterate_dataflow_bitmap):
	Add casts to remove warnings.

	* Makefile.in (OBJS): Sort alphabetically.

	* print-rtl.c (print_rtx): If RTX code is bad, just say so.
	Also minor cleanups.

Wed Nov 28 06:52:27 2001  Arnaud Charlet  <charlet@ACT-Europe.FR>

	* Makefile.in (ORDINARY_FLAGS_TO_PASS): Remove STAGE_PREFIX.
	(FLAGS_TO_PASS): Add STAGE_PREFIX.
	(SUBDIR_FLAGS_TO_PASS): Apply PREPEND_DOTDOT_TO_RELATIVE_PATH
	to STAGE_PREFIX.

Wed Nov 28 10:42:19 CET 2001  Jan Hubicka  <jh@suse.cz>

	* cse.c (true_dependence_in_rtx): New function.
	(invalidate): Use it.

	* c-common.h (GOTO_FAKE_P): New macro.
	* tree-inline.c (GOTO_FAKE_P): Set.
	* c-tree.texi (GOTO_FAKE_P): Document.

	* varasm.c (assemble_variable): Set reloc to 3 for error_mark
	containing pointers.
	(output_addressed_constants): Check for local/external relocations.
	* elfos.h (SELECT_SECTION): Classify data section.
	* tm.texi (SELECT_SECTION): Update documentation.

	* cfganal.c (flow_dfs_compute_reverse_add_bb): set visited bit.
	(flow_dfs_compute_reverse_execute): Add only unvisited blocks.

2001-11-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* defaults.h (UNALIGNED_SHORT_ASM_OP, UNALIGNED_INT_ASM_OP,
	UNALIGNED_DOUBLE_INT_ASM_OP): Also provide defaults when we have
	OBJECT_FORMAT_ROSE.

2001-11-28  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/cris.c: Tweak spacing for prototypes.
	(LOSE_AND_RETURN): New macro.
	(cris_operand_lossage): New function.
	(cris_print_index, cris_print_base): Use cris_operand_lossage
	rather than fatal_insn.
	(cris_print_operand, cris_print_operand_address): Use
	LOSE_AND_RETURN rather than fatal_insn and internal_error.
	(cris_output_addr_const): Use LOSE_AND_RETURN and
	output_operand_lossage rather than fatal_insn and internal_error
	for valid but unexpected rtx expressions.

	* config/cris/cris.c (cris_split_movdx): Don't call alter_subreg
	for a SUBREG in src or dest, abort instead.

2001-11-28  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* doc/passes.texi: Remove reference to c-dump.c. Update tree inlining
	doc.

2001-11-27  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (ASM_DEBUG_SPEC): Use conditional expression rather than
	preprocessor define.  If only DBX_DEBUGGING_INFO or only
	DWARF2_DEBUGGING_INFO is supported for the target, provide
	appropriate definitions.

2001-11-27  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Makefile.in: Update, and add c-objc-common.o dependencies.
	* c-lang.c: Remove unnecessary includes.
	(c_init): Move bulk of code to c_objc_common_init, and call it.
	(c_tree_printer, c_missing_noreturn_ok_p, c_disregard_inline_limits,
	inline_forbidden_p, c_cannot_inline_tree_fn): Move to
	c-objc-common.c.
	* c-objc-common.c: New.  Mostly pulled from c-lang.c.
	* c-tree.h (c_disregard_inline_limits, c_cannot_inline_fn,
	c_objc_common_init, c_missing_noreturn_ok_p): New.
	* toplev.c: Update comment.
	* doc/passes.texi: Update.
objc:
	* objc-act.c (LANG_HOOKS_TREE_INLINING_CANNOT_INLINE_TREE_FN,
	LANG_HOOKS_TREE_INLINING_DISREGARD_INLINE_LIMITS,
	LANG_HOOKS_TREE_INLINING_ANON_AGGR_TYPE_P): Override.
	(objc_init): Update to use c_objc_common_init.

2001-11-27  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpphash.c (_cpp_init_hashtable): Update.
	* cpphash.h (struct spec_nodes): Remove n_L.
	* cpplex.c (_cpp_lex_direct): Check for prefix L separately.

2001-11-17  Richard Henderson  <rth@redhat.com>

	* unroll.c (loop_iterations): Move last change ...
	* doloop.c (doloop_modify_runtime): ... here.

2001-11-17  Corey Minyard  <minyard@acm.org>
	    Richard Henderson  <rth@redhat.com>

	* unroll.c (loop_iterations): Detect one situation in which we
	overestimate the number of iterations.

2001-11-27  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* gcc.c (set_input): Export.
	Move declaration ...
	gcc.h (set_input): ... here.

2001-11-27  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* gcc.c (set_collect_gcc_options): New function, split out from
	main.
	Ignore elided switches.
	(do_spec): Invoke before executing command.
	(do_spec_1): Likewise.
	Fixes PR other/3968.

2001-11-27  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/cris.h (INT_ASM_OP): Remove.

2001-11-27  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/i386/sol2.h (WINT_TYPE): Redefine.
	(WINT_TYPE_SIZE): Likewise.

2001-11-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* collect2.c: Check HAVE_DUP2 instead of NO_DUP2.
	(dup2): Make static and add prototype.
	* m68k/plexus.h: Don't define NO_DUP2.
	* configure.in (AC_CHECK_FUNCS): Add dup2.
	* config.in, configure: Regenerate.

	* ia64/aix.h (REG_SIZE): Don't #undef.
	* sparc.h (REG_SIZE): Delete.
	* flow.c (mark_used_regs): Don't use REG_SIZE.
	* regs.h (REG_SIZE): Delete.

2001-11-27  Andreas Schwab  <schwab@suse.de>

	* gcc.c: Fix typo PREFERRED_DEBUGGING_FORMAT ->
	PREFERRED_DEBUGGING_TYPE.

Tue Nov 27 08:21:47 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Makefile.in (c-lang.o): Depends on langhooks-def.h.
	(expr.o, varasm.o): Depends on langhooks.h.
	* c-common.c (c_safe_from_p): Always declare.
	(c_expand_expr): Refine when declared.
	* c-lang.c (c-common.h): Now include.
	(LANG_HOOKS_SAFE_FROM_P): Define new hook.
	(c_init): Don't set lang_safe_from_expr.
	* expr.c (langhooks.h): Now include.
	(lang_safe_from_p): No longer define.
	(safe_from_p): Use lang hook.
	(expand_expr): Set IGNORE if VOID_TYPE result of VIEW_CONVERT_EXPR too.
	(expand_expr, case VIEW_CONVERT_EXPR): Pass ro_modifier down.
	* expr.h (lang_expand_constant, lang_safe_from_p): Delete.
	* langhooks-def.h (lhd_return_tree, lhd_safe_from_p): New decls.
	(LANG_HOOKS_EXPAND_CONSTANT, LANG_HOOKS_SAFE_FROM_P): New hooks.
	* langhooks.c (lhd_return_tree, lhd_safe_from_p): New functions.
	* langhooks.h (struct lang_hooks): New fields expand_constant
	and safe_from_p.
	* output.h (output_constant): Size arg is HOST_WIDE_INT.
	* stmt.c (expand_decl_init): No longer need to expand constant
	for CONST_DECL.
	* stor-layout.c (put_pending_size): Don't check for SAVE_EXPR.
	* toplev.c (lang_expand_constant): Delete var.
	* tree.c (save_expr): Don't put another SAVE_EXPR around simple
	operations on SAVE_EXPR.
	* varasm.c (langhooks.h): Now include.
	(compare_constant_1): Use lang_hooks, not lang_expand_constant.
	(record_constant_1, output_addressed_constants): Likewise.
	(initializer_constant_valid_p, output_constant): Likewise.
	(output_constant_def): Process no-defer of string constant.
	(output_addressed_constants, case ADDR_EXPR): Use handled_component_p.
	(output_constant): Strip more conversions.
	Track our size and pad for the rest.
	(array_size_for_constructor): Remove code for non-byte STRING_CST.
	(output_constructor): SIZE now HOST_WIDE_INT.

2001-11-27  Richard Henderson  <rth@redhat.com>

	* ifcvt.c (noce_try_store_flag_constants): Test for overflow
	in computing DIFF.

2001-11-27  Zack Weinberg  <zack@codesourcery.com>

	* cppfiles.c (read_include_file): Add comment.

2001-11-26  Richard Henderson  <rth@redhat.com>

	* toplev.c (rest_of_compilation): Call free_bb_for_insn before exit.

2001-11-26  Richard Henderson  <rth@redhat.com>

	* config/ia64/sysv4.h (DBX_DEBUGGING_INFO): Undef.
	* config/ia64/aix.h (PREFERRED_DEBUGGING_TYPE): Remove
	commented out override.

2001-11-26  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppfiles.c (stack_include_file): Don't optimize zero-length
	files.
	(read_include_file): NUL-terminate read files.
	* cpplex.c (handle_newline, skip_escaped_newlines,
	get_effective_char, skip_whitespace, parse_identifier,
	parse_identifier_slow, parse_number, parse_string,
	_cpp_lex_direct): Optimize for the fact that buffers are guaranteed
	NUL-terminated.
	* cpplib.c (destringize_and_run, cpp_define, handle_assertion):
	Be sure buffers are NUL terminated.
	* cppmacro.c (warn_of_redefinition): Kill compile warning.

2001-11-26  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-common.c: Include tree-inline.h.
	(c_language): Move separate definitions here.
	(c_common_init_options, c_common_post_options): New.
	(c_common_lang_init): Rename c_common_init.
	* c-common.h (c_common_lang_init): Similarly.
	(c_common_init_options, c_common_post_options): New.
	* c-lang.c (c_post_options): Move body to c_common_post_options.
	(c_init_options): Use c_common_init_options.
	(c_init): Update.
	* langhooks.def: Rearrange.
	* langhooks.h: Rearrange, and improve comments.
	* toplev.c (do_compile): New function.
	(toplev_main): Use it.
	(lang_independent_f_options, parse_options_and_default_flags,
	process_options): Remove trailing periods.
	* Makefile.in: Update.
objc:	* objc-act.c (objc_post_options, objc_init_options): Use c-common.c
	functions.
	(ojbc_init): Update.

2001-11-26  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (unop): Add 0 offset for some gas versions.

2001-11-26  DJ Delorie  <dj@redhat.com>

	* expr.c (store_constructor): Actually use the value computed
	if WORD_REGISTER_OPERATIONS.

2001-11-26  Richard Henderson  <rth@redhat.com>

	* config/elfos.h (SELECT_SECTION): Don't check TREE_READONLY
	for CONSTRUCTOR.

2001-11-26  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (output_mi_thunk): Handle minimal-toc and call
	correct function on AIX.

2001-11-26  Alexandre Oliva  <aoliva@redhat.com>

	* toplev.c (process_options): Don't force
	flag_optimize_sibling_calls to zero just because exceptions are
	enabled.

Mon Nov 26 12:37:05 2001  Jeffrey A Law  (law@cygnus.com)

	* df.h (transfer_function_sbitmap): Use PARAMS around argument
	list in function prototypes.
	(transfer_function_bitmap): Likewise.

2001-11-26  Loren J. Rittle  <ljrittle@acm.org>

	* config/stormy16/stormy16.h: Remove DEFAULT_VTABLE_THUNKS.
	* config/i386/netbsd-elf.h: Likewise.

2001-11-26  David Edelsohn  <edelsohn@gnu.org>

	* doc/trouble.texi: Remove outdated RS/6000 comments.

Mon Nov 26 13:49:41 CET 2001  Jan Hubicka  <jh@suse.cz>

	* final.c (walk_alter_subreg): Fix return value.

Mon Nov 26 11:36:20 CET 2001  Jan Hubicka  <jh@suse.cz>

	* sparc.c (sparc_absnegfloat_split_legitimate): Do not call
	alter_subreg.
	* sparc.md (post-reload splitters): Do not call alter_subreg.
	* cfgrtl.c (purge_dead_edges): Fix typo in previous fix.

2001-11-25  Aldy Hernandez  <aldyh@redhat.com>

	* regclass.c (choose_hard_reg_mode): Handle vector arguments.

2001-11-26  Alan Modra  <amodra@bigpond.net.au>

	* final.c: (insn_lengths): Make it an int *, so that large jump
	tables don't overflow.

2001-11-25  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-format.c (FMT_FLAG_DOLLAR_GAP_POINTER_OK): New.
	(format_types): Use it for scanf.
	(dollar_arguments_pointer_p): New.
	(init_dollar_format_checking): Store details of which arguments
	are pointers.
	(maybe_read_dollar_number): Reallocate dollar_arguments_pointer_p.
	(finish_dollar_format_checking): Take extra parameter
	pointer_gap_ok.  Treat unused arguments differently if
	pointer_gap_ok and the unused arguments are pointers.
	(check_format_info_main): Pass extra argument to
	finish_dollar_format_checking.
	* doc/invoke.texi (-Wno-format-extra-args): Document behavior when
	unused arguments are present between used arguments with operand
	numbers.

2001-11-25  Daniel Berlin  <dan@cgsoftware.com>

	* df.c: Add prototypes for hybrid_search_bitmap and
	hybrid_search_sbitmap.
	(hybrid_search_bitmap): New function.
	(hybrid_search_sbitmap): New function.
	(iterative_dataflow_sbitmap): Change to use hybrid_search_sbitmap.
	(iterative_dataflow_bitmap): Ditto.

2001-11-25  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md (peephole2): New peephole2 to optimize
	address computations.

2001-11-25  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.c (d_register_operand): Must accept
	register b (low part of d).

2001-11-25  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.h (FUNCTION_PROFILER): Fix label name
	passed to mcount.

Sun Nov 25 06:22:09 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/vms-ld.c, config/alpha/vms-cc.c: New files.
	* config/alpha/x-vms: New file, to compile the above.
	* config.gcc (alpha*-dec-vms*): Add x-vms.

2001-11-24  Hans-Peter Nilsson  <hp@axis.com>

	* genextract.c (main): Set ro_loc for peepholes.

Sat Nov 24 17:04:10 2001  Douglas B. Rupp  <rupp@gnat.com>

	* fix-header.c (main): Move inf_buffer termination and inf_limit
	calculation to after read.

	* config/alpha/xm-vms.h (FILE_TYPE): Remove undef and baggage.
	(__UNIX_FOPEN): Define.

Sat Nov 24 16:11:00 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (assign_stack_temp_for_type): Clear alias set before
	setting new one.

2001-11-23  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (print_operand, case 'v'): Use HOST_WIDE_INT_PRINT_HEX
	format.
	* rs6000.md (cmptf): Fix typo.

2001-11-23  Richard Sandiford  <rsandifo@redhat.com>

	* final.c (output_addr_const): Output PC as '.' even if !flag_pic.
	* varasm.c (output_constructor): Use assemble_integer rather
	than ASM_OUTPUT_BYTE.

2001-11-23  Andreas Jaeger  <aj@suse.de>

	* cpplex.c (cpp_interpret_charconst): Use HOST_WIDE_INT for sign
	extension.

2001-11-23  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/xscale-coff.h (SUBTARGET_CPU_DEFAULT): Override
	default definition.
	(SUBTARGET_EXTRA_ASM_SPEC): Remove previous definition.
	(MULTILIB_DEFAULTS): Remove previous definition.

2001-11-23  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppmacro.c (warn_of_redefinition): Warn regardless of -pedantic.
	* gcc.dg/cpp/mi6.c, gcc.dg/cpp/redef2.c: Update.

2001-11-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cris.h: Revert thinko in last patch.

2001-11-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* ChangeLog.0, ChangeLog.2, ChangeLog.3, ChangeLog.4, ChangeLog,
	FSFChangeLog.10, c-decl.c, cppfiles.c, cppinit.c, cpplex.c,
	cpplib.c, cppmain.c, cse.c, df.c, diagnostic.c, dominance.c,
	dwarf2out.c, dwarfout.c, emit-rtl.c, errors.c, except.c, except.h,
	explow.c, function.c, gcse.c, genrecog.c, predict.c, regmove.c,
	sched-rgn.c, ssa-ccp.c, stmt.c, toplev.c: Fix spelling errors.

	* predict.c, reg-stack.c: Fix spelling errors.

2001-10-09  Andrew Haley  <aph@redhat.com>

	* calls.c (check_sibcall_argument_overlap): Use slot_offset for
	start of stack slot.

2001-11-22  Graham Stott  <grahams@redhat.com>

	* cfgrtl.c (try_redirect_by_replacing_jump): Fix typo, emit
	replacement jump after original jump.

	(verify_flow_info): Remove redundent initialisation.
	Handle reaching end of insn list before finding a BARRIER.
	Only issue one missing barrier diagnostic.

2001-11-22  Graham Stott  <grahams@redhat.com>

	* local-alloc.c (combine_regs): Handle SUBREG_REG being a MEM.

Thu Nov 22 06:49:14 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/i386/i386.md (leave, leave_rex64): Have RTL reflect what
	insn actually does.

2001-11-22  Nick Clifton  <nickc@cambridge.redhat.com>

	* doc/invoke.texi (M32R/D Option Summary): Document -m32r switch.
	Fix typo -mm32rx=> -m32rx.

	* config/arm/arm.c (arm_elf_asm_named_section): Only build for elf
	targets.

	* config.gcc (xscale-coff): Add necessary header files to
	tm_file variable.

2001-11-20  Zack Weinberg  <zack@codesourcery.com>

	* rs6000.c (output_cbranch): Use $, not %$, in output template.

2001-11-21  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* tree-dump.c: Rename from c-dump.c. Include c-tree.h, not c-common.h.
	(lang_type_quals): Declare.
	(dequeue_and_dump): Use lang_hooks.tree_dump.type_quals function to
	retrieve language-specific qualifiers for a type node, instead of
	C_TYPE_QUALS. Likewise for lang_hooks.tree_dump.dump_tree instead of
	lang_dump_tree.
	* tree-dump.h: Rename from c-dump.h.
	* c-common.h (C_TYPE_QUALS): Removed.
	Move declarations for tree-dump.c interface to...
	* tree.h: ... here. Remove lang_dump_tree.
	* langhooks.h (struct lang_hooks_for_tree_dump): New.
	(struct lang_hooks): Add tree_dump hooks.
	* langhooks.c (lhd_tree_dump_dump_tree): New function.
	(lhd_tree_dump_type_quals): New function.
	* langhooks-def.h (lhd_tree_dump_dump_tree, lhd_tree_dump_type_quals):
	Declare.
	(LANG_HOOKS_INITIALIZER): Add tree_dump hooks.
	* Makefile.in: Move tree-dump.o to language-independent back-end.

2001-11-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* 1750a.h (DBX_REGISTER_NUMBER): Don't define.
	* alpha.h (DBX_REGISTER_NUMBER): Likewise.
	* arc.h (DBX_REGISTER_NUMBER): Likewise.
	* arm/aout.h (DBX_REGISTER_NUMBER): Likewise.
	* avr.h (DBX_REGISTER_NUMBER): Likewise.
	* c4x.h (DBX_REGISTER_NUMBER): Likewise.
	* clipper.h (DBX_REGISTER_NUMBER): Likewise.
	* convex.h (DBX_REGISTER_NUMBER): Likewise.
	* cris.h (DBX_REGISTER_NUMBER): Likewise.
	* dsp16xx.h (DBX_REGISTER_NUMBER): Likewise.
	* elxsi.h (DBX_REGISTER_NUMBER): Likewise.
	* fr30.h (DBX_REGISTER_NUMBER): Likewise.
	* h8300.h (DBX_REGISTER_NUMBER): Likewise.
	* i370.h (DBX_REGISTER_NUMBER): Likewise.
	* i860.h (DBX_REGISTER_NUMBER): Likewise.
	* i860/paragon.h (DBX_REGISTER_NUMBER): Likewise.
	* i860/sysv3.h (DBX_REGISTER_NUMBER): Likewise.
	* i860/sysv4.h (DBX_REGISTER_NUMBER): Likewise.
	* m32r.h (DBX_REGISTER_NUMBER): Likewise.
	* m68hc11.h (DBX_REGISTER_NUMBER): Likewise.
	* m88k.h (DBX_REGISTER_NUMBER): Likewise.
	* mcore/mcore-elf.h (DBX_REGISTER_NUMBER): Likewise.
	* mcore.h (DBX_REGISTER_NUMBER): Likewise.
	* mn10200.h (DBX_REGISTER_NUMBER): Likewise.
	* mn10300.h (DBX_REGISTER_NUMBER): Likewise.
	* pdp11.h (DBX_REGISTER_NUMBER): Likewise.
	* romp.h (DBX_REGISTER_NUMBER): Likewise.
	* rs6000.h (DBX_REGISTER_NUMBER): Likewise.
	* rs6000/sysv4.h (DBX_REGISTER_NUMBER): Likewise.
	* s390/linux.h (DBX_REGISTER_NUMBER): Likewise.
	* stormy16.h (DBX_REGISTER_NUMBER): Likewise.
	* v850.h (DBX_REGISTER_NUMBER): Likewise.
	* vax.h (DBX_REGISTER_NUMBER): Likewise.
	* we32k.h (DBX_REGISTER_NUMBER): Likewise.

	* defaults.h (DBX_REGISTER_NUMBER): Provide a default.
	* doc/tm.texi (DBX_REGISTER_NUMBER): Update.

2001-11-21  H.J. Lu <hjl@gnu.org>

	* config/rs6000/sysv4.h (LIB_SPEC): Fix a typo.

2001-11-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* s390.c (s390_va_arg): Eliminate ALIGN parameter in call to
	emit_cmp_and_jump_insns.

	* stormy16.c (xstormy16_expand_builtin_va_arg,
	xstormy16_expand_casesi): Likewise.

Wed Nov 21 17:37:16 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (keep_stack_depressed): Major rework.
	(handle_epilogue_set, emit_equiv_load): New functions.
	(thread_prologue_and_epilogue_insns): keep_stack_depressed now
	has return value.
	* jump.c (returnjump_p_1): Also return 1 if SET with SET_IS_RETURN_P.
	* rtl.h (SET_IS_RETURN_P): New macro.

	* expr.c (expand_expr, case VIEW_CONVERT_EXPR): Refine slightly
	and also support TREE_ADDRESSABLE.
	* tree.def (VIEW_CONVERT_EXPR): Document TREE_ADDRESSABLE.

2001-11-21  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (cmptf_internal1): Replace %$ with $.

Wed Nov 21 16:44:01 2001  Douglas B. Rupp  <rupp@gnat.com>

	* cppfiles.c (STAT_SIZE_TOO_BIG): Define.
	(read_include_file): Use STAT_SIZE_TOO_BIG.

	* cppinit.c (INO_T_COPY): Define.
	(INO_T_EQ): Uppercase parameters.
	(append_include_chain): Use INO_T_COPY.

2001-11-21  Richard Sandiford  <rsandifo@redhat.com>

	* cfg.c: Fix typos and formatting in the introductory comment.

Wed Nov 21 12:38:37 CET 2001  Jan Hubicka

	* profile.c (compute_branch_probabilites):  Compute probabilities
	for entry/exit edges; estimate probabilities for zero counts.

2001-11-21  Jakub Jelinek  <jakub@redhat.com>

	* explow.c (probe_stack_range): Use LCT_NORMAL as second argument
	to emit_library_call.
	* function.c (expand_main_function, expand_function_start,
	expand_function_end): Likewise.
	* profile.c (output_func_start_profiler): Likewise.
	* stmt.c (expand_nl_goto_receivers): Use LCT_NORETURN as
	second argument to emit_library_call.
	* optabs.c (prepare_cmp_insn): Use LCT_CONST_MAKE_BLOCK
	as second argument to emit_library_call.
	* calls.c (emit_library_call): Update fn_type description.

2001-11-21  Jakub Jelinek  <jakub@redhat.com>

	* c-decl.c (c_expand_deferred_function): Only call c_expand_body
	if fndecl is still DECL_INLINE and has DECL_RESULT.

2001-11-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* clipper.c (clipper_movstr): Avoid uninitialized warning.
	* i960.c (is_mask, legitimize_address): Likewise.
	* m88k.c (m88k_expand_prologue): Likewise.
	* m88k.md: Likewise.
	* mcore.c (emit_new_cond_insn): Likewise.
	* stormy16.c (xstormy16_emit_cbranch): Likewise.

2001-11-20  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc: Delete powerpcle-*-solaris2* stanza.
	* config/rs6000/eabi.asm, config/rs6000/rs6000.c,
	config/rs6000/rs6000.h, config/rs6000/rs6000.md,
	config/rs6000/sol-ci.asm, config/rs6000/sol-cn.asm,
	config/rs6000/sysv4.h, config/rs6000/t-ppccomm,
	config/rs6000/t-ppcos: Expunge all references to Solaris.

	* config/rs6000/sol-c0.c, config/rs6000/sol2.h: Delete.

	* config/rs6000/rs6000.md: Replace '%$' with '$' in all
	output templates.
	* config/rs6000/rs6000.h: Define DEFAULT_PCC_STRUCT_RETURN to 0,
	and change RETURN_IN_MEMORY to just check AGGREGATE_TYPE_P.

2001-11-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* sh.md: Avoid uninitialized warnings.
	* vax.c (vax_rtx_cost): Likewise.

2001-11-15  Aldy Hernandez  <aldyh@redhat.com>

	* rs6000.c (direct_return): Check if we are saving altivec
	registers.
	(first_altivec_reg_to_save): New.
	Updated stack frame layout comments.
	(rs6000_stack_info): Calculate altivec register save size.
	Save link register if we saved some altivec registers.
	(rs6000_stack_info): Align save size to 16 if altivec abi or
	abi_darwin.
	(rs6000_stack_info): Calculate altivec register offsets.
	(rs6000_stack_info): Add altivec info to save_size.
	(debug_stack_info): Add altivec debug info.
	(rs6000_emit_prologue): Save altivec registers and vrsave.
	(compute_vrsave_mask): New.
	(altivec_expand_builtin): Remove unused variables.
	(rs6000_parse_abi_options): Add static qualifier.
	(rs6000_expand_builtin): Remove unused parameters.
	(altivec_expand_builtin): Cast bdesc_2arg to get rid of warning.
	(altivec_init_builtins): Same.
	(is_altivec_return_reg): New.
	(vrsave_operation): New.
	(ALTIVEC_REG_BIT): New.
	(generate_set_vrsave): New.

	* rs6000.md (get_vrsave): New.
	(set_vrsave): New.
	(*set_vrsave_internal): New.

	* rs6000.h (rs6000_stack): Add first_altivec_reg_save,
	altivec_save_offset, vrsave_save_offset, altive_size, vrsave_size,
	altivec_padding_size, vrsave_mask.
	(TOTAL_ALTIVEC_REGS): New.
	(EPILOGUE_USES): Add VRSAVE_REGNO.

2001-11-20  Jeff Law <law@redhat.com>

	* unroll.c (copy_loop_body): Update LABEL_NUSES for the
	exit label as necessary.

2001-11-20  Brad Kaiser  <bkaiser@acelink.net>

	* reload1.c (elimination_effects): Use function_invariant_p
	instead of CONSTANT_P when considering register equivalences.

2001-11-20  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc: Add FreeBSD/PowerPC target.
	(powerpc64-*-linux*, powerpc-*-sysv*, powerpc-*-netbsd*,
	powerpc-*-chorusos*, powerpc-*-eabiaix*, powerpc-*-eabisim*,
	powerpc-*-elf*, powerpc-*-eabi*, powerpc-*-rtems*,
	powerpc-*-linux*libc1, powerpc-*-linux*, powerpc-wrs-vxworks*,
	powerpcle-wrs-vxworks*, powerpcle-*-sysv*, powerpcle-*-elf*,
	powerpcle-*-eabisim*, powerpcle-*-eabi*, powerpcle-*-solaris2*): Add
	freebsd-spec.h to tm_file.
	(rs6000-*-lynxos*): Add lynx.h to tm_file.
	* config/freebsd.h: Tidy up.
	(USING_CONFIG_FREEBSD): Define.
	(FBSD_SWITCH_TAKES_ARG, FBSD_WORD_SWITCH_TAKES_ARG,
	FBSD_CPP_PREDEFINES, FBSD_CPP_SPEC, FBSD_STARTFILE_SPEC,
	FBSD_ENDFILE_SPEC, FBSD_LIB_SPEC): Remove (moved to freebsd-spec.h).
	(TARGET_HAS_F_SETLKW): Define.
	(ASM_OUTPUT_IDENT): Delete, the elfos.h definition is fine.
	* config/freebsd-spec.h: New file.
	* config/rs6000/freebsd.h: New file.
	* config/rs6000/rs6000.h (TARGET_VERSION): Do not define.
	* config/rs6000/rs6000.c: Test for USING_ELFOS_H rather than
	USING_SVR4_H to know when to turn on ELF support.
	* config/rs6000/sysv4.h (TARGET_VERSION, CPP_PREDEFINES): Don't undef,
	define only if not already defined.
	Add FreeBSD support.
	* config/rs6000/aix.h (TARGET_VERSION): Define.
	* config/rs6000/beos.h: Likewise.
	* config/rs6000/darwin.h: Likewise.
	* config/rs6000/mach.h: Likewise.
	* config/rs6000/lynx.h (TARGET_VERSION): Likewise.
	Don't include lynx.h directly.

2001-11-20  Graham Stott  <grahams@redhat.com>

	* unwind-dw2-fde.c (__deregister_frame_info_bases):
	Fix lossage in last change return OB.

Tue Nov 20 11:56:12 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/xm-vms.h (_POSIX_EXIT): Define.
	Remove unneeded exit related macros.

2001-11-20  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (rs6000_emit_eh_toc_restore): Remove ALIGN parm.

	* rs6000.c (rs6000_emit_move): Add TFmode case.
	* sysv4.h (MASK_LONG_DOUBLE_128, TARGET_LONG_DOUBLE_128,
	LONG_DOUBLE_TYPE_SIZE, MAX_LONG_DOUBLE_TYPE_SIZE,
	LIBGCC2_LONG_DOUBLE_TYPE_SIZE): Move from here...
	* rs6000.h: ... to here.
	* rs6000.md (movtf, extenddftf2, extendsftf2, trunctfdf2,
	trunctfsf2, floatditf2, floatsitf2, fix_trunctfdi2,
	fix_trunctfsi2, negtf2, abstf2, nabstf2, cmptf): New patterns.

Tue Nov 20 06:41:38 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* emit-rtl.c (get_mem_attrs): Fix typo.

2001-11-20  Jakub Jelinek  <jakub@redhat.com>

	* c-lang.c (finish_file): Backout 2001-11-16
	changes, instead set DECL_DEFER_OUTPUT for static inline functions
	before calling c_expand_deferred_function.

2001-11-20  Jakub Jelinek  <jakub@redhat.com>

	* unwind-dw2-fde.c (__register_frame_info_bases, __register_frame):
	Don't register empty .eh_frame sections.
	(__deregister_frame_info_bases, __deregister_frame): Don't
	unregister them either.

2001-11-19  Geoffrey Keating  <geoffk@redhat.com>

	* configure.in (HAVE_AS_GDWARF2_DEBUG_FLAG): Define.
	(HAVE_AS_GSTABS_DEBUG_FLAG): Define.
	* configure: Regenerate.
	* config.in: Add dummy definitions of new flags.
	* toplev.c (PREFERRED_DEBUGGING_TYPE): Move definition to...
	* defaults.h (PREFERRED_DEBUGGING_TYPE): ... here.
	* gcc.c (ASM_DEBUG_SPEC): New macro.
	(asm_debug): New static variable.
	(default_compilers): Add asm_debug when assembling from
	user input.
	(static_specs): Add asm_debug.

2001-11-20  Loren J. Rittle  <ljrittle@acm.org>

	* config.gcc (*-*-freebsd*): Remove configuration block.

2001-11-19  Loren J. Rittle  <ljrittle@acm.org>

	bootstrap/4422
	* configure.in: Setup ability to run ./stage[1234]/xgcc in
	fixinc *as if* it were a proper lang subdirectory.
	* configure: Rebuilt.

2001-11-19  Loren J. Rittle  <ljrittle@acm.org>

	* config/freebsd.h: Remove DEFAULT_VTABLE_THUNKS (again).

2001-11-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* 1750a.md: Don't use hex format for a const_int.

2001-11-19  Geoffrey Keating  <geoffk@redhat.com>

	* expmed.c (extract_bit_field): Don't create invalid SUBREGs.

2001-11-19  Zack Weinberg  <zack@codesourcery.com>

	* mkconfig.sh: Undefine ENABLE_NLS if GENERATOR_FILE is
	defined (prevents link errors when gettext isn't in the system
	library).

2001-11-19  DJ Delorie  <dj@redhat.com>

	* read-rtl.c (ISDIGIT, ISSPACE): Make sure we have these.
	(validate_const_int): New.
	(read_rtx): Validate constant integers.
	* config/i386/i386.md (pmulhrwv4hi3): Use decimal constants.

2001-11-19  Jakub Jelinek  <jakub@redhat.com>

	* doc/hostconfig.texi (DUMPFILE_FORMAT): Move into the table.

Mon Nov 19 16:57:44 2001  Douglas B. Rupp  <rupp@gnat.com>

	* toplev.c (DUMPFILE_FORMAT): Define default.
	(open_dump_file): Use DUMPFILE_FORMAT in sprintf.
	(close_dump_file, compile_file): Likewise.
	* config/alpha/xm-vms.h (DUMPFILE_FORMAT): Define.
	* doc/hostconfig.texi (DUMPFILE_FORMAT): Document

2001-11-19  Jeff Law <law@redhat.com>

	* gcse.c (cprop_jump): Clear JUMP_LABEL field when we create
	a nop-jump.

2001-11-19  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppmacro.c (_cpp_backup_tokens): Revert previous check-in.
	Don't fall off the base token run.

2001-11-19  Jason Wilkins <fenix@io.com>

	* Makefile.in: Use INSTALL_SCRIPT not INSTALL_PROGRAM.

Mon Nov 19 15:13:43 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.def (VIEW_CONVERT_EXPR): New tree code.
	* tree.h (handled_component_p): New declaration.
	* alias.c (handled_component_p): Move function from here ...
	* expr.c (handled_component_p): ... to here and non longer static.
	(is_zeros_p, case VIEW_CONVERT_EXPR): New case.
	(store_field): Remove unneeded MEM_COPY_ATTRIBUTES call.
	(get_inner_reference): Handle VIEW_CONVERT_EXPR.
	(expand_expr, case VAR_DECL): Clean up handling of re-layout case.
	(expand_expr, case VIEW_CONVERT_EXPR): New case.
	(expand_expr, cse ADDR_EXPR): No need to copy if already
	BIGGEST_ALIGNMENT.
	* fold-const.c (fold, case VIEW_CONVERT_EXPR): New case.
	* varasm.c (initializer_constant_value_p, case VIEW_CONVERT_EXPR): New.
	(output_constant): Handle VIEW_CONVERT_EXPR.
	* dwarf2out.c (loc-descriptor_from_tree, add_bound_info):
	Add new case for VIEW_CONVERT_EXPR.

2001-11-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* a29k/unix.h (ASM_FILE_START): Const-ify.
	* i386/beos-elf.h (INCLUDE_DEFAULTS): Remove semi-colon.
	* i386/isc.h (ASM_FILE_START): Const-ify.
	* i386/sun386.h (ASM_FILE_START): Likewise.
	* m32r.md: Likewise.
	* m68k/auxas.h (ADDITIONAL_REGISTER_NAMES): Add missing brackets.
	* m68k/auxgas.h ADDITIONAL_REGISTER_NAMES): Likewise.
	* m68k/tower.h (REGISTER_NAMES): Remove semi-colon.
	* mn10200.md: Initialize variable.

Mon Nov 19 18:06:21 CET 2001  Jan Hubicka  <jh@suse.cz>

	* gcse.c (try_replace_reg): Copy RTX before creating note.

	* df.h (df_ref_flags): New uenum.
	(DF_REF_FLAGS): New macro.
	(struct ref): Add field "flags".
	* df.c (HANDLE_SUBREG): Remove.
	(df_ref_create): Likewise; set flags field of ref.
	(df_def_record_1): Strip down read_write subreg; remove
	commented out code; set READ_WRITE flag.
	(read_modify_subreg_p): New static function.
	(df_uses_record): Cleanup SET handling; set READ_WRITE flag;
	new argument "flags".
	(df_insn_refs_record): Update call of df_uses_record.
	(df_insn_modify): Avoid #if 0 around comment.
	(df_dump): Dump the read/write flag.

	* predict.c (propagate_freq): Make cyclic_probability and frequency
	volatile

	* i386.c (ix86_cc_mode): Accept USE.

	* cfgrtl.c (purge_dead_edges):  Cleanup EDGE_ABNORMAL flag if computed
	jump is turned into simplejump.

2001-11-19  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/fragments.texi, doc/trouble.texi: Remove links to old
	installation chapter.
	* doc/gcc.texi: Don't claim that this manual documents
	installation.  Mark Installation menu entry as being out of date.

Mon Nov 19 07:21:35 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/xm-vms.h: Don't define macros that autoconf handles.
	(SUCCESS_EXIT_CODE, FATAL_EXIT_CODE): Define for posix compatibility.
	* gcc.c (exit): Remove definition for VMS; moved to xm-vms.h.

2001-11-19  Jason Merrill  <jason@redhat.com>

	* cppmacro.c (_cpp_backup_tokens): Pop cur_run before decrementing
	cur_token, not after.

	* config/clipper/clix.h, config/h8300/elf.h, config/mips/linux.h:
	Lose ASM_OUTPUT_CONSTRUCTOR.
	* system.h: Poison it and INT_ASM_OP.
	* c-lang.c (finish_file): Don't check for it.
	* libgcc2.c (L_ctors): Check TARGET_ASM_CONSTRUCTOR instead.

2001-11-18  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mmix.c (mmix_cc1_ignored_option): Const-ify.
	(mmix_init_machine_status): Make static to match declaration.
	(mmix_unique_section): Const-ify.
	(mmix_output_quoted_string): Avoid automatic aggregate
	initialization.
	(mmix_output_register_setting): Likewise.
	(mmix_output_shiftvalue_op_from_str): Likewise.

	* mmix.h (mmix_cc1_ignored_option): Const-ify.
	(ASM_OUTPUT_BYTE): Fix format specifier warning.
	(ASM_GENERATE_INTERNAL_LABEL): Likewise.

2001-11-18  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	PR c/4448
	* gthr-win32.h: (__gthread_objc_thread_exit): Fix variable
	name __objc_thread_exit_status so that it matches the
	variable defined in objc/thr.h.

2001-11-18  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	PR bootstrap/4020
	* mklibgcc.in: Add missing semi-colons.
	* Makefile.in: Same.

Sun Nov 18 16:47:00 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case VAR_DECL): Update alignment of DECL_RTL
	after re-laying out decl in incomplete case.
	(expand_expr, case ADDR_EXPR): Fix typo in copy case.

2001-11-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install-old.texi: Move some sections out to ...
	* doc/collect2.texi, doc/configfiles.texi, doc/headerdirs.texi:
	... here.  New files.  Make into chapters rather than sections.
	* doc/gcc.texi: Include the new files and add menu entries for
	them.
	* Makefile.in ($(docdir)/gcc.info, gcc.dvi): Update dependencies.

Sun Nov 18 14:13:52 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.h (TYPE_ALIGN_OK): New flag.
	* emit-rtl.c (set_mem_attributes): Handle it.
	* expr.c (emit_single_push_insn): Only set to alias set 0 if
	doing sibcall optimization.
	(expand_expr, case COMPONENT_REF): Call set_mem_attributes on case
	when make temporary.
	(expand_expr, case CONVERT_EXPR): Simplify convert-to-union case.
	(expand_expr, case ADDR_EXPR): Abort if TYPE_ALIGN_OK and need copy.

	* sdbout.c (sdbout_symbol): Avoid warning due to &DECL_RTL.

2001-11-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (c_decode_option): Give deprecation warning for
	-traditional.
	* doc/invoke.texi (-traditional): Note that this option is
	deprecated.

Sun Nov 18 07:40:07 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/alpha.c (alpha_start_function, VMS): Cast shift
	arg to HOST_WIDE_INT, not long.

	* config/alpha/vms.h (DIR_SEPARATOR, PREFIX). Don't define.
	(HAS_INIT_SECTION): Define.
	(REAL_ARITHMETIC): Don't undefine.

2001-11-18  Egor Duda  <deo@logos-m.ru>

	* config/i386/cygwin.h: Strip leading '*' from name, if any.

2001-11-18  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Makefile.in (c-parse.o, c-common.o): Update dependencies.
	* c-common.c: Include diagnostic.h.
	(c_common_finish): New.
	* c-common.h (c_common_finish): New.
	* c-lang.c (LANG_HOOKS_FINISH): Override.
	* c-parse.in: Don't include diagnostic.h.
	(finish_parse): Remove.
	* langhooks.h: Update comments.
	* toplev.c (lang_dependent_init): New prototype.
	(finalize): New.
	(compile_file): Split cleanup code out to finalize.
	(lang_dependent_init): Stop if lang_hooks.init fails.
	(toplev_main): Update.
	* tree.h (finish_parse): Remove.
objc:
	* objc-act.c (LANG_HOOKS_FINISH): Override.

Sat Nov 17 23:30:44 2001  Douglas B. Rupp  <rupp@gnat.com>

	* config/alpha/t-vms (LIB2FUNCS_EXTRA): Add vms_tramp.asm.
	* config/alpha/vms_tramp.asm: New file.
	* config/alpha/vms-tramp.asm: Removed.

2001-11-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (struct disabled_builtin, disabled_builtins,
	disable_builtin_function, builtin_function_disabled_p): New.
	(builtin_function_2): Check for disabled built-in functions.
	* c-common.h (disable_builtin_function): Declare.
	* c-decl.c (c_decode_option): Handle -fno-builtin-FUNCTION.
	* doc/invoke.texi: Document -fno-builtin-FUNCTION.
	* doc/extend.texi: Mention -fno-builtin-FUNCTION.

2001-11-17  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	PR target/4606
	* config.gcc: Remove reference to va-clipper.h.

2001-11-17  Stan Shebs  <shebs@apple.com>

	* config/rs6000/rs6000.h (REG_CLASS_CONTENTS): Fix the
	AltiVec-related bitfields.

Sat Nov 17 12:06:31 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* except.c (enum eh_region_type): Add ERT_UNKNOWN.
	(mark_eh_region, case ERT_UKNONW): New case.

2001-11-17  Christopher Faylor  <cgf@redhat.com>
	    Corinna Vinschen  <vinschen@redhat.com>

	* config/i386/cygwin.h: Search target specific include directory for
	w32api stuff, if appropriate.

Sat Nov 17 08:20:44 2001  Douglas Rupp  <rupp@gnat.com>

	* config/alpha/vms.h (REG_ALLOC_ORDER): Redefine.

2001-11-16  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.md: Change all ldvx to lvx.

2001-11-16  Alexandre Oliva  <aoliva@redhat.com>

	* gensupport.c (process_rtx): Don't assume filename is the first
	argument of any rtl.

2001-11-16  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* vax-protos.h (reg_was_0_p): New prototype.
	* vax.md (movsi, movhi, movqi): Use reg_was_0_p.
	* vax.c (follows_p, reg_was_0_p): New functions.

2001-11-16  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* vax.md (casesi): Swap arguments in "(plus:SI (pc) (mult))". Reformat.
	(casesi1): Likewise.  Define new pattern which arises by simplification
	when operand 1 is a constant int.  Correct pattern which arises by
	simplification when operand 1 is zero.

2001-11-16  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (arm*-*-rtems*, arm-*-coff*, armel-*-coff*,
	arm-*-vxworks*, arm-*-riscix1.[01]*, arm-*-riscix*,
	arm-semi-aout, armel-semi-aout, arm-semi-aof, armel-semi-aof,
	arm*-*-netbsd*, arm*-*-linux*, arm*-*-uclinux*, arm*-*-aout,
	arm*-*-ecos-elf, arm*-*-elf, arm*-*-conix*, arm*-*-oabi,
	arm-*-pe*, strongarm-*-elf*, strongarm-*-coff*, strongarm-*-pe,
	xscale-*-elf, xscale-*-coff: Include various CPU headers via tm_file.
	* config/arm/aof.h: Don't include arm.h.
	* config/arm/aout.h: Likewise.
	* config/arm/coff.h: Don't include semi.h and aout.h.
	* config/arm/elf.h: Don't include aout.h.
	* config/arm/netbsd.h: Don't include netbsd.h and aout.h.
	(TARGET_VERSION): Undef before defining.
	(ARM_OS_NAME): Likewise
	(TARGET_DEFAULT): Likewise
	(TARGET_MEM_FUNCTIONS): Do not need to undefine now.
	* config/arm/pe.h: Don't include arm/coff.h.
	* config/arm/riscix.h (CPP_SPEC, SUBTARGET_CPP_SPEC): Use
	SUBTARGET_CPP_SPEC rather than overiding the arm.h CPP_SPEC definition.
	* config/arm/riscix1-1.h: Likewise.
	* config/arm/rix-gas.h: Don't include riscix.h.
	(DBX_CONTIN_LENGTH): Undef before defining.
	* config/arm/semi.h: Don't include aout.h.
	* config/arm/semiaof.h: Don't include aof.h.
	* config/arm/strongarm-coff.h: Don't include coff.h.
	* config/arm/strongarm-pe.h: Don't include strongarm-coff.h and pe.h.
	* config/arm/vxarm.h: Don't include arm/coff.h.
	* config/arm/xscale-coff.h: Don't include coff.h.

Fri Nov 16 15:22:35 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/pa/pa.c: Reflect changes in calling sequences of alter_reg and
	emit_cmp_insn.

2001-11-16  Andreas Jaeger  <aj@suse.de>

	* cfglayout.c (fixup_fallthru_exit_predecesor): Make void, rename
	to ....
	(fixup_fallthru_exit_predecessor): ... this.
	Change callers and prototype.

2001-11-16  Bernd Schmidt  <bernds@redhat.com>

	* config/i386/i386.c (ix86_expand_sse_comi): Generate setcc by
	hand; don't use gen_setcc_2.
	(ix86_expand_builtin): Fix pshufw.
	* config/i386/i386.md (maskncmpv4sf3, vmmmaskncmpv4sf3): Special
	case UNORDERED to emit the right assembler instruction.
	(mmx_pshufw): Lose operand 2.
	(cvtsi2ss): Fix representation.
	From Graham Stott:
	(mmx_clrdi, sse_clrti, stmxcsr, ldmxcsr): Set memory attribute.

2001-11-16  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/include/linux-and-gnu.texi: Remove.
	* doc/gnu.texi: New.
	* doc/gcc.texi: Include gnu.texi instead of linux-and-gnu.texi.
	* Makefile.in ($(docdir)/gcc.info, gcc.dvi): Update dependencies.

2001-11-16  Kazu Hirata  <kazu@hxi.com>

	* config/a29k/a29k.c: Fix comment formatting.
	* config/a29k/a29k.h: Likewise.
	* config/arc/arc.c: Likewise.
	* config/arc/arc.h: Likewise.
	* config/vax/vax.c: Likewise.
	* config/vax/vax.h: Likewise.
	* config/we32k/we32k.c: Likewise.
	* config/we32k/we32k.h: Likewise.

2001-11-16  Jeff Law  <law@redhat.com>

	* unroll.c (copy_loop_body): Initialize JUMP_LABEL field after
	creating a new jump insn.

Fri Nov 13 09:06:25 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case ADDR_EXPR): Refine test for when to
	copy misaligned data.
	* varasm.c (assemble_variable): Set alignment into MEM when changed.

2001-11-16  Graham Stott  <grahams@redhat.com>

	* optabs.c (prepare_cmp_insn): Correct lossage in last change fix
	OPALIGN type.

2001-11-16  Olivier Hainque <hainque@act-europe.fr>

	* except.c: Support for catching a list of types with a single handler
	(struct eh_region): Change type and filter to lists for catch regions.
	(mark_eh_region): Mark the filter list for GC also.
	(expand_start_catch): Always build a list if argument not NULL and
	register each type of the list through add_type_for_runtime.
	(duplicate_eh_region_1): Change type into type_list for catch regions.
	(assign_filter_values): Assign a filter to each type associated with a
	catch region. Assign filter for NULL types in a unique entry in the
	filter list.
	(build_post_landing_pads): Emit compare and jump for each filter of
	the list associated with a catch region.
	(reachable_next_level): When the type thrown is known, stop the search
	as soon as one type within a catch list matches. Also, a handler is
	potentially reachable only if at least one of the types it catches
	has not been previously caught.
	(collect_one_action_chain): Retrieve the filter for a NULL type list
	from the first filter list entry. For non NULL type lists, add an
	action record for every filter assigned.
	* except.h: Reflect changes in comment before expand_start_catch.

Fri Nov 16 07:12:51 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case ADDR_EXPR): Only copy for misaligned if
	BLKmode.

Fri Nov 16 06:37:05 2001  Andreas Tobler  <a.tobler@schweiz.ch>

	* config/sparc/sparc.c: Remove ALIGN arg from emit_cmp_insn.

2001-11-16  Jakub Jelinek  <jakub@redhat.com>

	* c-lang.c (finish_file): Don't emit static inline functions if
	they weren't referenced.

2001-11-15  Stan Shebs  <shebs@apple.com>

	* expr.c (expand_expr, case COMPONENT_REF): Fix variable ref.

2001-11-16  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* config/s390/s390.md: Remove ALIGN arg from emit_cmp_and_jump_insns
	call.
	* config/i386/i386.md: Likewise.

Thu Nov 15 21:40:16 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* timevar.c (rtl.h): Include so get fancy abort.

2001-11-15  Dale Johannesen  <dalej@apple.com>

	* config/darwin.h (SELECT_RTX_SECTION):  Force address
	initializers into 'const' section
	* config/rs6000/rs6000.c (rs6000_emit_cmove):  Fix mode of
	if_then_else to match result, not operands

Thu Nov 15 17:57:48 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* alias.c (nonoverlapping_memrefs): Use REGNO_PTR_FRAME_P.
	* emit-rtl.c (change_address): Fix typo in default alignment.
	(adjust_address_1): Use mode of NEW, not MODE, when setting size.
	* expr.c (highest_pow2_factor, case WITH_RECORD_EXPR): New case.
	* rtl.h (REGNO_PTR_FRAME_P): New macro.

	* expr.c (store_field): Pass tree instead of max size; callers changed.
	Change handling of alignment.
	Only copy to_rtx if is TARGET.
	(expand_expr_unaligned): Delete; callers now use expand_expr.
	(emit_cmp_insn): No longer take ALIGN parm; all callers changed.
	(expand_assignment): Change handling of alignment.
	Only copy to_rtx if was original.
	(get_inner_reference): No longer return alginment; callers changed.
	(expand_expr, case COMPONENT_REF): Change handling of alignment.
	(expand_expr, case ADDR_EXPR): Make copy if not sufficiently aligned.
	(compare_from_rtx): Delete ALIGN parm; all callers changed.
	(do_compare_rtx_and_jump): Likewise.
	* expr.h: Reflect above changes.
	* tree.h: Likewise.
	* dwarf2out.c (loc_descriptor_from_tree): Remove ALIGN parameter
	to get_inner_reference.
	* builtins.c: Remove ALIGN parm in call to emit_cmp_and_jump_insns.
	* doloop.c, except.c, explow.c, loop.c, stmt.c, unroll.c: Likewise.
	* optabs.c: Likewise.
	(prepare_cmp_insn): Now static; remove ALIGN parm.  Callers changed.
	(emit_cmp_and_jump_insns): Remove ALIGN parm; all callers changed.
	* expmed.c: Remove ALIGN arg from calls to compare_from_rtx,
	compare_rtx_and_jump, and emit_cmp_jump_insns.
	* fold-const.c: Remove PALIGN in calls to get_inner_reference.
	* function.c (assign_stack_temp_for_type): No longer static.
	* optabs.h (emit_cmp_insn): Remove ALIGN parm.
	(prepare_cmp_insn): Delete declaration.
	* rtl.h (assign_stack_temp_for_type): Add declaration.
	* config/alpha/alpha.c, config/d30v/d30v.c: Reflect above changes.
	* config/clipper/clipper.c, config/h8300/h8300.c: Likewise.
	* config/i386/i386.c,config/mips/mips.c: Likewise.
	* config/i860/i860.c, config/ia64/ia64.c: Likewise.
	* config/rs6000/rs6000.c, config/sh/sh.c: Likewise.

2001-11-15  Stan Shebs  <shebs@apple.com>

	* config/rs6000/rs6000.h: Fix a comment typo.
	(RTX_COSTS): Sort processor versions better.

2001-11-15  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md: Fix insn length of bit insns.

2001-11-15  Jason Merrill  <jason@redhat.com>

	* dwarf2out.c (dwarf2out_finish): Don't abort because of orphan
	DIEs if there were errors in the source.

	* config/alpha/alpha-interix.h, config/alpha/elf.h,
	config/arm/coff.h, config/i386/djgpp.h, config/i386/i386.c,
	config/i386/i386.h, config/i386/sco5.h, config/i960/i960-coff.h,
	config/m68k/coff.h, config/m88k/m88k.h, config/m88k/m88k.c,
	config/pa/pa64-hpux.h, config/sh/sh.h, config/sparc/litecoff.h,
	config/elfos.h, config/lynx.h, config/netware.h,
	config/m68hc11/m68hc11.h, config/mcore/mcore-pe.h,
	config/s390/linux64.h: Remove definitions of INT_ASM_OP, change
	uses to use ASM_LONG.

2001-11-15  Alan Matsuoka  <alanm@redhat.com>

	* gensupport.c	process_include : Change call to alloca to
	xmalloc.

2001-11-15  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.md: Use spaces instead of tabs in output
	templates.

Thu Nov 15 08:36:39 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* final.c (alter_subreg): If simplify_subreg can't do anything,
	handle REG ourselves and abort for others.

2001-11-15  Richard Hodson  <hodsonr@dionecorp.com>

	* config/h8300/h8300.c (dosize): Avoid corrupting R3 in interrupt
	routines.

2001-11-15  Neil Booth  <neil@daikokuya.demon.co.uk>

	* fix-header.c (read_scan_file): Update.

Thu Nov 15 08:36:39 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* toplev.c (toplev_main): Don't start timing until after
	command-line options are parsed.

2001-11-15  Andreas Schwab  <schwab@suse.de>

	* config.gcc: Set STMP_FIXPROTO and FIXPROTO_DEFINES in target
	makefile frag, not host makefile frag.
	(m88k-dg-dguxbcs*): Add m88k/t-dgux to tmake_file.
	(hppa*): Add pa/t-bsd to tmake_file where no special xmake_file is
	used.
	(hppa*-*-openbsd*): Don't use nonexitent pa/t-openbsd.
	* config/m88k/t-dguxbcs: Remove definitions already in t-dgux.
	* config/m88k/t-dgux (STMP_FIXPROTO): Define.
	* config/i386/t-cygwin (STMP_FIXPROTO): Define.
	* config/i386/t-dgux (STMP_FIXPROTO): Define.
	* config/x-interix: Don't define STMP_FIXPROTO and
	FIXPROTO_DEFINES.
	* config/t-interix: New file, define STMP_FIXPROTO.
	* config/i386/x-beos (STMP_FIXPROTO): Don't define here.
	* config/i386/t-beos (STMP_FIXPROTO): Define here instead.
	* config/t-svr4 (FIXPROTO_DEFINES): Define.
	* config/arm/t-riscix (FIXPROTO_DEFINES): Define.
	* config/i386/t-sco5 (FIXPROTO_DEFINES): Define.
	* config/i386/t-sco5gas (FIXPROTO_DEFINES): Define.
	* config/m68k/t-hp3200: Renamed from x-hp3200.
	* config/i370/t-oe: Renamed from x-oe.
	* config/mips/t-iris: Renamed from x-iris.
	* config/pa/t-bsd: Renamed from x-pa.
	* config/pa/t-pa-hpux: Renamed from x-pa-hpux.
	* config/x-linux, config/i386/x-cygwin, config/i386/x-dgux,
	config/m88k/x-dgux, config/x-svr4, config/arm/x-riscix,
	config/i386/x-sco5, config/m68k/x-hp320g, config/mips/x-iris6,
	config/rs6000/x-cygwin: Remove files.

	* configure.in: Check for target objdump and use that in eh_frame
	optimization test.
	* configure: Regenerated.

2001-11-15  Jakub Jelinek  <jakub@redhat.com>

	* jump.c (squeeze_notes): Return true if no real insns were found.
	* rtl.h (squeeze_notes): Adjust prototype.
	* cfgcleanup.c (merge_blocks_move_predecessor_nojumps): If
	squeeze_notes finds no real instructions, abort.
	(merge_blocks_move_successor_nojumps): Likewise.
	* loop.c (find_and_verify_loops): Likewise.
	* stmt.c (expand_end_case): Likewise.
	* ifcvt.c (dead_or_predicable): Return TRUE if squeeze_notes doesn't
	find any real instructions.

	* config/ia64/ia64.c (ia64_adjust_cost): Handle SUBREGs.

	* cfgcleanup.c (try_optimize_cfg): If try_simplify_condjump optimized
	conditional jump, request updating life into for the block
	containing it.  Fix a typo which prevented life info update.
	Clear blocks bitmap before using it.

2001-11-15  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-common.c: Include c-lex.h.
	(c_common_lang_init): Change prototype.  Call init_c_lex and
	init_pragma from here.
	* c-common.h (c_common_lang_init): Change prototype.
	* c-decl.c (init_decl_processing): Rename.  Call c_parse_init.
	* c-lang.c (c_init): Change prototype.  Update.
	(c_init_options): Update.
	* c-lex.c (cpp_filename): Remove.
	(init_c_lex): Update.  Read the main file, and get the original
	file name.
	(yyparse): Finish the command line options.
	* c-parse.in (c_parse_init): Call init_reswords here.
	(init_parse): Remove.
	* c-tree.h (c_init_decl_processing): New.
	* cpphash.c (_cpp_init_hashtable): After initializing the hash
	table, populate it.
	* cppinit.c (read_original_filename, cpp_finish_options): New.
	(cpp_create_reader): New prototype. Defer hash table initialization.
	(cpp_start_read): Rename cpp_read_main_file.  Initialize the
	hash table.  Get the original filename.
	* cpplib.h (cpp_create_reader): Update.
	(cpp_start_read): Remove.
	(cpp_read_main_file, cpp_finish_options): New.
	* cppmain.c (main, do_preprocessing): Update.
	* langhooks.h (struct langhooks): Update init prototype.
	* toplev.c (general_init, parse_options_and_default_flags,
	process_options, lang_indpendent_init, lang_dependent_init,
	init_asm_output): New; perform the bulk of initialization.
	(compile_file): Move most of initialization to above functions.
	(debug_hooks): Initialize statically.
	(set_Wunused): Relocate.
	(toplev_main): Move most of initialization to other init functions.
	Have a clear logic flow.
	* tree.h (init_parse, init_decl_processing): Remove.
objc:
	* objc-act.c (objc_init): Update prototype, combine with old
	init_parse.
	(objc_init_options): Update.


2001-11-15  Andreas Jaeger  <aj@suse.de>

	* cfgrtl.c (purge_all_dead_edges): Use int as argument for
	portability.
	* basic-block.h: Adjust prototype.

2001-11-15  Kazu Hirata  <kazu@hxi.com>

	* config/rs6000/aix31.h: Fix comment formatting.
	* config/rs6000/beos.h: Likewise.
	* config/rs6000/darwin.h: Likewise.
	* config/rs6000/eabi.asm: Likewise.
	* config/rs6000/linux.h: Likewise.
	* config/rs6000/linux64.h: Likewise.
	* config/rs6000/lynx.h: Likewise.
	* config/rs6000/netbsd.h: Likewise.
	* config/rs6000/rs6000.c: Likewise.
	* config/rs6000/rs6000.h: Likewise.
	* config/rs6000/rs6000.md: Likewise.
	* config/rs6000/sol2.h: Likewise.
	* config/rs6000/tramp.asm: Likewise.
	* config/rs6000/xcoff.h: Likewise.
	* config/rs6000/xm-beos.h: Likewise.

2001-11-14  Alan Matsuoka  <alanm@redhat.com>

	* rtl.def (INCLUDE) : Define.
	* gensupport.c  (init_include_reader, process_include,
	save_string) :  New functions to implement an include facility
	in .md files.
	* gensupport.h : Add prototype for init_md_reader_args.
	* genattr.c genattrtab.c gencodes.c genconfig.c genemit.c
	genextract.c genflags.c genopinit.c genoutput.c
	genpeep.c genrecog.c: Change call to init_md_reader to
	init_md_reader_args.
	* md.texi: Document (include "path") and -I directives for RTL
	generation tools.

2001-11-14  DJ Delorie  <dj@redhat.com>

	* integrate.c (get_hard_reg_initial_reg): New.
	* integrate.h (get_hard_reg_initial_reg): Prototype.
	* local-alloc.c (block_alloc): Don't tie pseudos that
	represent call-saved hard regs' initial values.

2001-11-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* m68k/linux.h: Include <linux.h> not "linux.h" to avoid infinite
	recursion.

2001-11-14  Roger Sayle <roger@eyesopen.com>

	* fold-const.c (fold): Optimize strlen comparisons against zero.

2001-11-14  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (sparc64-wrs-vxworks*, sparc-*-netbsd*, sparc-*-openbsd*,
	sparc-*-chorusos*, sparc-*-elf*, sparc-*-linux*aout*,
	sparc-*-linux*libc1*, sparc-*-linux*, sparc-*-lynxos*, sparc-*-rtems*,
	sparc-*-rtemself*, sparc-hal-solaris2*, sparc-*-solaris2*,
	sparc-*-sunos4.0*, sparc-*-sunos4*, sparc-*-sunos3*, sparc-*-sysv4*,
	sparc-*-vxsim*, sparclite-*-aout*, sparclite-*-elf*, sparc86x-*-aout*,
	sparc86x-*-elf*, sparc64-*-aout*, sparc64-*-elf*, sparc64-*-linux*):
	Include various CPU headers via tm_file.  a.out based platforms now
	properly include sparc/aout.h.  sol2.h usage now implies including
	elfos.h, svr4.h, and sparc/sysv4.h.
	* config/netbsd.h (TARGET_MEM_FUNCTIONS): Undef before defining it.
	Also define to '1'.
	* sparc/sparc.h (CPP_PREDEFINES, TARGET_VERSION, WORD_SWITCH_TAKES_ARG,
	SELECT_SECTION, ASM_DECLARE_FUNCTION_NAME, TEXT_SECTION_ASM_OP,
	DATA_SECTION_ASM_OP, DBX_REGISTER_NUMBER, ASM_OUTPUT_SOURCE_LINE):
	Remove.  They are a.out specific and belong in sparc/aout.h.
	* sparc/aout.h (TARGET_VERSION, WORD_SWITCH_TAKES_ARG, SELECT_SECTION,
	ASM_DECLARE_FUNCTION_NAME, TEXT_SECTION_ASM_OP, DATA_SECTION_ASM_OP,
	DBX_REGISTER_NUMBER, ASM_OUTPUT_SOURCE_LINE): Define.  Moved here from
	sparc/sparc.h.
	* sparc/litecoff.h (WORD_SWITCH_TAKES_ARG, ASM_DECLARE_FUNCTION_NAME,
	TEXT_SECTION_ASM_OP, DATA_SECTION_ASM_OP, DBX_REGISTER_NUMBER): Define.
	Moved here from sparc/sparc.h.
	* config/sparc/linux-aout.h (DEFAULT_PCC_STRUCT_RETURN): Undef before
	defining.
	* config/sparc/linux64.h (UNALIGNED_DOUBLE_INT_ASM_OP): Undef before
	* config/sparc/lynx.h:  Don't include lynx.h.
	(SELECT_SECTION): Do not undef.
	* config/sparc/openbsd.h: Don't include sparc/sparc.h.
	* config/sparc/sol2-sld-64.h: Include sparc/sparc.h, elfos.h, svr4.h,
	and sparc/sysv4.h.
	* config/sparc/sol2.h: Don't include sparc/sparc.h and sparc/sysv4.h.
	* config/sparc/sp64-aout.h (CPP_PREDEFINES): Don't define.  Get from
	sparc/aout.h now.
	* config/sparc/sp64-elf.h (DWARF_DEBUGGING_INFO, DWARF2_DEBUGGING_INFO):
	Don't undef, there is no need.
	* config/sparc/splet.h (CPP_PREDEFINES): Define.
	* config/sparc/sun4o3.h (CPP_PREDEFINES): Likewise.
	* config/sparc/sunos4.h (CPP_PREDEFINES): Likewise.
	Don't include sparc/sparc.h.
	* config/sparc/sysv4.h (WORD_SWITCH_TAKES_ARG, ASM_OUTPUT_SOURCE_LINE,
	SELECT_SECTION, ASM_DECLARE_FUNCTION_NAME, TEXT_SECTION_ASM_OP,
	DATA_SECTION_ASM_OP): Don't undef, there is no need now.  Don't include
	elfos.h and svr4.h.
	(TARGET_VERSION): Define.
	* config/sparc/vxsim.h (TARGET_VERSION): Define.

Wed Nov 14 19:46:08 CET 2001  Jan Hubicka  <jh@suse.cz>

	* cfglayout.c (fixup_fallthru_exit_predecesor): New static function.
	(cfg_layout_finalize): Use it.
	* bb-reorder.c (HAVE_epilogue): Remove.
	(make_reorder_chain): Do not care special placement of
	last basic block.

	* predict.c (expected_value_to_br_prob): Delete the note
	once transformed.

	* c-decl.c (c_expand_body): Fix TV_EXPAND nesting problem;
	measure integration time separately.

Wed Nov 14 12:30:57 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (struct temp_slot): ALIGN now unsigned.

2001-11-14  Kazu Hirata  <kazu@hxi.com>

	* config/dsp16xx/dsp16xx.c: Fix comment formatting.
	* config/dsp16xx/dsp16xx.h: Likewise.
	* config/dsp16xx/dsp16xx.md: Likewise.

2001-11-14  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (get_shift_alg): Reorganize the code
	that deals with 7-bit shifts in HImode.

Wed Nov 14 14:17:05 CET 2001  Jan Hubicka  <jh@suse.cz>

	* dbxout.c (dbxout_symbol_location): Update call of alter_subreg.
	* final.c (walk_alter_subreg): Take pointer; update call of alter_subreg.
	(final_scan_insn): Update call of alter_subreg.
	(cleanup_subreg_operands): Likewise.
	(alter_subreg): Rewrite using simplify_subreg.
	(output_address, output_operand): Update call of alter_subreg.
	* output.h (alter_subreg): Update prototype.
	* sdbout.c (sdbout_symbol): Update call of alter_subreg.
	* simplify-rtx.c (simplify_subreg): Copy ORIGINAL_REGNO.
	* Makefile.in (final.o): Add dependency on expr.h

Wed Nov 14 06:37:54 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* c-lang.c (finish_file): Make I unsigned to eliminate warning.

2001-11-13  Jeff Sturm  <jsturm@one-point.com>

	* doc/install.texi (sparc-*-linux*): Mention requirements for
	binutils and glibc.

2001-11-14  Joseph S. Myers  <jsm28@cam.ac.uk>

	* Makefile.in (POD2MAN): Don't include --section=1.
	(manext): Rename to man1ext.  All users changed.
	(man7ext): New.
	(man7dir): New.
	(generated-manpages): Also depend on $(docdir)/gfdl.7,
	$(docdir)/gpl.7, and $(docdir)/fsf-funding.7.
	($(docdir)/gcov.1, $(docdir)/cpp.1, $(docdir)/gcc.1): Include
	--section=1 in calls to $(POD2MAN).
	($(docdir)/gfdl.7, $(docdir)/gpl.7, $(docdir)/fsf-funding.7): New.
	(maintainer-clean, install, uninstall): Handle the new man pages.
	($(docdir)/cpp.info, cpp.dvi): Depend on fdl.texi.
	(installdirs): Create man7dir.
	* doc/cpp.texi: Include GFDL in this manual.  In the man page,
	refer to gfdl(7) for the GFDL.  Apply Front Cover and Back Cover
	texts to man page.  Include gpl(7), gfdl(7) and fsf-funding(7) in
	the SEE ALSO man page section.
	* doc/gcov.texi: Apply GFDL to man page.  Include gpl(7), gfdl(7)
	and fsf-funding(7) in the SEE ALSO man page section.
	* doc/invoke.texi: Apply GFDL to man page.  Include gpl(7),
	gfdl(7) and fsf-funding(7) in the SEE ALSO man page section.
	* doc/include/fdl.texi, doc/include/funding.texi,
	doc/include/gpl.texi: Adjust for conversion by texi2pod.pl.
	* doc/.cvsignore: Add gfdl.7, gpl.7 and fsf-funding.7.

2001-11-13  Richard Henderson  <rth@redhat.com>

	* dwarf2asm.c (dw2_force_const_mem): Set PUBLIC or STATIC
	as appropriate for the artificial decl.

2001-11-13  Richard Henderson  <rth@redhat.com>

	* loop.c (combine_movables): Turn off combination until
	move_movables validation bugs are fixed.

2001-11-13  DJ Delorie  <dj@redhat.com>

	* config.gcc (powerpc|rs6000): Set default cpp options based
	on --with-cpu settings.
	* config/rs6000/softfloat.h: New.

2001-11-13  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (shift_alg_si): Use special code for
	25-bit shifts on H8S.
	(get_shift_alg): Generate special code for 25-bit shifts on
	H8S.

2001-11-13  Jakub Jelinek  <jakub@redhat.com>

	* emit-rtl.c (adjust_address_1): Add ADJUST argument.
	(adjust_automodify_address_1): New.
	* expr.h (adjust_address, adjust_address_nv): Adjust.
	(adjust_automodify_address, adjust_automodify_address_nv): Define.
	(adjust_address_1): Update prototype.
	(adjust_automodify_address_1): Add prototype.
	* expr.c (move_by_pieces_1): Use adjust_automodify_address.
	(store_by_pieces_2): Likewise.

Tue Nov 13 05:45:40 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Makefile.in (explow.o): Now depends on ggc.h.
	* explow.c (ggc.h): Include.
	(set_stack_check_libfunc): Mark stack_check_libfunc as ggc root.

	* Makefile.in (expr.o): Depends on insn-attr.h.
	* expr.c (insn-attr.h): New include.
	(force_operand): If INSN_SCHEDULING, deal with paradoxical SUBREG
	of MEM.
	(highest_pow2_factor, case INTEGER_CST): Handle negative values.
	(expand_expr): Remove unneeded mark_temp_addr_taken calls and
	clean up related usage in ADDR_EXPR.
	(expand_expr_unaligned): Likewise.

	* emit-rtl.c (change_address): Fix typo in alias setting.

2001-11-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (cfgcleanup.o): Depend on insn-config.h

2001-11-12  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	PR bootstrap/3451
	* c-pragma.c: Rename macros BAD, BAD2, BAD_ACTION to
	GCC_BAD, GCC_BAD2, GCC_BAD_ACTION.

2001-11-12  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc (sparc-tti-*, sparc64-wrs-vxworks*, sparc-wrs-vxworks*,
	sparclite-wrs-vxworks*, sparc-*-aout*, sparc-*-netbsd*,
	sparc-*-chorusos*, sparc-*-linux*aout*, sparc-*-linux*libc1*,
	sparc-*-linux*, sparc-*-lynxos*, sparc-*-rtemsaout*, sparc-*-rtems*,
	sparc-*-rtemself*, sparc-*-solaris2*, sparc-*-sunos3*, sparc-*-sysv4*,
	sparc-*-vxsim*, sparclet-*-aout*, sparclite-*-coff*, sparclite-*-aout*,
	sparc86x-*-aout*, sparc86x-*-elf*, sparc64-*-aout*, sparc64-*-elf*,
	sparc64-*-linux*):  Include various CPU headers via tm_file.
	* config/svr3.h (ASM_OUTPUT_IDENT): Undef before defining it.
	(SELECT_SECTION): Likewise.
	(SELECT_RTX_SECTION): Likewise.
	* config/sparc/sparc_bi.h: New file.
	* config/sparc/aout.h: Don't include sparc/sparc.h and aoutos.h.
	* config/sparc/linux-aout.h: Likewise.
	* config/sparc/linux.h: Don't include sparc/sysv4.h.
	* config/sparc/linux64.h: Likewise.
	(SPARC_BI_ARCH): Don't define.  sparc_bi.h will do it instead.
	* config/sparc/lite.h:  Don't include sparc/sparc.h and gofast.h.
	* config/sparc/litecoff.h: Don't include sparc/lite.h, svr3.h,
	and dbxcoff.h
	(ASM_OUTPUT_IDENT): Do not #undef.
	(SELECT_SECTION): Likewise.
	(SELECT_RTX_SECTION): Likewise.
	* config/sparc/liteelf.h: Don't include gofast.h.
	* config/sparc/lynx-ng.h: Don't include sparc/sparc.h and lynx-ng.h.
	* config/sparc/lynx.h: Don't include sparc/sparc.h.
	* config/sparc/pbd.h: Likewise.
	* config/sparc/netbsd.h: Don't include sparc/sparc.h and netbsd.h.
	* config/sparc/rtems.h: Don't include sparc/aout.h and rtems.h.
	* config/sparc/rtemself.h: Don't include rtems.h.
	* config/sparc/sol2-64.h: Don't include sparc/sol2-sld-64.h.
	* config/sparc/sol2-sld-64.h (SPARC_BI_ARCH): Don't define, include
	sparc_bi.h instead.
	* config/sparc/sol2-sld.h: Don't include sparc/sol2.h.
	* config/sparc/sol2.h: Include sparc/sparc.h directly.
	* config/sparc/sp64-aout.h: Don't include sparc/sparc.h and aoutos.h.
	* config/sparc/sp64-elf.h: Don't include sparc/sol2.h.
	* config/sparc/sp86x-aout.h: Don't include sparc/sparc.h and gofast.h.
	* config/sparc/sp86x-elf.h: Don't include gofast.h.
	* config/sparc/splet.h: Don't include sparc/aout.h.
	* config/sparc/sun4o3.h: Don't include sparc/sparc.h.
	* config/sparc/sysv4.h: Don't include sparc/sparc.h directly.
	* config/sparc/vxsim.h: Don't include sparc/sysv4.h.
	* config/sparc/vxsparc.h: Don't include sparc/aout.h and gofast.h.
	* config/sparc/vxsparc64.h: Don't include gofast.h.
	(SPARC_BI_ARCH): Don't define.  sparc_bi.h will do it instead.

2001-11-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/standards.texi: Mention C99 TC1.

2001-11-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips-protos.h (mips_output_conditional_branch): Const-ify.
	* mips.c (mips_output_conditional_branch): Likewise.

2001-11-12  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (shift_alg_si): Use special code for
	15-bit logical shifts and 31-bit logical shifts.
	(get_shift_alg): Generate special code for 15-bit and 31-bit
	logical shifts.

2001-11-12  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (shift_alg_qi): Use rotations when
	doing 6-bit logical shifts on H8S.
	(shift_alg_qi): Use special code for 21-bit shifts on H8S.
	(get_shift_alg): Generate special code for 21-bit shifts on
	H8S.

2001-11-12  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (get_shift_alg): Remove a redundant
	label.

Mon Nov 12 11:58:26 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* alias.c (nonoverlapping_memrefs_p): Only update size from memref
	if both size and offset known.

2001-11-12  David O'Brien  <obrien@FreeBSD.org>

	* config/ia64/freebsd.h: Fix misspelling.

2001-11-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Move several chapters out to ...
	* doc/configterms.texi, doc/fragments.texi, doc/hostconfig.texi,
	doc/include/linux-and-gnu.texi, doc/interface.texi,
	doc/makefile.texi, doc/passes.texi, doc/portability.texi:
	... here.  New files.
	* doc/gcc.texi, doc/contrib.texi: Move section headings into
	contrib.texi.
	* Makefile.in ($(docdir)/gcc.info, gcc.dvi): Update dependencies.

2001-11-12  Kazu Hirata  <kazu@hxi.com>

	* config/alpha/alpha-interix.h: Fix comment formatting.
	* config/alpha/alpha.c: Likewise.
	* config/alpha/alpha.h: Likewise.
	* config/alpha/alpha32.h: Likewise.
	* config/alpha/freebsd.h: Likewise.
	* config/alpha/unicosmk.h: Likewise.
	* config/alpha/vms.h: Likewise.

2001-11-12  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (get_shift_alg): Remove redundant code.

2001-11-12  Jakub Jelinek  <jakub@redhat.com>

	* dbxout.c (dbxout_symbol_location): Avoid emitting invalid register
	numbers.

Mon Nov 12 05:18:42 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* emit-rtl.c (set_mem_attributes): If making object, can set alignment
	from type.
	(replace_equiv_address): Call update_temp_slot_address.

	* dwarf2out.c (loc_descriptor_from_tree, case COMPOUND_EXPR): New case.

	* alias.c (nonoverlapping_memrefs_p): Handle DECL_RTL being a CONCAT.

2001-11-12  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (shift_alg_qi): New.
	(shift_alg_hi): Likewise.
	(shift_alg_si): Likewise.
	(get_shift_alg): Change the type of count to unsigned int.
	Use the tables.

2001-11-11  Alexandre Oliva  <aoliva@redhat.com>

	* Makefile.in (c-lang.o): Depend on $(VARRAY_H).
	* c-decl.c (c_expand_body): Take argument can_defer_p.  Use it
	to decide whether to defer a function.
	(finish_function): Adjust.
	(c_expand_deferred_function): New function.
	* c-lang.c (deferred_fns): New variable.
	(c_init): Initialize it, and mark it as a root.
	(defer_fn): New function.
	(finish_file): Expand all deferred functions.
	* c-tree.h (defer_fn): Declare.
	(c_expand_deferred_function): Likewise.
	* objc/Make-lang.in (objc-act.o): Depend on $(VARRAY_H).
	* objc-act.c (deferred_fns): New variable.
	(objc_init): Initialize it, and mark it as a root.
	(defer_fn): New function.
	(finish_file): Expand all deferred functions.

2001-11-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.c (unicosmk_special_name): Prototype.
	(unicosmk_ssib_name): Delete unused variable.
	* alpha/unicosmk.h (common_section, ssib_section): Prototype.
	* alpha/vms.h (PREFIX): Undef before defining.
	* arm/pe.h (SUBTARGET_NAME_ENCODING_LENGTHS): Likewise.
	* i370/i370.c (mvs_hash_alias): Prototype.  Wrap with macro
	controlling usage.  Const-ify.
	(alias_number): Delete unused variable.
	* m32r/m32r.c (m32r_sched_init): Add missing argument.
	(m32r_expand_block_move): Fix uninitialized warnings.
	* mn10300/mn10300.h (REGNO_IN_RANGE_P): Fix 'unsigned >=0 is
	always true' warnings.
	* openbsd.h (TARGET_MEM_FUNCTIONS): Don't redefine.
	* sh/sh.c: Include "integrate.h".
	(output_far_jump): Fix uninitialized warning.
	* final.c (shorten_branches): Avoid automatic aggregate
	initialization.
	* integrate.c (subst_constants): Likewise.

2001-11-11  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (shift_alg): Remove SHIFT_MAX.
	(get_shift_alg): Remove redundant code.

2001-11-11  Kazu Hirata  <kazu@hxi.com>

	* config/pa/milli64.S: Fix comment formatting.
	* config/pa/pa-64.h: Likewise.
	* config/pa/pa-linux.h: Likewise.
	* config/pa/pa-protos.h: Likewise.
	* config/pa/pa.c: Likewise.
	* config/pa/pa.h: Likewise.
	* config/pa/pa32-linux.h: Likewise.
	* config/pa/pa32-regs.h: Likewise.
	* config/pa/pa64-hpux.h: Likewise.
	* config/pa/pa64-regs.h: Likewise.
	* config/pa/som.h: Likewise.

2001-11-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Move several chapters out to ...
	* doc/bugreport.texi, doc/contribute.texi, doc/frontends.texi,
	doc/service.texi, doc/standards.texi, doc/trouble.texi,
	doc/vms.texi: ... here.  New files.
	* Makefile.in ($(docdir)/gcc.info, gcc.dvi): Update dependencies.

2001-11-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* ChangeLog.2, ChangeLog.3, ChangeLog.4, ChangeLog.5, ChangeLog,
	cfg.c, cfganal.c, cfgcleanup.c, cfglayout.c, cfgloop.c, cfgrtl.c,
	collect2.c, combine.c, config.in, configure, configure.in,
	conflict.c, dwarf2out.c, dwarfout.c, except.c, final.c, flow.c,
	genattrtab.c, ggc-page.c, jump.c, lcm.c, predict.c, reg-stack.c,
	reload1.c, rtlanal.c, sched-rgn.c, toplev.c, unwind-dw2-fde.h: Fix
	spelling errors.

Sun Nov 11 05:56:01 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/rs6000/rs6000.c (rs6000_hash_constant, toc_hash_eq):
	Adjust operand number in CONST_DOUBLE.

	* expmed.c (extract_bit_field): No longer pass in alignment.
	(extract_fixed_bit_field, extract_split_bit_field): Likewise.
	(store_bit_field, store_fixed_bit_field, store_split_bit_field):
	Likewise.
	* expr.c (store_constructor, store_constructor_field): Likewise.
	(store_field, emit_group_load, emit_group_store): Likewise.
	* expr.h (emit_group_load, emit_group_store): Delete ALIGN parm.
	(store_bit_field, extract_bit_field): Likewise.
	* calls.c, expr.c, function.c: Change calls to above functions.
	* ifcvt.c, stmt.c: Likewise.

	* alias.c (nonoverlapping_memrefs_p): Not overlapping if one base is
	constant and one is on frame.
	If know memref offset, adjust size from decl.

2001-11-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha/unicosmk.h (ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT): Fix
	format specifier warning.
	* convex.h (ASM_OUTPUT_BYTE): Likewise.
	* elfos.h (ALIGN_ASM_OP): Undef before defining.
	* i386/att.h (ASM_GENERATE_INTERNAL_LABEL): Fix format specifier
	warning.
	* i386/bsd.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386/gas.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386-interix.h (gen_stdcall_suffix): Prototype.
	* i386.h (ASM_OUTPUT_BYTE): Fix format specifier warning.
	* i386elf.h (ASM_OUTPUT_FLOAT, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_LONG_DOUBLE): Likewise.
	* i386/interix.c (gen_stdcall_suffix): Const-ify.
	* i386/next.h (ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_FLOAT, ASM_GENERATE_INTERNAL_LABEL): Fix format
	specifier warnings.
	* i386/osfrose.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386/ptx4-i.h (ASM_OUTPUT_FLOAT, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_LONG_DOUBLE): Likewise.
	* i386/sco5.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386/sequent.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386/sun386.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386/svr3dbx.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* m68k/3b1.h (ASM_OUTPUT_DOUBLE, ASM_OUTPUT_LONG_DOUBLE,
	ASM_OUTPUT_FLOAT, ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* m68k/altos3068.h (ASM_OUTPUT_FLOAT_OPERAND): Likewise.
	* m68k/amix.h (ASM_OUTPUT_ASCII, ASM_GENERATE_INTERNAL_LABEL):
	Likewise.
	* m68k/atari.h (ASM_OUTPUT_ASCII, ASM_GENERATE_INTERNAL_LABEL):
	Likewise.
	* m68k/crds.h (ASM_OUTPUT_DOUBLE, PRINT_OPERAND): Likewise.
	* m68k/dpx2.h (ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_FLOAT, ASM_OUTPUT_BYTE, ASM_OUTPUT_FLOAT_OPERAND):
	Likewise.
	* m68k/hp320.h (ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_BYTE):
	Likewise.
	* m68k.h (ASM_GENERATE_INTERNAL_LABEL, ASM_OUTPUT_BYTE):
	Likewise.
	* m68k/m68kv4.h (ASM_OUTPUT_ASCII): Delete unused variable.
	* m68k/mot3300.h (ASM_OUTPUT_BYTE): Fix format specifier warning.
	* m68k/news.h (PRINT_OPERAND): Likewise.
	* m68k/next.h (ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT,
	ASM_OUTPUT_FLOAT_OPERAND, ASM_OUTPUT_DOUBLE_OPERAND): Likewise.
	* m68k/next21.h (ASM_OUTPUT_FLOAT_OPERAND): Likewise.
	* m68k/plexus.h (ASM_SPEC): Insert space between macro name and
	definition.
	* m68k/sgs.h (ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_FLOAT, ASM_OUTPUT_ASCII, ASM_OUTPUT_FLOAT_OPERAND,
	ASM_OUTPUT_DOUBLE_OPERAND): Fix format specifier warnings.
	* m68k/sun3.h (ASM_OUTPUT_FLOAT_OPERAND): Likewise.
	* m68k/tower-as.h (ASM_GENERATE_INTERNAL_LABEL, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_LONG_DOUBLE, ASM_OUTPUT_FLOAT, ASM_OUTPUT_BYTE,
	PRINT_OPERAND): Likewise.
	* m88k/m88k.h (ASM_GENERATE_INTERNAL_LABEL, ASM_OUTPUT_BYTE):
	Likewise.
	* mips/elf.h (PUT_SDB_SIZE, ASM_DECLARE_OBJECT_NAME): Likewise.
	* mips/elf64.h (PUT_SDB_SIZE, ASM_DECLARE_OBJECT_NAME): Likewise.
	* mips/iris5gas.h (PUT_SDB_SIZE): Likewise.
	* mips/linux.h (ASM_DECLARE_OBJECT_NAME): Likewise.
	* mips.c (mips_output_external_libcall): Mark parameter with
	ATTRIBUTE_UNUSED.
	(mips_asm_file_start): Move variable into the scope where it's
	used.
	* mips.h (PUT_SDB_INT_VAL, PUT_SDB_SIZE): Likewise.
	* mips/netbsd.h (ASM_DECLARE_OBJECT_NAME): Likewise.
	* mips/sni-gas.h (PUT_SDB_SIZE): Likewise.
	* ns32k/encore.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* ns32k.c (print_operand): Likewise.
	* pa.c (print_operand, output_div_insn): Likewise.
	* pa.h (ASM_OUTPUT_MI_THUNK, ASM_GENERATE_INTERNAL_LABEL,
	ASM_OUTPUT_BYTE, PRINT_OPERAND_ADDRESS): Likewise.
	* pa/pa64-hpux.h (UNIQUE_SECTION): Const-ify.
	* sparc/linux.h (ASM_GENERATE_INTERNAL_LABEL): Fix format
	specifier warnings.
	* sparc/linux64.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* sparc/pbd.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	(ASM_OUTPUT_SOURCE_LINE): Don't list macro arguments in undef.
	* sparc/vxsim.h (ASM_GENERATE_INTERNAL_LABEL): Fix format
	specifier warnings.
	* svr3.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.

	* sdbout.c (sdbout_end_epilogue): Mark parameter with
	ATTRIBUTE_UNUSED.
	* varasm.c (assemble_global): Likewise.

2001-11-11  H.J. Lu <hjl@gnu.org>

	* config.gcc: Add "elfos.h svr4.h" to $tm_file for Linux/mips.

Sun Nov 11 01:26:00 CET 2001  Jan Hubicka  <jh@suse.cz>

	* final.c (*_MAX_SKIP): Use *_max_skip variables.
	* flags.h (align_loops_max_skip, align_jumps_max_skip,
	align_labels_max_skip): New global variables.
	* toplev.c (align_loops_max_skip, align_jumps_max_skip,
	align_labels_max_skip): New global variables.
	(toplev_main): Set new variables.
	* i386.c (override_options): Set max_skip values.

2001-11-10  Geoffrey Keating  <geoffk@redhat.com>

	* doc/tm.texi (Label Output): Document ASM_OUTPUT_LABEL_REF.
	* final.c (output_addr_const): Use ASM_OUTPUT_LABEL_REF.
	* config/stormy16/stormy16.c (xstormy16_print_operand): For '%C',
	don't print an @fptr for labels either.
	(xstormy16_output_addr_vec): Don't print @fptr here.
	* config/stormy16/stormy16.h (ASM_OUTPUT_LABEL_REF): New macro.

Sat Nov 10 08:50:50 2001  Jeffrey A Law  (law@cygnus.com)

	* ssa-ccp.c (examine_flow_edges): Use old-style definition, not
	an ANSI/ISO definitino.
	(ssa_const_prop): Likewise.

2001-11-10  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (rs6000_reg_names): Remove leading "v" or
	altivec registers.

2001-11-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cppexp.c (parse_number): Use ISXDIGIT/hex_value.
	* cpplex.c (hex_digit_value): Use hex_p/hex_value.
	* cppmain.c (general_init): Call hex_init.
	* tradcif.y (parse_number): Use TOLOWER/ISXDIGIT/hex_value/hex_p.

	* config.gcc (i[34567]86-dg-dgux*): Don't set `out_file'.

	* i386/dgux.h (ASM_FILE_START): Set to the meaningful portions
	of dgux.c:output_file_start().

	* i386/dgux.c: Delete file.

2001-11-09  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (decl_in_text_section): New.
	(current_file_function_operand): Use it.
	(alpha_encode_section_info, alpha_end_function): Likewise.

2001-11-07  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc: Add FreeBSD/IA-64 target. Expand config/i64/elf.h headers.
	* config/i64/ia64.h (TARGET_VERSION,ASM_SPEC,LINK_SPEC): Remove,
	they are OS specific.  Use CPP_CPU_SPEC rather than CPP_PREDEFINES,
	so OS specific files and use CPP_PREDEFINES for their needs.
	* config/i64/elf.h (TARGET_VERSION): Add.  Also, move inclusion of
	target headers to tm_file.
	* config/ia64/aix.h (TARGET_VERSION): Likewise.
	* config/ia64/hpux.h (TARGET_VERSION): Likewise.
	* config/ia64/linux.h (TARGET_VERSION): Likewise.
	(FUNCTION_PROFILER): Remove.
	* config/ia64/ia64.h (FUNCTION_PROFILER): Update definition using the
	version in config/ia64/linux.h.
	* config/ia64/freebsd.h: New file.
	* config/freebsd.h: Tidy up.
	(_USING_CONFIG_FREEBSD): Define.
	(FBSD_CPP_PREDEFINES): Add __KPRINTF_ATTRIBUTE__.
	(FBSD_CPP_SPEC): Define generic FreeBSD spec.
	(FBSD_STARTFILE_SPEC): Likewise.
	(FBSD_ENDFILE_SPEC): Likewise.
	(FBSD_LIB_SPEC): Likewise.
	(WCHAR_UNSIGNED): Undefine, FreeBSD's wchars are signed.
	(USER_LABEL_PREFIX): Define to ELF compatible value as some CPU headers
	set an ELF-improper one.

2001-11-09  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c (emit_move_sequence): Use cint_ok_for_move to check whether a
	constant can be loaded in a single instruction to a register.  When
	loading immediate constants, use PLUS instead of HIGH/LO_SUM.  Use
	depdi for insertion of most significant 32-bits on 64-bit hosts.
	* pa.h (LEGITIMATE_CONSTANT_P): Accept constants that can be built
	with ldil/ldo/depdi instruction sequence on 64-bit hosts.
	* pa.md: New addmove pattern for adding constant_int to HImode
	register and moving result to HImode register.  Remove HImode HIGH
	and LO_SUM patterns.

2001-11-09  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Makefile.in: Update.
	* c-decl.c (print_lang_decl, print_lang_type): Remove.
	(print_lang_identifier): Rename c_print_identifier.
	* c-lang.c (LANG_HOOKS_PRINT_IDENTIFIER, LANG_HOOKS_SET_YYDEBUG): New.
	(print_lang_statistics, lang_print_xnode): Remove.
	* c-parse.in (set_yydebug): Rename c_set_yydebug.
	* c-tree.h (c_set_yydebug, c_print_identifier): New.
	* langhooks-def.h (lhd_print_tree_nothing, lhd_set_yydebug): New.
	LANG_HOOKS_PRINT_STATISTICS, LANG_HOOKS_PRINT_XNODE,
	LANG_HOOKS_PRINT_DECL, LANG_HOOKS_PRINT_TYPE,
	LANG_HOOKS_PRINT_IDENTIFIER, LANG_HOOKS_SET_YYDEBUG): New.
	(LANG_HOOKS_INITIALIZER): Update.
	* langhooks.h (struct lang_hooks): New members.
	(lang_print_tree_hook): New.
	* langhooks.c (lhd_print_tree_nothing, lhd_set_yydebug): New.
	* print-tree.c: Include langhooks.h.
	(print_node): Update.
	* toplev.c (decode_d_option): Update.
	* tree.c: Include langhooks.h.
	(dump_tree_statistics): Update.
	* tree.h (print_lang_statistics, print_lang_decl, print_lang_type,
	print_lang_identifier, set_yydebug, lang_print_xnode): Remove.
objc:
	* objc-act.c (LANG_HOOKS_PRINT_IDENTIFIER,
	LANG_HOOKS_SET_YYDEBUG): Override.
	(lang_print_xnode, print_lang_statistics): Remove.

2001-11-09  Richard Henderson  <rth@redhat.com>

	* dwarf2asm.c (dw2_force_const_mem): Invoke STRIP_NAME_ENCODING
	on the symbol string.

2001-11-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* pa/elf.h (ASM_DECLARE_FUNCTION_NAME,
	ASM_OUTPUT_EXTERNAL_LIBCALL): Undef before defining.
	* config.gcc (hppa1.1-*-rtems*): Remove duplicate clause.

	* clipper.h (ASM_OUTPUT_REG_POP): Fix typo.

	* tlink.c (recompile_files): Copy strings passed to `putenv'.

2001-11-09  Geoffrey Keating  <geoffk@redhat.com>

	* tree.h (TYPE_VOLATILE): Trap use not on TYPEs.
	(TYPE_READONLY): Likewise.

	* flow.c (insn_dead_p): Allow for AUTO_INC notes all the time.

	* config/stormy16/stormy16.h (ASM_SPEC): Revert last change,
	don't pass --gdwarf2 to the assembler if the compiler will also
	provide debug info.

	* config/stormy16/stormy16.c (xstormy16_expand_casesi):
	Don't change INDEX.

Fri Nov  9 17:51:09 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* alias.c (nonoverlapping_memrefs_p): New function.
	(true_dependence, canon_true_depenence, write_dependence_p): Call it.

	* emit-rtl.c (set_mem_attributes): Get alignments for constants.

2001-11-09  Aldy Hernandez  <aldyh@redhat.com>

	* rs6000.h (REG_CLASS_CONTENTS): Add VRSAVE bit to ALL_REGS.
	(CONDITIONAL_REGISTER_USAGE): Disable AltiVec registers unless
	generating altivec code.
	(FIXED_REGISTERS): VRSAVE is fixed.
	(CALL_USED_REGISTERS): VRSAVE is call used.

2001-11-09  Jason Eckhardt  <jle@rice.edu>

	* config/mips/mips.c (mips_output_conditional_branch): Do not hard
	code the branch target as ".+16/.+12", but rather use labels.

Fri Nov  9 11:27:42 2001  Jeffrey A Law  (law@cygnus.com)

	* config/pa/milli64.S: Use %r25 and %r0 instead of arg1 and r0
	to work around limitations of certain versions of GAS.

	* pa.md (mulsi3): Remove PA64 hack to work around SUBREG issues.
	(muldi3): Update due to SUBREG_BYTE changes.
	(casesi): Similarly.

2001-11-09  Zack Weinberg  <zack@codesourcery.com>

	* doc/invoke.texi: Remove comment referring to -xf77-version.

2001-11-09  Kazu Hirata  <kazu@hxi.com>

	* config/convex/convex.c: Fix comment formatting.
	* config/convex/convex.h: Likewise.

2001-11-08  Zack Weinberg  <zack@codesourcery.com>

	* Makefile.in (.po.pox): Look both in srcdir and builddir
	for $(PACKAGE).pot.
	(po/$(PACKAGE).pot): Don't move-if-change the new potfile over
	to the source directory.

2001-11-09 Ben Elliston  <bje@redhat.com>
	   Michael Meissner  <meissner@redhat.com>
	   Andrew MacLeod  <amacleod@redhat.com>
	   Richard Henderson  <rth@redhat.com>
	   Nick Clifton  <nickc@redhat.com>
	   Catherine Moore  <clm@redhat.com>

	* m32r.c: Add support for m32rx processor.
	* m32r.h: Ditto.
	* m32r.md: Ditto.
	* t-m32r: Ditto.
	* m32r-protos.h: Add prototypes for m32rx functions.
	* doc/invoke.texi: Document -m32rx option.

2001-11-09  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (movdf): Avoid calling validize_mem during
	or after reload.

2001-11-09  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi2html: Use $MAKEINFO --no-split.

2001-11-09  Andreas Schwab  <schwab@suse.de>

	* Makefile.in ($(HOST_PREFIX_1)rtl.o,
	$(HOST_PREFIX_1)print-rtl.o, $(HOST_PREFIX_1)bitmap.o,
	$(HOST_PREFIX_1)vfprintf.o, $(HOST_PREFIX_1)doprint.o,
	$(HOST_PREFIX_1)strstr.o, $(HOST_PREFIX_1)errors.o,
	$(HOST_PREFIX_1)ggc-none.o): Update dependencies.

2001-11-09  H.J. Lu <hjl@gnu.org>

	* config/mips/mips.c (mips_output_function_prologues): Cast
	`tsize' to long for output.

2001-11-09  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lang.c (LANG_HOOKS_NAME): New.
	(lang_hooks): Constify.
	(c_init_options): Update.
	(lang_identify): Remove.
	* c-parse.in (language_string): Remove.
	* dbxout.c: Include langhooks.h.
	(dbxout_symbol_location): Update.
	* dwarf2out.c: Include langhooks.h.
	(gen_compile_unit_die): Update.
	* dwarfout.c: Include langhooks.h.
	(prototyped_attribute, output_compile_unit_die): Update.
	* langhooks-def.h (LANG_HOOKS_NAME, LANG_HOOKS_IDENTIFIER_SIZE): New.
	(LANG_HOOKS_INITIALIZER): Update.
	* langhooks.h (struct lang_hooks): New members.  Constify.
	* stringpool.c: Don't include toplev.h.
	(set_identifier_size): Remove.
	* toplev.c (toplev_main): Initialize identifier size.
	(print_version): Update.
	* tree.h (language_string, init_lex, lang_identify,
	set_identifier_size): Remove.
	* Makefile.in: Update dependencies.
	* config/darwin.c: Include langhooks.h.
	(func_name_maybe_scoped): Update.
	* config/darwin.h (ASM_END_FILE): Update.
	* config/nextstep.h (ASM_END_FILE): Update.
	* config/nextstep21.h (ASM_END_FILE): Update.
	* config/i386/sun386.h (ASM_END_FILE): Update.
	* config/rs6000/rs6000.c (ASM_END_FILE): Include langhooks.h.
	(rs6000_output_function_epilogue): Update.
objc:
	* objc-act.c (LANG_HOOKS_NAME): Override.
	(struct lang_hooks): Constify.
	(objc_init_options): Update.
	(lang_identify): Remove.

Fri Nov  9 00:25:18 EST 2001  John Wehle  (john@feith.com)

	* fold-const.c (lshift_double): Honor PREC.
	(rshift_double): Likewise.

2001-11-08  Kazu Hirata  <kazu@hxi.com>

	* config/1750a/1750a.c: Fix comment formatting.
	* config/1750a/1750a.h: Likewise.

2001-11-08  Phil Edwards  <pedwards@disaster.jaj.com>

	* configure.in (--enable-languages): Be more permissive about
	syntax.  Check for empty lists better.  Warn about $LANGUAGES.
	* configure: Regenerated.

2001-11-08  Richard Henderson  <rth@redhat.com>

	* dwarf2asm.c (dw2_force_const_mem): Fix typo.

2001-11-08  Geoffrey Keating  <geoffk@redhat.com>

	* config.gcc: Rename stormy16 to xstormy16.
	* config/stormy16/stormy-abi: Likewise.
	* config/stormy16/stormy16-protos.h: Likewise.
	* config/stormy16/stormy16.c: Likewise.
	* config/stormy16/stormy16.h: Likewise.
	* config/stormy16/stormy16.md: Likewise.

2001-11-06  Geoffrey Keating  <geoffk@redhat.com>

	* tree.h (TYPE_VOLATILE): Add enable-checking code.
	(TYPE_READONLY): Likewise.

Thu Nov  8 18:00:55 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* reload1.c (reload): Don't delete equiv insn if can throw.

	* expr.c (emit_block_move): If X is readonly emit CLOBBER for it.
	(clear_storage): Likewise, for OBJECT.

Thu Nov  8 16:23:51 2001  Jeffrey A Law  (law@cygnus.com)

	* pa.c (emit_move_sequence): Fix SUBREG expression to
	use proper byte offset when extending a constant from
	SImode to DImode.

2001-11-09  Jakub Jelinek  <jakub@redhat.com>

	* cfgrtl.c (purge_dead_edges): Remove REG_EH_REGION note for insns
	which cannot throw.

Thu Nov  8 18:00:55 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* explow.c (convert_memory_address, case SUBREG): Only return
	inner object if SUBREG_PROMOTED_VAR_P or known to be pointer.

2001-11-08  Richard Henderson  <rth@redhat.com>

	* Makefile.in (GCC_FOR_TARGET): Add build_tooldir/sys-include.
	(CROSS_SYSTEM_HEADER_DIR): Use build_tooldir not tooldir.
	(ORDINARY_FLAGS_TO_PASS, stmp-fixinc): Likewise.

2001-11-08  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (ASM_CPU_SPEC): Add -maltivec.

2001-11-08  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (debug_str_hash): New.
	(struct indirect_string_node): New.
	(struct dw_val_struct): Change type of val_str to it.
	(DEBUG_STR_SECTION_FLAGS): Define.
	(add_AT_string): Push string into hashtable, increment reference
	counter.
	(AT_string): Return string from ht_identifier.
	(AT_string_form): New.
	(free_AT): For dw_val_class_str, just decrement reference counter.
	(size_of_string): Remove.
	(size_of_die): Use AT_string_form to decide what size the string
	occupies in DIE.
	(size_of_pubnames): Use strlen instead of size_of_string.
	(value_format): Use AT_string_form for dw_val_class_str.
	(output_die): Output DW_FORM_strp strings using
	dw2_asm_output_offset.
	(indirect_string_alloc, output_indirect_string): New.
	(dwarf2out_finish): Emit .debug_str strings if there are any.

2001-11-08  Andreas Franck  <afranck@gmx.de>

	* configure.in: Add AC_ARG_PROGRAM to support program name
	transformation with --program-prefix, --program-suffix and
	--program-transform-name.
	* configure: Regenerated.
	* Makefile.in (GCC_INSTALL_NAME, CPP_INSTALL_NAME,
	PROTOIZE_INSTALL_NAME, UNPROTOIZE_INSTALL_NAME, GCOV_INSTALL_NAME,
	GCCBUG_INSTALL_NAME, GCC_CROSS_NAME, CPP_CROSS_NAME,
	PROTOIZE_CROSS_NAME, UNPROTOIZE_CROSS_NAME): Handle
	program_transform_name the way suggested by autoconf.
	(GCC_TARGET_INSTALL_NAME): Define.
	(install-driver): Use the transformed target alias name.

2001-11-08  Richard Henderson  <rth@redhat.com>

	* config/mips/mips.c (save_restore_insns): Remove GP from the
	restore registers mask early instead of special casing it inside
	the loop.

2001-11-08  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cp/decl.c (shadow_warning): New function.
	(pushdecl): Improve -Wshadow warnings.  Don't give both a warning
	and an error when a block scope decl shadows a parameter.

2001-11-08  Richard Henderson  <rth@redhat.com>

	* config/fp-bit.h (usi_to_float): Define for US_SOFTWARE_GOFAST
	case as well.

2001-11-08  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.md (negdf2, negsf2): Use multiplication rather than subtraction
	to implement floating negation on processors prior to PA 2.0.

2001-11-08  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2asm.c (mark_indirect_pool_entry, mark_indirect_pool): New.
	(USE_LINKONCE_INDIRECT): Define.
	(dw2_output_indirect_constant_1): Try to output indirect constants
	into linkonce sections if possible.
	(dw2_force_const_mem): Likewise.  Register indirect_pool with GGC.
	(dw2_output_indirect_constants): Likewise.

2001-11-07  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (REG_ALLOC_ORDER): Add vrsave.

2001-11-07  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-decl.c (pushdecl): Remove file and line.
	* c-typeck.c (pop_init_level): Remove size.

2001-11-07  Aldy Hernandez  <aldyh@redhat.com>

	* doc/invoke.texi: Add -maltivec, -mno-altivec, and -mabi=altivec
	for rs6000.

	* config/rs6000/rs6000.h (MASK_ALTIVEC): New.
	(TARGET_ALTIVEC): New.
	(TARGET_SWITCHES): Add altivec.
	(FIRST_PSEUDO_REGISTER): Change to 109.
	(CALL_USED_REGISTERS): Same.
	(FIRST_ALTIVEC_REGNO): New.
	(LAST_ALTIVEC_REGNO): New.
	(ALTIVEC_REGNO_P): New.
	(UNITS_PER_ALTIVEC_WORD): New.
	(ALTIVEC_VECTOR_MODE): New.
	(FIXED_REGISTERS): Add altivec registers.
	(REG_ALLOC_ORDER): Same.
	(HARD_REGNO_NREGS): Adjust for altivec registers.
	(HARD_REGNO_MODE_OK): Same.
	(MODES_TIEABLE_P): Same.
	(REGISTER_MOVE_COST): Same.
	(REGNO_REG_CLASS): Same.
	(reg_class): Add ALTIVEC_REGS.
	(REG_CLASS_NAMES): Same.
	(REG_CLASS_CONTENTS): Same.
	(REG_CLASS_FROM_LETTER): Add 'v' constraint for ALTIVEC_REGS.
	(ALTIVEC_ARG_RETURN): New.
	(FUNCTION_VALUE): Handle VECTOR_TYPE.
	(LIBCALL_VALUE): Handle altivec vector modes.
	(VECTOR_MODE_SUPPORTED_P): New.
	(ALTIVEC_ARG_MIN_REG): New.
	(ALTIVEC_ARG_MAX_REG): New.
	(ALTIVEC_ARG_NUM_REG): New.
	(FUNCTION_VALUE_REGNO_P): Return true for altivec return register.
	(FUNCTION_ARG_REGNO_P): Support passing args in altivec registers.
	(REGISTER_NAMES): Add altivec regs.
	(DEBUG_REGISTER_NAMES): Same.
	(ADDITIONAL_REGISTER_NAMES): Same.
	(rs6000_builtins): New.
	(MD_EXPAND_BUILTIN): New.
	(MD_INIT_BUILTINS): New.
	(LEGITIMATE_OFFSET_ADDRESS_P): This addressing mode is not valid
	for AltiVec instructions.
	(LEGITIMATE_LO_SUM_ADDRESS_P): Same.
	(HARD_REGNO_MODE_OK): Altivec modes can only go in altivec
	registers.
	(SECONDARY_MEMORY_NEEDED): We need memory to copy vector modes.
	(TARGET_SWITCHES): Add no-altivec.
	(DATA_ALIGNMENT): Align vectors to 128 bits.
	(TARGET_OPTIONS): Add abi= option.
	Add rs6000_abi_string extern.
	(LOCAL_ALIGNMENT): New.
	(CPP_CPU_SPEC): Define __ALTIVEC__ when -maltivec.
	(MASK_ALTIVEC_ABI): New.
	(TARGET_ALTIVEC_ABI): New.
	(CONDITIONAL_REGISTER_USAGE): Set first 20 AltiVec registers to
	call-saved.
	(STACK_BOUNDARY): Adjust for altivec.
	(BIGGEST_ALIGNMENT): Same.
	(rs6000_args): Add vregno.
	(USE_ALTIVEC_FOR_ARG_P): New.
	(FIXED_REGISTERS): Add vrsave register.
	(CALL_USED_REGISTERS): Same.
	(CONDITIONAL_REGISTER_USAGE): Set VRSAVE info.
	(VRSAVE_REGNO): New.
	(reg_class): Add VRSAVE_REGS.
	(REG_CLASS_NAMES): Same.
	(REG_CLASS_CONTENTS): Same.
	(REGNO_REG_CLASS): Same.

	* config/rs6000/sysv4.h (STACK_BOUNDARY): Adjust for altivec.
	(ABI_STACK_BOUNDARY): Same.
	(BIGGEST_ALIGNMENT): Same.
	(ADJUST_FIELD_ALIGN): Remove undef.  Define anew.
	(ROUND_TYPE_ALIGN): Same.

	* config/rs6000/aix.h (ROUND_TYPE_ALIGN): Change BIGGEST_ALIGNMENT
	to 64.

	* config/rs6000/darwin.h (ROUND_TYPE_ALIGN): Change BIGGEST_ALIGNMENT
	to 64.

	* config/rs6000/darwin.h (ROUND_TYPE_ALIGN): Change BIGGEST_ALIGNMENT
	to 64.

	* config/rs6000/rs6000.c (rs6000_expand_builtin): New.
	(altivec_expand_builtin): New.
	(altivec_init_builtins): New.
	(TARGET_EXPAND_BUILTIN): New.
	(TARGET_INIT_BUILTINS): New.
	(rs6000_init_builtins): New.
	(struct builtin_description): New.
	(bdesc_2arg): New.
	(rs6000_reg_names): Add altivec registers.
	(alt_reg_names): Same.
	(secondary_reload_class): Altivec regs can hold altivec regs and
	memory.
	(rs6000_emit_move): Force constants into memory for AltiVec moves.
	(print_operand): Add 'y' case for printing altivec memory
	operands.
	(rs6000_legitimize_address): Legitimize vector addresses into
	[REG+REG] or [REG].
	(altivec_expand_binop_builtin): New.
	New string rs6000_current_abi.
	(rs6000_override_options): Call rs6000_parse_abi_options.
	(rs6000_parse_abi_options): New.
	(function_arg_boundary): Vector arguments must be 16
	byte aligned.
	(function_arg_advance): Handle vector arguments.
	(function_arg_partial_nregs): Same.
	(init_cumulative_args): Same.
	(function_arg): Same.

	* config/rs6000/rs6000.md (altivec_lvx): New.
	(type): Add altivec attribute.
	(movv4si): New.
	(*movv4si_internal): New.
	(movv16qi): New.
	(*movv16qi_internal): New.
	(movv8hi): New.
	(*movv8hi_internal1): New.
	(movv4sf): New.
	(*movv4sf_internal1): New.
	(altivec_stvx): New.
	(vaddubm): New.
	(vadduhm): New.
	(vadduwm): New.
	(vaddfp): New.
	(vaddcuw): New.
	(vaddubs): New.
	(vaddsbs): New.
	(vadduhs): New.
	(vaddshs): New.
	(vadduws): New.
	(vaddsws): New.
	(vand): New.
	(vandc): New.
	(vavgub): New.
	(vavgsb): New.
	(vavguh): New.
	(vavgsh): New.
	(vavguw): New.
	(vavgsw): New.
	(vcmpbfp): New.
	(vcmpequb): New.
	(vcmpequh): New.
	(vcmpequw): New.
	(vcmpeqfp): New.
	(vcmpgefp): New.
	(vcmpgtub): New.
	(vcmpgtsb): New.
	(vcmpgtuh): New.
	(vcmpgtsh): New.
	(vcmpgtuw): New.
	(vcmpgtsw): New.
	(vcmpgtfp): New.
	(vcmpgefp): New.
	(vcmpgtub): New.
	(vcmpgtsb): New.
	(vcmpgtuh): New.
	(vcmpgtsh): New.
	(vcmpgtuw): New.
	(vcmpgtsw): New.
	(vcmpgtfp): New.
	(vmaxub): New.
	(vmaxsb): New.
	(vmaxuh): New.
	(vmaxsh): New.
	(vmaxuw): New.
	(vmaxsw): New.
	(vmaxfp): New.
	(vmrghb): New.
	(vmrghh): New.
	(vmrghw): New.
	(vmrglb): New.
	(vmrglh): New.
	(vmrglw): New.
	(vminub): New.
	(vminsb): New.
	(vminuh): New.
	(vminsh): New.
	(vminuw): New.
	(vminsw): New.
	(vminfp): New.
	(vmuleub): New.
	(vmulesb): New.
	(vmuleuh): New.
	(vmulesh): New.
	(vmuloub): New.
	(vmulosb): New.
	(vmulouh): New.
	(vmulosh): New.
	(vnor): New.
	(vor): New.
	(vpkuhum): New.
	(vpkuwum): New.
	(vpkpx): New.
	(vpkuhss): New.
	(vpkshss): New.
	(vpkuwss): New.
	(vpkswss): New.
	(vpkuhus): New.
	(vpkshus): New.
	(vpkuwus): New.
	(vpkswus): New.
	(vrlb): New.
	(vrlh): New.
	(vrlw): New.
	(vslb): New.
	(vslh): New.
	(vslw): New.
	(vsl): New.
	(vslo): New.
	(vsrb): New.
	(vrsh): New.
	(vrsw): New.
	(vsrab): New.
	(vsrah): New.
	(vsraw): New.
	(vsr): New.
	(vsro): New.
	(vsububm): New.
	(vsubuhm): New.
	(vsubuwm): New.
	(vsubfp): New.
	(vsubcuw): New.
	(vsububs): New.
	(vsubsbs): New.
	(vsubuhs): New.
	(vsubshs): New.
	(vsubuws): New.
	(vsubsws): New.
	(vsum4ubs): New.
	(vsum4sbs): New.
	(vsum4shs): New.
	(vsum2sws): New.
	(vsumsws): New.
	(vxor): New.

2001-11-07  Daniel Berlin  <dan@cgsoftware.com>

	* Makefile.in (df.o): Add fibheap.h to dependencies.

	* df.h: Add prototypes for transfer functions, iterative_dataflow
	functions.
	(enum df_flow_dir): New enum.
	(enum df_confluence_op): New enum.
	(struct df): Add inverse_rts_map.

	* df.c: Add sbitmap.h to the list of includes.
	(df_rd_global_compute): Removed.
	(df_ru_global_compute): Removed.
	(df_lr_global_compute): Removed.
	(df_rd_transfer_function): New function.
	(df_ru_transfer_function): New function.
	(df_lr_transfer_function): New function.
	(df_analyse_1): allocate/compute/free df->inverse_rts_map.
	Use iterative_dataflow_bitmap instead of df_*_global_compute.
	(iterative_dataflow_sbitmap): New function.
	(iterative_dataflow_bitmap): New function.

2001-11-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Move terminology and spelling conventions to
	htdocs/codingconventions.html.

2001-11-07  Graham Stott  <grahams@redhat.com>

	* cse.c (cse_insn): Emit BARRIER after unconditional jump.

Wed Nov  7 13:33:34 CET 2001  Jan Hubicka  <jh@suse.cz>

	* expmed.c (expand_mult): Force operand to register before computing
	cost.
	* i386.c (x86_decompose_lea): New global vairable.
	* i386.h (x86_decompose_lea): Declare.
	(TARGET_DECOMPOSE_LEA): New macro.
	(RTX_COST): Handle leas properly.

2001-11-06  Richard Henderson  <rth@redhat.com>

	* config/alpha/elf.h (DO_SELECT_SECTION): TREE_READONLY is not
	defined for a CONSTRUCTOR; don't check it.

2001-11-06  Danny Smith  <dannysmith@users.sourceforge.net>

	* gcov.c (output_data): Use IS_ABSOLUTE_PATHNAME to
	test for absolute pathnames.

2001-11-06  Olivier Hainque <hainque@act-europe.fr>

	* unwind-dw2.c (execute_cfa_program): Evaluate call frame
	instructions up to the target pc inclusive.

2001-11-06  Steve Christiansen  <smc@us.ibm.com>

	* loop.c (loop_regs_scan):  Don't invalidate PIC register.

2001-11-06  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.md(movdf_internal2): Add constraints for float
	to general register move.
	* config/mips/elf64.h: Add default ABI.

2001-11-06  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* alias.c:: Include langhooks.h.
	* emit-rtl.c: Similarly.
	* toplev.c: Similarly.
	* tree-inline.c: Similarly.
	* langhooks-def.h: New, the old langhooks.h.  Give the default
	hooks a common prefix.
	* langhooks.h: Contents extracted from toplev.h.
	* toplev.h: Move langhook stuff to langhooks.h.
	* langhooks.c: Give default hooks a common prefix.

	* c-lang.c: Include langhooks-def.h.
	* objc/objc-act.c: Similarly.
	* Makefile.in: Update.
	* objc/Make-lang.in: Update.

2001-11-06  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi: Document that configure options not listed in
	this file are unsupported.  Document --with-system-zlib.

Tue Nov  6 09:21:34 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* rtl.h (mem_for_const_double): New declaration.
	* varasm.c (mem_for_const_double): New function.
	* config/convex/convex.md (movdf): Use it.
	* config/m68k/hp320.h (LEGITIMATE_PIC_OPERAND_P): Likewise.
	* config/m68k/linux.h, config/m68k/m68k.h: Likewise.
	* config/m68k/m68kv4.h: Likewise.

	* config/alpha/alpha.h (SECONDARY_MEMORY_NEEDED): Adjust for addition
	of new GP reg classes.

	* expr.c (store_field): When making temp object for unaligned
	component, set it to alias set 0.

2001-11-06  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (c_expand_expr_stmt): Apply default conversions to
	non-lvalue arrays if C99.
	* c-typeck.c (default_conversion): Split out code handling
	array-to-pointer and function-to-pointer conversions into a
	separate default_function_array_conversion function.
	(default_function_array_conversion): New function.  Keep track of
	whether any NON_LVALUE_EXPRs were stripped.  Return non-lvalue
	arrays unchanged outside C99 mode instead of giving an error for
	them.
	(build_component_ref): Use pedantic_non_lvalue when handling
	COMPOUND_EXPR.  Don't handle COND_EXPR specially.
	(convert_arguments): Use default_function_array_conversion.
	(build_unary_op): For ADDR_EXPR, take a flag indicating whether
	non-lvalues are OK.
	(unary_complex_lvalue): Likewise.
	(internal_build_compound_expr): Use
	default_function_array_conversion.  Apply default conversions to
	function in compound expression.
	(build_c_cast, build_modify_expr, digest_init, build_asm_stmt):
	Use default_function_array_conversion.
	* doc/extend.texi: Update documentation of subscripting non-lvalue
	arrays.
	Fixes PR c/461.

2001-11-05  Zack Weinberg  <zack@codesourcery.com>

	* aclocal.m4: (AM_WITH_NLS): Don't look at ALL_LINGUAS.
	(AM_GNU_GETTEXT): Set CATALOGS to a list of .gmo files
	corresponding to the complete set of .po and .gmo files in
	the source directory's po subdir, modified by LINGUAS.  Don't
	look at ALL_LINGUAS.
	* configure.in: Don't set ALL_LINGUAS.
	* configure: Regenerate.

	* Makefile.in (.po.gmo): Don't move into source directory.
	(.po.pox): Clarify comments.
	(install-po): Look for .gmo files in both srcdir and objdir;
	don't fail if a file is totally missing.
	(distclean): rmdir ada subdirectory too.

2001-11-05  Geoffrey Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.c (rs6000_select_section): Handle
	CONSTRUCTORs _correctly_.

2001-11-05  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* c-decl.c (delete_block): Remove.
	* c-tree.h (delete_block): Remove.

2001-11-05  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* cppexp.c (lex, parse_defined): Update warning about defined.

2001-11-05  Geoffrey Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.c (rs6000_select_section): Handle
	CONSTRUCTORs too.

2001-11-05  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (arm_return_in_memory): Cope with
	int_size_in_bytes returning -1.

	* config/arm/unknown-elf.h (ASM_OUTPUT_ALIGNED_DECL_LOCAL): Handle
	DECL being NULL.

Mon Nov  5 16:15:25 CET 2001  Jan Hubicka  <jh@suse.cz>

	* Makefile.in (bb-reorder.o): Add dependency on cfglayout.h;
	remove unneeded dependencies;
	(cfglayout.o): New.
	* cfglayout.c, cfglayout.h: New files; break out from ...
	* bb-reorder.c: ... here; Remove unneeded includes;

2001-11-04  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.md (load_toc_aix_{si,di}): Mark r2 as used.

2001-11-04  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_emit_move): Handle 64-bit
	mode as well.  Do not explicitly create intermediate regs.

2001-11-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* arm/aof.h (aof_text_section, aof_data_section): Don't declare.
	(common_section): Delete unused variable.
	(ASM_OUTPUT_ASCII): Fix signed/unsigned warnings.
	(ASM_GENERATE_INTERNAL_LABEL): Fix format specifier warning.
	* arm-protos.h (arm_poke_function_name, aof_add_import,
	aof_delete_import): Const-ify.
	* arm.c (legitimize_pic_address): Wrap variables in the macro
	controlling their usage.
	(arm_finalize_pic): Mark variable with ATTRIBUTE_UNUSED.
	(arm_poke_function_name, pic_chain, import, aof_add_import,
	aof_delete_import): Const-ify.
	* i386.c (ix86_osf_output_function_prologue): Const-ify.
	* i386/sysv4.h (ASM_OUTPUT_FLOAT, ASM_OUTPUT_DOUBLE,
	ASM_OUTPUT_LONG_DOUBLE): Fix format specifier warnings.
	* i860/fx2800.h (DBX_OUTPUT_STANDARD_TYPES): Const-ify.
	* i860/sysv3.h: Add missing comment closure.
	* m68k/apollo68.h (ASM_RETURN_CASE_JUMP): Add missing semi-colon.
	* m88k/dgux.h (SELECT_RTX_SECTION): Add missing argument in call
	to symbolic_operand.

	* config.gcc (m680[02]0-*-*): Rename case from m68000-*-*.
	(i960-*-*): Set tmake_file.
	(sparc86x-*-elf*): Fix typo in header name.

	* sched-rgn.c (schedule_insns): Delete unused variable.

2001-11-04  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	PR c/2820
	* c-typeck.c (lookup_field): Rework to return a chain down to
	the looked-up field.
	(build_component_ref): Use the new lookup_field to handle
	nested anonymous entities correctly.

Sun Nov  4 11:53:31 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/sparc/sparc.c (sparc_emit_set_const32, GEN_HIGHINT64):
	Change parameters to gen_rtx_CONST_DOUBLE.
	(GEN_INT64, sparc_emit_set_const64): Likewise.
	* config/sparc/sparc.md (movdf split): Likewise.

2001-11-03  Geoffrey Keating  <geoffk@redhat.com>

	* unroll.c (calculate_giv_inc): Use find_last_value rather
	than just hoping the last instruction is the right SET.
	[Fixes 990604-1.c on stormy16.]

	* config/stormy16/stormy16.h (LIB_SPEC): Don't supply any libgloss
	library at all if -T is used.

	* config/stormy16/stormy16.c (stormy16_print_operand): Avoid
	some uses of uninitialized variables in error cases.

	* config/stormy16/stormy16.c (stormy16_output_shift): Don't
	look at 'temp' if we won't be using it.

	* config/stormy16/stormy16.h (CONST_COSTS): Define.
	(RTX_COSTS): Define.
	(ADDRESS_COST): Define.
	(MEMORY_MOVE_COST): Allow for memory_move_secondary_cost.

	* config/stormy16/stormy16.h (ASM_SPEC): Pass -g to the assembler.

	* config/stormy16/stormy16.h (ASM_OUTPUT_MI_THUNK): Call
	stormy16_asm_output_mi_thunk.
	* config/stormy16/stormy16.c (stormy16_asm_output_mi_thunk): New
	function.
	* config/stormy16/stormy16-protos.h
	(stormy16_asm_output_mi_thunk): New prototype.

2001-11-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* ChangeLog.2, ChangeLog.4, ChangeLog.5, ChangeLog,
	FSFChangeLog.10, FSFChangeLog.11, alias.c, attribs.c,
	caller-save.c, calls.c, cfg.c, cfganal.c, cfgcleanup.c, cfgrtl.c,
	cppmacro.c, fold-const.c, ifcvt.c, local-alloc.c, profile.c,
	sched-int.h, toplev.c, config/alpha/alpha.c,
	config/alpha/alpha.md, config/c4x/c4x.h, config/cris/cris.h,
	config/cris/cris.md, config/i370/i370.md, config/i386/i386.c,
	config/i386/i386.h, config/i386/i386.md, config/i386/xm-djgpp.h,
